#!/usr/bin/python
# gtkrawgallery.py: entry point of GTKRawGallery
# author:(c) 2007 Daniele Isca <bit123@users.sourceforge.net>
# license:GNU GPL
# version: 0.6

import gtk,gtk.glade,pygtk,glob,math,os,os.path,gobject,cPickle,sys,string,gc,shutil,time,commands,thread,threading,pango
import exif

if gtk.gtk_version < (2, 10, 0):
	sys.stderr.write("GTKRawGallery requires GTK+ 2.10.0 or newer..\n")
	sys.exit(1)
if gtk.pygtk_version < (2, 10, 0):
	sys.stderr.write("GTKRawGallery requires PyGTK 2.10.0 or newer.\n")
	sys.exit(1)
if os.getcwd() not in sys.path:
        sys.path.append(os.getcwd())

gobject.threads_init()

class Gallery:
	def __init__(self):
		self.wtree=gtk.glade.XML('gtkrg.glade')
		dict={"on_window1_delete_event":self.destroy,
			"on_toolbutton2_clicked":self.First_Foto,
			"on_toolbutton3_clicked":self.Last_Foto,
			"on_toolbutton4_clicked":self.Previous_Foto,
			"on_toolbutton5_clicked":self.Next_Foto,
			"on_toolbutton12_clicked":self.Fullscreen,
                        "on_treeview2_row_expanded":self.Expand_Rows,
			"on_treeview2_row_collapsed":self.Collapse_Rows,
                        "on_add_to_album1_activate":self.Add_Selection,
                        "on_delete1_activate":self.Delete_Selection,
                        "on_open_image_activate":self.Display_Foto,
                        "on_open_with_gimp_activate":self.Open_With_Gimp,
                        "on_open_with_other_activate":self.Open_With_Other,
                        "on_menuitem9_activate":self.Open_With_Gimp,
                        "on_menuitem10_activate":self.Open_With_Other,
			"on_menuitem13_activate":self.Hide_Pane,
                        "on_convert_activate":self.Show_Convert,
                        "on_about1_activate":self.Info,
			"on_exit2_activate":self.destroy,
                        "on_rename1_activate":self.Rename,
                        "on_delete3_activate":self.Delete,
                        "on_menuitem5_activate":self.Options,
                        "on_window2_window_state_event":self.Window_State_event,
                        "on_button5_clicked": self.Stop_Thumbnails,
                        "on_save_as_activate":self.Save_As_Dialog,
                        "on_dcraw_options_button_clicked":self.Dcraw_Options,
                        "on_win6_okbutton_clicked":self.Conversion,
                        "on_win6_cancelbutton_button_press_event":self.Hide_win6,
			"on_toolbutton24_toggled":self.Full_Exif,
			"on_toolbutton25_clicked":self.Hide_Exif,
			"on_toolbutton37_clicked":self.Save_As_Dialog,
			"on_menuitem6_activate":self.Open_With_Gimp,
			"on_imagemenuitem5_activate":self.Make_Bottom_Panel,
                        "on_imagemenuitem8_activate":self.Add_Selection,
                        "on_imagemenuitem9_activate":self.Delete_Selection,
                        "on_imagemenuitem10_activate":self.Save_As_Dialog,
                        "on_imagemenuitem15_activate":self.First_b_Foto,
                        "on_imagemenuitem16_activate":self.Previous_b_Foto,
                        "on_imagemenuitem17_activate":self.Next_b_Foto,
                        "on_imagemenuitem18_activate":self.Last_b_Foto,
			"on_imagemenuitem19_activate":self.Set_Album_Preview,
			"on_imagemenuitem20_activate":self.Set_Album_Preview,
			"on_button4_clicked":self.Default_Colors,
			"on_button22_clicked":self.Clear_Cache,
			"on_menuitem7_activate":self.Open_With_Other }
		self.wtree.signal_autoconnect(dict)
		self.Load_Widgets(self)
		self.Setup_Signal_Handlers(self)	
		self.watch = gtk.gdk.Cursor(gtk.gdk.WATCH)
		self.Stop_thread=threading.Event()
		self.lock=thread.allocate_lock()
		self.lock2=thread.allocate_lock()
		self.count=self.n=self.stop_thumb=self.indice=self.win2_indice=self.total_size=self.pixbuf1=self.pid=self.n_columns=0
		self.delay=0.00
		self.sample=self.close_panel=self.scrolledwindow6=self.raw_preview=None
		self.cache_size=50
		self.dcraw_options='-w -q 3'
		self.preview_options='-h'
		self.border_color=0xffffffff
		self.gradi=[gtk.gdk.PIXBUF_ROTATE_NONE,gtk.gdk.PIXBUF_ROTATE_COUNTERCLOCKWISE,gtk.gdk.PIXBUF_ROTATE_UPSIDEDOWN,gtk.gdk.PIXBUF_ROTATE_CLOCKWISE]
		self.width=150
		self.height=100
		self.list=[]
		self.selected=[]
		self.exif_list=[]
		self.oldlist=[]
		self.pblist=range(3)
		self.fullpblist=range(3)
		self.b_pixlist=range(3)
		self.pixindex=self.pbindex=self.fullpbindex=self.loop=1
		self.oldadj=self.pause=2
		self.frames=25
		self.album=self.added_album=self.cartella=self.Image_Size=''
		self.font='TSCu_Comic 12'
		self.rawpath={}
		self.ark=os.environ['HOME']+'/.GTKRawGallery/' 
		self.cache=self.ark+'.Thumbnails/'  
		self.temp=os.getcwd()+'/.raw/'
		self.version='GTKRawGallery-0.6 - '
		self.formats=['.jpg','.jpeg','.jpe','.tiff','.tif','.png','.xpm',\
			'.xbm','.gif','.ico','.cur','.ppm','.pbm','.pgm','.pnm','.pcx','.bmp',\
                        '.svg','.svgz','.svg.gz','.ras','.tga','.targa','.wmf','.apm','.wbmp']
                self.raw_formats=['.cr2','.nef','.crw','.raf','.kdc','.dcr','.mrw','.orf','.ptx','.pef','.arw',\
		'.srf','.x3f','.erf','.dng']
		self.outdir='.raw'
                self.boxmodel=gtk.ListStore(str)
                self.boxmodel2=gtk.ListStore(str)
		if '.thumbnails' not in os.listdir(os.getcwd()):
                        os.mkdir('.thumbnails')
                if self.outdir not in os.listdir(os.getcwd()):
                        os.mkdir(self.outdir)
                if '.GTKRawGallery' not in os.listdir(os.environ['HOME']):
                        os.mkdir(self.ark)
                if '.Thumbnails' not in os.listdir(self.ark):
                        os.mkdir(self.cache)
		self.cache_list=os.listdir(self.cache)
#=============  self.treeview1 structure ===========================================
															
		self.model=gtk.ListStore(gtk.gdk.Pixbuf,str)										
		(self.COL_PIXBUF,self.COL_STRING)=range(2)								
		cell=gtk.CellRendererText()
		pb_renderer=gtk.CellRendererPixbuf()
		self.column=gtk.TreeViewColumn()
		self.column.set_title('Albums')
		self.column.pack_start(pb_renderer, expand=False)
                self.column.add_attribute(pb_renderer, 'pixbuf', self.COL_PIXBUF)
                self.column.pack_start(cell, expand=True)
                self.column.add_attribute(cell, 'text', self.COL_STRING)
		self.column.set_resizable(True)										
		self.column.set_sort_column_id(self.COL_STRING)							
		self.treeview1.append_column(self.column)				
		self.treeview1.set_model(self.model)					
			
#=============  self.treeview2 structure ============================================
		
		(COL_PIXBUF, COL_STRING) = range(2)	
		self.treestore=gtk.TreeStore(gtk.gdk.Pixbuf,str)	
		self.folderpb = gtk.gdk.pixbuf_new_from_file('icons/stock_directory_24.png')
      		self.iter0 = self.treestore.append(None, [self.folderpb,'/'])
      		filelist=glob.glob('/*')
      		for item in filelist:
                        if os.path.isdir(item):
                                self.treestore.append(self.iter0, [self.folderpb,os.path.basename(item)])
		self.treeview2.set_model(self.treestore)
                self.column0 = gtk.TreeViewColumn("Directory Tree")
                self.treeview2.append_column( self.column0 )
		self.cellpb = gtk.CellRendererPixbuf()
        	self.cell = gtk.CellRendererText()
        	self.column0.pack_start(self.cellpb, False)
       		self.column0.add_attribute(self.cellpb, 'pixbuf', COL_PIXBUF)
       		self.column0.pack_start(self.cell, True)
       		self.column0.add_attribute(self.cell, 'text',COL_STRING)
		self.treeview2.expand_all()
		
#============== self.treeview3 structure =================================================

       		self.exifmodel=gtk.ListStore(str,str)
       		(COL_ITEM,COL_VALUE)=range(2)
       		cell=gtk.CellRendererText()										
		self.column_item=gtk.TreeViewColumn("TAG",cell,text=COL_ITEM)			
		self.column.set_resizable(True)																	
		self.treeview3.append_column(self.column_item)				
                cell=gtk.CellRendererText()										
		self.column_value=gtk.TreeViewColumn("VALUE",cell,text=COL_VALUE)			
		self.column.set_resizable(True)																	
		self.treeview3.append_column(self.column_value)		
		self.treeview3.set_model(self.exifmodel)
#=========================================================================================

                self.Load_Settings_Database(self)
                self.Load_Album_Database(self)
       		self.Widgets_Settings(self)
		self.Load_Last_Path(self)
		self.Add_Pattern(self)
		self.hpaned1.handler_unblock(self.id28)
		self.scrolledwindow2.set_size_request(int(gtk.gdk.screen_width()*0.85),-1)
		thread.start_new_thread(self.Cache_Control,())
#=======Methods ==========================================================================
		
	def Load_Last_Path(self,event):
		if self.checkbutton3.get_active():
                        if self.settings.has_key('switch') and self.settings['switch']!='':
                                if self.settings['switch']=='cartella':
					try:
                                        	self.Open_Last_Folder(self.settings['last_folder_path'])
					except: pass
                                elif self.settings['switch']=='album':
					try:
                                        	self.Open_Last_Album(self.settings['last_album_path'])
					except: pass
	
        def Load_Widgets(self,event):
                self.open_folder1=self.wtree.get_widget('open_folder1')
		self.open_album1=self.wtree.get_widget('open_album1')
		self.Open1=self.wtree.get_widget('open1')
		self.new1=self.wtree.get_widget('new1')
		self.new2=self.wtree.get_widget('new2')
		self.delete2=self.wtree.get_widget('delete2')
		self.filechooser=self.wtree.get_widget('filechooserdialog1')
		self.filechooser2=self.wtree.get_widget('filechooserdialog2')
		self.filechooserbutton1=self.wtree.get_widget('filechooserbutton1')
		self.filechooserbutton2=self.wtree.get_widget('filechooserbutton2')
		self.filechooserbutton3=self.wtree.get_widget('filechooserbutton3')
		self.filter0=gtk.FileFilter()
		self.filter1=gtk.FileFilter()
		self.dialog1=self.wtree.get_widget('dialog1')
		self.dialog2=self.wtree.get_widget('dialog2')
		self.dialog3=self.wtree.get_widget('dialog3')
		self.dialog4=self.wtree.get_widget('dialog4')
		self.dialog5=self.wtree.get_widget('dialog5')
		self.dialog6=self.wtree.get_widget('dialog6')
		self.dialog7=self.wtree.get_widget('dialog7')
		self.dialog8=self.wtree.get_widget('dialog8')
		self.dialog9=self.wtree.get_widget('dialog9')
		self.dialog10=self.wtree.get_widget('dialog10')
		self.dialog11=self.wtree.get_widget('dialog11')
		self.dialog12=self.wtree.get_widget('dialog12')
		self.dialog13=self.wtree.get_widget('dialog13')
		self.dialog14=self.wtree.get_widget('dialog14')
		self.dialog15=self.wtree.get_widget('dialog15')
		self.dialog16=self.wtree.get_widget('dialog16')
		self.dialog17=self.wtree.get_widget('dialog17')
		self.dialog18=self.wtree.get_widget('dialog18')
		self.dialog19=self.wtree.get_widget('dialog19')
		self.dialog20=self.wtree.get_widget('dialog20')
		self.label29=self.wtree.get_widget('label29')
		self.label7=self.wtree.get_widget('label7')
		self.label8=self.wtree.get_widget('label17')
		self.label4=self.wtree.get_widget('label4')
		self.label9=self.wtree.get_widget('label9')
		self.label10=self.wtree.get_widget('label10')
		self.label31=self.wtree.get_widget('label31')
		self.delete1=self.wtree.get_widget('delete1')
		self.frame1=self.wtree.get_widget('frame1')
		self.hpaned1=self.wtree.get_widget('hpaned1')
		self.hpaned2=self.wtree.get_widget('hpaned2')
		self.vpaned2=self.wtree.get_widget('vpaned2')
		self.delete_selection1=self.wtree.get_widget('delete_selection1')
		self.add_selection1=self.wtree.get_widget('add_selection1')
		self.add_to_album1=self.wtree.get_widget('add_to_album1')
		self.comboboxentry1=self.wtree.get_widget('comboboxentry1')
		self.comboboxentry2=self.wtree.get_widget('comboboxentry2')
		self.comboboxentry3=self.wtree.get_widget('comboboxentry3')
		self.comboboxentry4=self.wtree.get_widget('comboboxentry4')
		self.comboboxentry5=self.wtree.get_widget('comboboxentry5')
		self.entry1=self.wtree.get_widget('entry1')
		self.entry2=self.wtree.get_widget('entry2')
		self.entry3=self.wtree.get_widget('entry3')
		self.entry4=self.wtree.get_widget('entry4')
		self.entry5=self.wtree.get_widget('entry5')
		self.entry6=self.wtree.get_widget('entry6')
		self.entry7=self.wtree.get_widget('entry7')
		self.entry8=self.wtree.get_widget('entry8')
		self.entry9=self.wtree.get_widget('entry9')
		self.menu3=self.wtree.get_widget('menu3')
		self.menu5=self.wtree.get_widget('menu5')
		self.menu6=self.wtree.get_widget('menu6')
		self.menu8=self.wtree.get_widget('menu8')
		self.boxentry=self.wtree.get_widget('comboboxentry-entry1')
		self.boxentry2=self.wtree.get_widget('comboboxentry-entry2')
		self.window1=self.wtree.get_widget('window1')
		self.window2=self.wtree.get_widget('window2')
		self.window3=self.wtree.get_widget('window3')
		self.window4=self.wtree.get_widget('window4')
		self.window5=self.wtree.get_widget('window5')
		self.window6=self.wtree.get_widget('window6')
		self.window7=self.wtree.get_widget('window7')
                self.statusbar2=self.wtree.get_widget('statusbar2')
		self.statusbar3=self.wtree.get_widget('statusbar3')
		self.progressbar1=self.wtree.get_widget('progressbar1')
		self.progressbar2=self.wtree.get_widget('progressbar2')
		self.progressbar3=self.wtree.get_widget('progressbar3')
		self.progressbar4=self.wtree.get_widget('progressbar4')
		self.radiobutton1=self.wtree.get_widget('radiobutton1')
		self.radiobutton2=self.wtree.get_widget('radiobutton2')
		self.radiobutton3=self.wtree.get_widget('radiobutton3')
		self.radiobutton4=self.wtree.get_widget('radiobutton4')
		self.radiobutton5=self.wtree.get_widget('radiobutton5')
		self.radiobutton6=self.wtree.get_widget('radiobutton6')
		self.radiobutton7=self.wtree.get_widget('radiobutton7')
		self.radiobutton8=self.wtree.get_widget('radiobutton8')
		self.radiobutton9=self.wtree.get_widget('radiobutton9')
		self.checkbutton1=self.wtree.get_widget('checkbutton1')
		self.checkbutton2=self.wtree.get_widget('checkbutton2')
		self.checkbutton3=self.wtree.get_widget('checkbutton3')
		self.checkbutton4=self.wtree.get_widget('checkbutton4')
		self.checkbutton5=self.wtree.get_widget('checkbutton5')
		self.checkbutton6=self.wtree.get_widget('checkbutton6')
		self.checkbutton7=self.wtree.get_widget('checkbutton7')
		self.image2=self.wtree.get_widget('image2')
		self.image4=self.wtree.get_widget('image4')
		self.image15=self.wtree.get_widget('image15')
		self.image_open1=self.wtree.get_widget('menu-item-image9')
		self.image_open2=self.wtree.get_widget('menu-item-image10')
		self.image_hide_panel=self.wtree.get_widget('menu-item-image16')
		self.image_show_panel=self.wtree.get_widget('menu-item-image17')
		self.viewport1=self.wtree.get_widget('viewport1')
		self.image1=self.wtree.get_widget('image1')
		self.hscale1=self.wtree.get_widget('hscale1')
		self.hscale2=self.wtree.get_widget('hscale2')
		self.image52=self.wtree.get_widget('image52')
		self.image11=self.wtree.get_widget('image11')
		self.image12=self.wtree.get_widget('image12')
		self.image13=self.wtree.get_widget('image13')
		self.image14=self.wtree.get_widget('image14')
		self.scrolledwindow2=self.wtree.get_widget('scrolledwindow2')
		self.scrolledwindow3=self.wtree.get_widget('scrolledwindow3')
		self.scrolledwindow5=self.wtree.get_widget('scrolledwindow5')
		self.scrolledwindow4=self.wtree.get_widget('scrolledwindow4')
		self.treeview1=self.wtree.get_widget('treeview1')
		self.treeview2 = self.wtree.get_widget('treeview2')
		self.treeview3=self.wtree.get_widget('treeview3')
		self.toolbutton1=self.wtree.get_widget('toolbutton1')
		self.toolbutton6=self.wtree.get_widget('toolbutton6')
		self.toolbutton7=self.wtree.get_widget('toolbutton7')
		self.toolbutton8=self.wtree.get_widget('toolbutton8')
		self.toolbutton9=self.wtree.get_widget('toolbutton9')
		self.toolbutton10=self.wtree.get_widget('toolbutton10')
		self.toolbutton11=self.wtree.get_widget('toolbutton11')
		self.toolbutton13=self.wtree.get_widget('toolbutton13')
		self.toolbutton14=self.wtree.get_widget('toolbutton14')
		self.toolbutton15=self.wtree.get_widget('toolbutton15')
		self.toolbutton16=self.wtree.get_widget('toolbutton16')
		self.toolbutton17=self.wtree.get_widget('toolbutton17')
		self.toolbutton18=self.wtree.get_widget('toolbutton18')
		self.toolbutton19=self.wtree.get_widget('toolbutton19')
		self.toolbutton20=self.wtree.get_widget('toolbutton20')
		self.toolbutton21=self.wtree.get_widget('toolbutton21')
		self.toolbutton24=self.wtree.get_widget('toolbutton24')
		self.toolbutton25=self.wtree.get_widget('toolbutton25')
		self.toolbutton26=self.wtree.get_widget('toolbutton26')
		self.toolbutton27=self.wtree.get_widget('toolbutton27')
		self.toolbutton28=self.wtree.get_widget('toolbutton28')
		self.toolbutton29=self.wtree.get_widget('toolbutton29')
		self.toolbutton30=self.wtree.get_widget('toolbutton30')
		self.toolbutton31=self.wtree.get_widget('toolbutton31')
		self.toolbutton32=self.wtree.get_widget('toolbutton32')
		self.toolbutton33=self.wtree.get_widget('toolbutton33')
		self.toolbutton34=self.wtree.get_widget('toolbutton34')
		self.toolbutton35=self.wtree.get_widget('toolbutton35')
		self.toolbutton36=self.wtree.get_widget('toolbutton36')
		self.eventbox1=self.wtree.get_widget('eventbox1')
		self.eventbox2=self.wtree.get_widget('eventbox2')
		self.adj=self.hscale1.get_adjustment()
		self.jpg_quality=self.hscale2.get_adjustment()
		self.spinbutton2=self.wtree.get_widget('spinbutton2')
		self.spinbutton3=self.wtree.get_widget('spinbutton3')
		self.win6_okbutton=self.wtree.get_widget('win6_okbutton')
		self.win6_cancelbutton=self.wtree.get_widget('win6_cancelbutton')
		self.dcraw_options_button=self.wtree.get_widget('dcraw_options_button')
		self.menutoolbutton1=self.wtree.get_widget('menutoolbutton1')
		self.colorbutton1=self.wtree.get_widget('colorbutton1')
		self.colorbutton2=self.wtree.get_widget('colorbutton2')
		self.colorbutton3=self.wtree.get_widget('colorbutton3')
		self.colorbutton4=self.wtree.get_widget('colorbutton4')
		self.colorbutton5=self.wtree.get_widget('colorbutton5')
		self.eb=gtk.EventBox()
		self.fontbutton1=self.wtree.get_widget('fontbutton1')
		self.toolbar1=self.wtree.get_widget('toolbar1')
		self.toolbar2=self.wtree.get_widget('toolbar2')
		self.button4=self.wtree.get_widget('button4')
		self.button5=self.wtree.get_widget('button5')
		self.button25=self.wtree.get_widget('button25')
		self.sort_by_name=self.wtree.get_widget('radiomenuitem1')
		self.sort_by_type=self.wtree.get_widget('radiomenuitem2')
		self.sort_by_reverse=self.wtree.get_widget('radiomenuitem3')
		self.sort_by_random=self.wtree.get_widget('radiomenuitem4')
		self.imagemenuitem2=self.wtree.get_widget('imagemenuitem2')
		self.imagemenuitem3=self.wtree.get_widget('imagemenuitem3')
		self.imagemenuitem5=self.wtree.get_widget('menu-item-image21')
		self.imagemenuitem6=self.wtree.get_widget('imagemenuitem6')
		self.imagemenuitem8=self.wtree.get_widget('imagemenuitem8')
		self.imagemenuitem9=self.wtree.get_widget('imagemenuitem9')
		self.imagemenuitem11=self.wtree.get_widget('imagemenuitem11')
		self.imagemenuitem12=self.wtree.get_widget('imagemenuitem12')
		self.imagemenuitem13=self.wtree.get_widget('imagemenuitem13')
		self.imagemenuitem14=self.wtree.get_widget('imagemenuitem14')
		self.imagemenuitem19=self.wtree.get_widget('imagemenuitem19')
		self.imagemenuitem20=self.wtree.get_widget('imagemenuitem20')
		self.menu_item_image23=self.wtree.get_widget('menu-item-image23')
		self.menu_item_image25=self.wtree.get_widget('menu-item-image25')
		self.menu_item_image26=self.wtree.get_widget('menu-item-image26')
		self.menu_item_image33=self.wtree.get_widget('menu-item-image33')
		self.menu_item_image34=self.wtree.get_widget('menu-item-image34')
		self.menu_item_image35=self.wtree.get_widget('menu-item-image35')
		self.menuitem11=self.wtree.get_widget('menuitem11')
		self.menuitem12=self.wtree.get_widget('menuitem12')
		self.tooltip=gtk.Tooltips()
		self.background=gtk.gdk.pixbuf_new_from_file('icons/nero.png').scale_simple(gtk.gdk.screen_width(),\
		gtk.gdk.screen_height(),gtk.gdk.INTERP_BILINEAR)
		self.grey=gtk.gdk.pixbuf_new_from_file('icons/layer1.png')
		self.stock_cancel_img=gtk.image_new_from_stock(gtk.STOCK_CANCEL,gtk.ICON_SIZE_BUTTON)
		self.stock_stop_img=gtk.image_new_from_stock(gtk.STOCK_STOP,gtk.ICON_SIZE_BUTTON)
		self.stock_close_img=gtk.image_new_from_stock(gtk.STOCK_CLOSE,gtk.ICON_SIZE_BUTTON)
		self.stock_properties_img=gtk.image_new_from_stock(gtk.STOCK_PROPERTIES,gtk.ICON_SIZE_BUTTON)
		
	def Widgets_Settings(self,event):
                self.dialog11.set_default_response(gtk.RESPONSE_OK)
		self.dialog13.set_default_response(gtk.RESPONSE_OK)
		self.dialog1.set_default_response(gtk.RESPONSE_OK)
		self.dialog1.set_transient_for(self.window1)
		self.dialog1.set_transient_for(self.dialog4)
		self.dialog16.set_transient_for(self.filechooser2)
		self.dialog17.set_transient_for(self.filechooser2)
		self.dialog18.set_transient_for(self.filechooser2)
		self.window5.set_transient_for(self.filechooser2)
		self.context_id2=self.statusbar2.get_context_id('dimensions')
		self.context_id3=self.statusbar3.get_context_id('tot. photos')
		self.image52.set_from_file('icons/open_album.png')
		self.image11.set_from_file('icons/layout-gallery.png')
		self.image12.set_from_file('icons/layout-bottom.png')
		self.image13.set_from_file('icons/sound.png')
		self.image14.set_from_file('icons/video.png')
		self.image_open1.set_from_file('icons/open_album.png')
		self.image_open2.set_from_file('icons/open_photo.png')
		self.image_hide_panel.set_from_file('icons/hide-panel.png')
		self.image_show_panel.set_from_file('icons/show-panel.png')
		self.imagemenuitem5.set_from_file('icons/bottom-panel.png')
		self.menu_item_image23.set_from_file('icons/open_photo.png')
		self.menu_item_image25.set_from_file('icons/rotate_ccw.png')
		self.menu_item_image26.set_from_file('icons/rotate_cw.png')
		self.menu_item_image33.set_from_file('icons/mime-image.png')
		self.menu_item_image34.set_from_file('icons/hide-pane.png')
		self.menu_item_image35.set_from_file('icons/mime-image.png')
		image10=gtk.Image()
		image10.set_from_file('icons/rotate_ccw.png')
		self.toolbutton10.set_icon_widget(image10)
		image10.show()
                image11=gtk.Image()
		image11.set_from_file('icons/rotate_cw.png')
		self.toolbutton11.set_icon_widget(image11)
		image11.show()
		image18=gtk.Image()
		image18.set_from_file('icons/select_all.png')
		self.toolbutton18.set_icon_widget(image18)
		image18.show()
		image19=gtk.Image()
		image19.set_from_file('icons/unselect.png')
		self.toolbutton19.set_icon_widget(image19)
		image19.show()
		image20=gtk.Image()
		image20.set_from_file('icons/inverted.png')
		self.toolbutton20.set_icon_widget(image20)
		image20.show()
		image26=gtk.Image()
		image26.set_from_file('icons/hide-panel.png')
		self.toolbutton26.set_icon_widget(image26)
		image26.show()
		image27=gtk.Image()
		image27.set_from_file('icons/show-panel.png')
		self.toolbutton27.set_icon_widget(image27)
		image27.show()
		image28=gtk.Image()
		image28.set_from_file('icons/hide-pane.png')
		self.toolbutton28.set_icon_widget(image28)
		image28.show()
		image29=gtk.Image()
		image29.set_from_file('icons/bottom-panel.png')
		self.toolbutton29.set_icon_widget(image29)
		image29.show()
		self.nero=gtk.gdk.color_parse('#000000')
		self.selection_color=self.colorbutton5.get_color()
		self.colorbase=gtk.gdk.color_parse('#EFEFEF')
		self.viewport1.modify_bg(gtk.STATE_NORMAL,self.nero)
		self.window3.modify_bg(gtk.STATE_NORMAL,self.nero)
		self.window4.modify_bg(gtk.STATE_NORMAL,self.nero)
		self.window1.modify_bg(gtk.STATE_NORMAL,self.toolbar_color)
		self.window2.modify_bg(gtk.STATE_NORMAL,self.toolbar_color)
		self.toolbar1.modify_bg(gtk.STATE_NORMAL,self.toolbar_color)
		self.toolbar2.modify_bg(gtk.STATE_NORMAL,self.toolbar_color)
		self.eventbox1.modify_bg(gtk.STATE_NORMAL,self.gallery_color)
		self.treeview1.modify_base(gtk.STATE_NORMAL,self.treeview_color)
		self.treeview2.modify_base(gtk.STATE_NORMAL,self.treeview_color)
		self.treeview3.modify_base(gtk.STATE_NORMAL,self.treeview_color)
		self.fontbutton1.set_font_name(self.font)
		self.treeview1.modify_font(self.font_desc)	
		self.window1.set_icon_from_file('icons/logo.png')
		self.window2.set_icon_from_file('icons/logo.png')
		self.window5.set_icon_from_file('icons/logo.png')
		self.window6.set_icon_from_file('icons/logo.png')
		self.dialog1.set_icon_from_file('icons/logo.png')
		self.dialog2.set_icon_from_file('icons/logo.png')
		self.dialog3.set_icon_from_file('icons/logo.png')
		self.dialog4.set_icon_from_file('icons/logo.png')
		self.dialog5.set_icon_from_file('icons/logo.png')
		self.dialog6.set_icon_from_file('icons/logo.png')
		self.dialog8.set_icon_from_file('icons/logo.png')
		self.dialog10.set_icon_from_file('icons/logo.png')
		self.dialog11.set_icon_from_file('icons/logo.png')
		self.dialog12.set_icon_from_file('icons/logo.png')
		self.dialog13.set_icon_from_file('icons/logo.png')
		self.dialog14.set_icon_from_file('icons/logo.png')
		self.dialog15.set_icon_from_file('icons/logo.png')
		self.dialog16.set_icon_from_file('icons/logo.png')
		self.dialog17.set_icon_from_file('icons/logo.png')
		self.dialog18.set_icon_from_file('icons/logo.png')
		self.dialog19.set_icon_from_file('icons/logo.png')
		self.dialog20.set_icon_from_file('icons/logo.png')
		self.filechooser.set_icon_from_file('icons/logo.png')
		self.filechooser2.set_icon_from_file('icons/logo.png')
		self.filechooserbutton1.set_current_folder(self.ark[:-1])
		self.filechooser2.set_current_folder(os.environ['HOME'])
		self.entry4.set_text(self.ark[:-1])
		self.entry5.set_text(os.environ['HOME'])
		self.entry8.set_text(os.environ['HOME'])
		self.window1.set_title(self.version[:-2])
		self.window1.maximize()
		self.window2.set_default_size(gtk.gdk.screen_width(),gtk.gdk.screen_height())
		self.scrolledwindow3.set_size_request(int(gtk.gdk.screen_width()*0.7),-1)
		self.hpaned1.set_position(int(gtk.gdk.screen_width()*0.15))
		self.menutoolbutton1.set_menu(self.menu3)
		self.filter0.set_name('sound files')
		self.filter1.set_name('Image files')
		
	def Add_Pattern(self,event):
		output=commands.getoutput('sox -h')
		a=string.split(output,':')
		formats=string.split(a[-1],' ')[1:-1]
		for item in formats:
			self.filter0.add_pattern("*."+item)
		self.filechooserbutton3.add_filter(self.filter0)
		for item in self.formats:
                        self.filter1.add_pattern("*"+item)
                        self.filter1.add_pattern("*"+string.upper(item))
                for item in self.raw_formats:
                        self.filter1.add_pattern("*"+item)
                        self.filter1.add_pattern("*"+string.upper(item))
                self.filechooser.add_filter(self.filter1)
 					
	def Setup_Signal_Handlers(self,event):
                self.treeview1.connect("button_press_event",self.Menu)
                self.toolbutton10.connect('clicked',self.Sx_Rotation,0)
                self.toolbutton11.connect('clicked',self.Dx_Rotation,0)
                self.toolbutton13.connect("clicked",self.Slideshow,1)
		self.id1=self.toolbutton16.connect("clicked",self.Reduce_Gallery)
		self.id2=self.toolbutton17.connect("clicked",self.Enlarge_Gallery)
		self.id3=self.treeview1.connect("row_activated",self.Show_Album)
		self.id4=self.Open1.connect("activate",self.Open)
		self.id5=self.open_folder1.connect("activate",self.Show_Filechooserdialog1)
		self.id6=self.open_album1.connect("activate",self.Open_Album)
		self.id7=self.treeview2.connect("row_activated",self.Get_Folder)
		self.id8=self.toolbutton1.connect("clicked",self.Show_Filechooserdialog1)
		self.id9=self.toolbutton14.connect("clicked",self.Add_Album,None)
		self.id10=self.toolbutton15.connect("clicked",self.Delete_Album)
		self.id11=self.toolbutton18.connect("clicked",self.Select_All)
		self.id12=self.toolbutton19.connect("clicked",self.Unselect)
		self.id13=self.toolbutton20.connect("clicked",self.Inverted_Selection)
		self.id14=self.new1.connect('activate',self.Add_Album,None)
		self.id15=self.delete2.connect('activate',self.Delete_Album)
		self.id16=self.add_selection1.connect('activate',self.Pre_Add_Selection)
		self.id17=self.delete_selection1.connect('activate',self.Delete_Selection)
		self.id18=self.new2.connect('activate',self.Add_Album,None)
		self.id19=self.toolbutton21.connect("clicked",self.Slideshow,1,2)
		self.id22=self.hpaned2.connect('notify',self.Autoresize)
		self.id23=self.toolbutton26.connect('clicked',self.Set_Panel,'hide')
		self.id24=self.toolbutton27.connect('clicked',self.Set_Panel,'show')
		self.id26=self.toolbutton29.connect('clicked',self.Make_Bottom_Panel)
		self.id27=self.vpaned2.connect('notify',self.Autoresize2)
		self.id28=self.hpaned1.connect('notify',self.Autoresize2)
		self.id29=self.eventbox1.connect("button_press_event", self.Eventbox1_Handler)
		self.id30=self.toolbutton30.connect('clicked',self.Fullscreen)
		self.id31=self.toolbutton31.connect('clicked',self.First_b_Foto)
		self.id32=self.toolbutton32.connect('clicked',self.Previous_b_Foto)
		self.id33=self.toolbutton33.connect('clicked',self.Next_b_Foto)
		self.id34=self.toolbutton34.connect('clicked',self.Last_b_Foto)
		self.id35=self.toolbutton6.connect('clicked',self.Zoom_in_Foto,0)
                self.id36=self.toolbutton7.connect('clicked',self.Zoom_out_Foto,0)
		self.id37=self.toolbutton8.connect('clicked',self.Zoom_fit_Foto,0)
                self.id38=self.toolbutton9.connect('clicked',self.Zoom_1_Foto,0)
		self.id39=self.toolbutton28.connect('clicked',self.Hide_Pane)
		self.id40=self.toolbutton35.connect('clicked',self.Close_Window2)
		self.id41=self.toolbutton36.connect('clicked',self.Load_Raw_Preview)
		self.scrolledwindow2.connect('scroll_event',self.Scroll_Eventbox1)
		self.hpaned1.handler_block(self.id28)
		self.window1.connect('delete-event',self.destroy)
		self.window2.connect('delete-event',self.on_delete_event)
		self.window5.connect('delete-event',self.on_delete_event)
		self.window6.connect('delete-event',self.on_delete_event)
		self.dialog6.connect('delete-event',self.on_delete_event)
                self.window3.connect("button-press-event",self.on_delete_window3)
		self.window3.connect("scroll-event",self.Scroll_Fullfoto)
		self.window4.connect("button-press-event",self.on_delete_event)
		self.window4.connect("scroll-event",self.on_delete_event)
		self.scrolledwindow3.connect('scroll-event',self.Scroll_Scrolledwindow3)
		self.filechooserbutton1.connect("current_folder_changed",lambda w:self.entry4.set_text(self.filechooserbutton1.get_current_folder()))
		self.filechooserbutton2.connect("current_folder_changed",lambda w:self.entry5.set_text(self.filechooserbutton2.get_current_folder()))
		self.filechooser2.connect("current_folder_changed",lambda w:self.entry8.set_text(self.filechooser2.get_current_folder()))
                self.radiobutton4.connect("toggled",lambda w: self.entry6.set_sensitive(False))
                self.radiobutton5.connect("toggled",lambda w: self.entry6.set_sensitive(True))
		self.window3.connect("key_press_event",self.on_key_press_event)
		self.window4.connect("key_press_event",self.on_key_press_event)
		self.imagemenuitem2.connect('activate',self.Set_Panel,'hide')
		self.imagemenuitem3.connect('activate',self.Set_Panel,'show')
		self.imagemenuitem6.connect('activate',self.Open_On_Window2)
 		self.imagemenuitem11.connect('activate',self.Zoom_out_Foto,1)
 		self.imagemenuitem12.connect('activate',self.Zoom_in_Foto,1)
 		self.imagemenuitem13.connect('activate',self.Sx_Rotation,1)
 		self.imagemenuitem14.connect('activate',self.Dx_Rotation,1)
		self.menuitem11.connect('activate',self.Zoom_fit_Foto,1)
		self.menuitem12.connect('activate',self.Zoom_1_Foto,1)

        def Autoresize(self,obj,param):
                if param.name=='position':
                        self.rect=self.scrolledwindow3.allocation
                        format=os.path.splitext(self.list[self.indice])[1]	
                        if string.lower(format) in self.raw_formats:
				preview=self._label[:-len(format)]+'.tiff'
				if preview in os.listdir(self.temp) and self.raw_preview:
					self.pblist[self.pbindex]=gtk.gdk.pixbuf_new_from_file_at_size(self.temp+preview,\
					self.rect.width,self.rect.height)
				else:
                                	self.pblist[self.pbindex] = gtk.gdk.pixbuf_new_from_file_at_size(self.list[self.indice]\
                                	[:-len(format)],self.rect.width,self.rect.height)
                        else:
                                self.pblist[self.pbindex] = gtk.gdk.pixbuf_new_from_file_at_size(self.list[self.indice],\
                                self.rect.width,self.rect.height)
			self.pblist[self.pbindex]=self.Check_Icons(format,self.pblist[self.pbindex])
                        self.image1.set_from_pixbuf(self.pblist[self.pbindex])
                        self.window2.show_all()
			gc.collect()
                        while gtk.events_pending(): gtk.main_iteration(False)
			
	def Autoresize2(self,obj,param):
		if not self.n: return True
		if self.radiobutton6.get_active(): return True
		if param.name=='position':
                        self.rect2=self.scrolledwindow2.allocation
			format=os.path.splitext(self.list[self.indice])[1]	
                        if string.lower(format) in self.raw_formats:
                                self.b_pixlist[self.pixindex]= gtk.gdk.pixbuf_new_from_file_at_size(self.list[self.indice]\
                                [:-len(format)],self.rect2.width,self.rect2.height-self.swin2_label.allocation.height)
                        else:
                                self.b_pixlist[self.pixindex]= gtk.gdk.pixbuf_new_from_file_at_size(self.list[self.indice],\
                                self.rect2.width,self.rect2.height-self.swin2_label.allocation.height)
			self.b_pixlist[self.pixindex]=self.Check_Icons(format,self.b_pixlist[self.pixindex])
			self.swin2_image.set_from_pixbuf(self.b_pixlist[self.pixindex])
			self.scrolledwindow2.show_all()
			gc.collect()
                        while gtk.events_pending(): gtk.main_iteration(False)
			
	def on_key_press_event(self,obj,event):
		keyname = gtk.gdk.keyval_name(event.keyval)
		if obj==self.window3:
			if keyname=='Up': self.Previous_Fullfoto(self)
			elif keyname=='Down': self.Next_Fullfoto(self)
			elif keyname in ['Return','space']: self.on_delete_window3(self.window3,event)
		elif obj==self.window4: self.on_delete_event(self.window4,event)

	def Scroll_Bottom_Panel(self,obj,event):
                adj=self.scrolledwindow6.get_hadjustment()
                if event.direction==gtk.gdk.SCROLL_DOWN:
			if adj.value<adj.upper-adj.page_size:
                                adj.set_value(adj.value+adj.step_increment)
                                self.scrolledwindow6.set_hadjustment(adj)
			elif adj.value>=adj.upper-adj.page_size:
				adj.set_value(adj.upper-adj.page_size)
                                self.scrolledwindow6.set_hadjustment(adj)
                elif event.direction==gtk.gdk.SCROLL_UP:
                        adj.set_value(adj.value-adj.step_increment)
                        self.scrolledwindow6.set_hadjustment(adj)
			
	def Toolbuttons(self,obj,data1,data2):
			self.toolbutton31.set_sensitive(data1)
			self.toolbutton32.set_sensitive(data1)
			self.toolbutton33.set_sensitive(data1)
			self.toolbutton34.set_sensitive(data1)
			self.toolbutton18.set_sensitive(data2)
			self.toolbutton19.set_sensitive(data2)
			self.toolbutton20.set_sensitive(data2)
                        
        def Load_Settings_Database(self,event):
                try:
                        f=open('settings')
                        self.settings=cPickle.load(f)
                        f.close()
			if self.settings.has_key('font'):
				self.font=self.settings['font']
				self.font_desc=pango.FontDescription(self.font)
			else:   self.font_desc=pango.FontDescription(self.font)
			if self.settings.has_key('gallery_red'): red=self.settings['gallery_red']
			if self.settings.has_key('gallery_green'): green=self.settings['gallery_green']
			if self.settings.has_key('gallery_blue'):
				blue=self.settings['gallery_blue']
				self.gallery_color=gtk.gdk.Color(red,green,blue)	
				self.colorbutton1.set_color(self.gallery_color)
			else:   self.gallery_color=self.colorbutton1.get_color()
			if self.settings.has_key('label_red'): l_red=self.settings['label_red']
			if self.settings.has_key('label_green'): l_green=self.settings['label_green']
			if self.settings.has_key('label_blue'):
				l_blue=self.settings['label_blue']
				self.label_color=gtk.gdk.Color(l_red,l_green,l_blue)	
				self.colorbutton2.set_color(self.label_color)
			else:   self.label_color=self.colorbutton2.get_color()
			if self.settings.has_key('treeview_red'): treeview_red=self.settings['treeview_red']
			if self.settings.has_key('treeview_green'): treeview_green=self.settings['treeview_green']
			if self.settings.has_key('treeview_blue'):
				treeview_blue=self.settings['treeview_blue']
				self.treeview_color=gtk.gdk.Color(treeview_red,treeview_green,treeview_blue)
				self.colorbutton3.set_color(self.treeview_color)
			else:   self.treeview_color=self.colorbutton3.get_color()
			if self.settings.has_key('toolbar_red'): toolbar_red=self.settings['toolbar_red']
			if self.settings.has_key('toolbar_green'): toolbar_green=self.settings['toolbar_green']
			if self.settings.has_key('toolbar_blue'):
				toolbar_blue=self.settings['toolbar_blue']
				self.toolbar_color=gtk.gdk.Color(toolbar_red,toolbar_green,toolbar_blue)
				self.colorbutton4.set_color(self.toolbar_color)
			else:   self.toolbar_color=self.colorbutton4.get_color()
			if self.settings.has_key('selection_red'): selection_red=self.settings['selection_red']
			if self.settings.has_key('selection_green'): selection_green=self.settings['selection_green']
			if self.settings.has_key('selection_blue'):
				selection_blue=self.settings['selection_blue']
				self.selection_color=gtk.gdk.Color(selection_red,selection_green,selection_blue)
				self.colorbutton5.set_color(self.selection_color)
			else:   self.selection_color=self.colorbutton5.get_color()
                        if self.settings.has_key('adj_value'):
				self.adj.set_value(self.settings['adj_value'])
			else:
				self.adj.set_value(2)
				self.settings['adj_value']=2
                        if self.settings.has_key('jpg_quality'): self.jpg_quality.set_value(self.settings['jpg_quality'])
                        self.pause=self.settings['adj_value']
			if self.settings.has_key('border_color'):
				self.border_color=self.settings['border_color']
				if self.border_color==0xffffffff:
					self.comboboxentry5.child.set_text('White')
				elif self.border_color==0x00000000:
					self.comboboxentry5.child.set_text('Black')
				else:   self.comboboxentry5.child.set_text('Grey')
			if self.settings.has_key('frames'):
				self.frames=self.settings['frames']
				self.spinbutton2.set_value(self.frames)
                        if self.settings['radiobutton1']:
                                self.radiobutton1.set_active(True)
                                self.width=150
                                self.height=100
                        if self.settings['radiobutton2']:
                                self.radiobutton2.set_active(True)
                                self.width=201
                                self.height=134
                        if self.settings['radiobutton3']:
                                self.radiobutton3.set_active(True)
                                self.width=260
                                self.height=174
			if self.settings['radiobutton6']:
				self.radiobutton6.set_active(True)
				self.Toolbuttons(self,False,True)
			elif self.settings['radiobutton7']:
				self.radiobutton7.set_active(True)
				self.Toolbuttons(self,True,False)
			if self.settings['radiobutton8']:
				self.radiobutton8.set_active(True)
				self.preview_options='-h'
			else:
				self.radiobutton9.set_active(True)
				self.preview_options='-w -h'
                        if self.settings['dcraw_options'] and self.settings['dcraw_options']=='-w -q 3':
                                self.radiobutton4.set_active(True)
                                self.entry6.set_sensitive(False)
                                self.dcraw_options=self.settings['dcraw_options']
                        elif self.settings['dcraw_options']:
                                self.radiobutton5.set_active(True)
                                self.entry6.set_sensitive(True)
                                self.dcraw_options=self.settings['dcraw_options']
                                self.entry6.set_text(self.dcraw_options)
                        if self.settings['checkbutton1']:
                                self.checkbutton1.set_active(True)
				self.toolbutton25.set_icon_widget(self.stock_properties_img)
				self.stock_properties_img.show()
				self.tooltip.set_tip(self.toolbutton25,'Show Exif',None)
			else:
				self.toolbutton25.set_icon_widget(self.stock_close_img)
				self.stock_close_img.show()
				self.tooltip.set_tip(self.toolbutton25,'Hide Exif',None)
			if self.settings['checkbutton2']:
                                self.checkbutton2.set_active(True)
                        if self.settings['checkbutton3']:
                                self.checkbutton3.set_active(True)
			if self.settings['checkbutton4']:
                                self.checkbutton4.set_active(True)
			if self.settings['checkbutton5']:
                                self.checkbutton5.set_active(True)
			if self.settings['checkbutton6']:
                                self.checkbutton6.set_active(True)
			else:   self.checkbutton6.set_active(False)
			if self.settings['checkbutton7']:
                                self.checkbutton7.set_active(True)
			else:   self.checkbutton7.set_active(False)
                        self.ark=self.settings['ark']+'/'
                        self.filechooserbutton1.set_current_folder(self.ark[:-1])
                        self.entry4.set_text(self.ark[:-1])
			if self.settings['sample']:
				self.sample=self.settings['sample']
                                self.filechooserbutton3.set_filename(self.sample)
			if self.settings['delay']:
				self.delay=self.settings['delay']
				self.spinbutton3.set_value(self.delay)
                except:	
			self.settings={}
			self.Default_Settings(self)
			
	def Default_Settings(self,event):
		self.checkbutton1.set_active(False)
		self.settings['checkbutton1']=False
		self.toolbutton25.set_icon_widget(self.stock_close_img)
		self.stock_close_img.show()
		self.tooltip.set_tip(self.toolbutton25,'Hide Exif',None)
		self.settings['checkbutton2']=True
		self.settings['checkbutton3']=True
		self.settings['checkbutton4']=True
		self.settings['checkbutton5']=True
		self.settings['checkbutton6']=False
		self.settings['checkbutton7']=True
		self.settings['radiobutton1']=True
		self.settings['radiobutton2']=False
		self.settings['radiobutton3']=False
		self.settings['radiobutton6']=True
		self.settings['radiobutton8']=True       
		self.settings['ark']=self.ark[:-1]
		self.settings['dcraw_options']='-w -q 3'
		self.radiobutton1.set_active(True)
		self.radiobutton6.set_active(True)
		self.radiobutton7.set_active(False)
		self.radiobutton8.set_active(True)
		self.checkbutton2.set_active(True)
		self.checkbutton3.set_active(True)
		self.checkbutton4.set_active(True)
		self.checkbutton5.set_active(True)
		self.checkbutton6.set_active(False)
		self.checkbutton7.set_active(True)
		self.Default_Colors(self)
		self.gallery_color=self.colorbutton1.get_color()
		self.label_color=self.colorbutton2.get_color()
		self.treeview_color=self.colorbutton3.get_color()
		self.toolbar_color=self.colorbutton4.get_color()
		self.selection_color=self.colorbutton5.get_color()
		self.font_desc=pango.FontDescription(self.font)
		self.settings['border_color']=0xffffffff
		self.comboboxentry5.child.set_text('White')
		self.frames=25
		self.delay=0.00
		self.sample=None
		self.font='TSCu_Comic 12'
		self.settings['frames']=25
		self.settings['sample']=self.sample
		self.settings['delay']=0.00
		self.spinbutton3.set_value(0.00)
		self.spinbutton2.set_value(self.frames)	
		self.fontbutton1.set_font_name(self.font)
		self.adj.set_value(2)
		self.filechooserbutton1.set_current_folder(os.environ['HOME']+'/.GTKRawGallery')
		self.entry9.set_text('50')

	def Load_Album_Database(self,event):
                try:
                        f=open(self.ark+'albums.db')
                        self.albums=cPickle.load(f)
                        f.close()
			for key in self.albums.keys():
                                try:
                                        self.model.append([gtk.gdk.pixbuf_new_from_file(self.ark+key+'/_preview_.png'),key])
                                except:
                                        self.model.append([gtk.gdk.pixbuf_new_from_file('icons/no_preview.png'), key])
				self.boxmodel.append([key])
				self.boxmodel2.append([key])
                        self.comboboxentry1.set_model(self.boxmodel)
                        self.comboboxentry2.set_model(self.boxmodel2)
			if self.comboboxentry1.get_text_column()!=0: self.comboboxentry1.set_text_column(0)
                        if self.comboboxentry2.get_text_column()!=0: self.comboboxentry2.set_text_column(0)
			self.treeview1.set_model(self.model)
                except: self.albums={}

	def Menu(self,obj,event):
                if event.button==3:
			x=int(event.x)
			y=int(event.y)
			path=self.treeview1.get_path_at_pos(x, y)
			if path:
				self.path=path[0]
                                self.menu6.popup(None,None,None,event.button, event.time)

        def Info(self,event):
                self.dialog7.show()
                response=self.dialog7.run()
                if response==gtk.RESPONSE_CLOSE or response==gtk.RESPONSE_DELETE_EVENT:  self.dialog7.hide()
                        
        def Window_State_event(self,obj,event):
                        if event.new_window_state & gtk.gdk.WINDOW_STATE_MAXIMIZED:
                                if self.settings['checkbutton1']:
					self.frame1.hide_all()
					while gtk.events_pending(): gtk.main_iteration(False)
					self.Zoom_fit_Foto(self,0)		
                                else: self.frame1.show_all()
                        else:pass
			
	def Hide_Exif(self,obj):
		if not self.checkbutton1.get_active():
			self.frame1.hide_all()
			self.checkbutton1.set_active(True)
			self.settings['checkbutton1']=True
			self.toolbutton25.set_icon_widget(self.stock_properties_img)
			self.stock_properties_img.show()
			self.tooltip.set_tip(self.toolbutton25,'Show Exif',None)
			self.exifmodel.clear()
			while gtk.events_pending(): gtk.main_iteration(False)
			self.Zoom_fit_Foto(self,0)
		else:
			self.checkbutton1.set_active(False)
			self.settings['checkbutton1']=False
			if self.toolbutton24.get_active(): self.Full_Exif(self)
			else: self.Add_Dimensions(os.path.splitext(self.list[self.indice])[1],self._label)
			self.frame1.show_all()
			self.toolbutton25.set_icon_widget(self.stock_close_img)
			self.stock_close_img.show()
			self.tooltip.set_tip(self.toolbutton25,'Hide Exif',None)
			while gtk.events_pending(): gtk.main_iteration(False)
			self.Zoom_fit_Foto(self,0)
		
        def Options(self,event):                      #Saves settings
                self.dialog12.show()
                response=self.dialog12.run()
                if response==gtk.RESPONSE_CANCEL or response==gtk.RESPONSE_DELETE_EVENT:
			self.dialog12.hide()
			self.settings['adj_value']=self.oldadj
			self.adj.set_value(self.settings['adj_value'])
                        self.pause=int(self.settings['adj_value'])
                        if self.settings['radiobutton1']:
                                self.radiobutton1.set_active(True)
                                self.width=150
                                self.height=100
                        if self.settings['radiobutton2']:
                                self.radiobutton2.set_active(True)
                                self.width=201
                                self.height=134
                        if self.settings['radiobutton3']:
                                self.radiobutton3.set_active(True)
                                self.width=260
                                self.height=174
			if self.settings['radiobutton6']:
                                self.radiobutton6.set_active(True)
			else:
			   	self.radiobutton7.set_active(True)
			if self.settings['radiobutton8']:
                                self.radiobutton8.set_active(True)
			else:
			   	self.radiobutton9.set_active(True)
                        if self.settings['checkbutton1']:
                                self.checkbutton1.set_active(True)
			else:   self.checkbutton1.set_active(False)
			if self.settings['checkbutton2']:
                                self.checkbutton2.set_active(True)
			else:   self.checkbutton2.set_active(False)
                        if self.settings['checkbutton4']:
                                self.checkbutton4.set_active(True)
			else:   self.checkbutton4.set_active(False)
			if self.settings['checkbutton5']:
                                self.checkbutton5.set_active(True)
			else:   self.checkbutton5.set_active(False)
			if self.settings['checkbutton6']:
                                self.checkbutton6.set_active(True)
			else:   self.checkbutton6.set_active(False)
			if self.settings['checkbutton7']:
                                self.checkbutton7.set_active(True)
			else:   self.checkbutton7.set_active(False)
			if self.settings['checkbutton3']:
                                self.checkbutton3.set_active(True)
			else:   self.checkbutton3.set_active(False)
                        self.ark=self.settings['ark']+'/'
                        self.filechooserbutton1.set_current_folder(self.ark[:-1])
                        self.entry4.set_text(self.ark[:-1])
			self.colorbutton1.set_color(self.gallery_color)
			self.colorbutton2.set_color(self.label_color)
			self.colorbutton3.set_color(self.treeview_color)
			self.colorbutton4.set_color(self.toolbar_color)
			self.colorbutton5.set_color(self.selection_color)
			self.fontbutton1.set_font_name(self.font)
			self.border_color=self.settings['border_color']
			if self.border_color==0xffffffff: self.comboboxentry5.child.set_text('White')
			elif self.border_color==0x00000000: self.comboboxentry5.child.set_text('Black')
			else: self.comboboxentry5.child.set_text('Grey')
			self.spinbutton2.set_value(self.settings['frames'])
			self.spinbutton3.set_value(self.settings['delay'])
			if self.settings['sample']: self.filechooserbutton3.set_filename(self.settings['sample'])
			self.entry9.set_text(str(self.cache_size))
		elif response==-7:
			self.dialog20.show()
			response20=self.dialog20.run()
			if response20==gtk.RESPONSE_CANCEL or response20==gtk.RESPONSE_DELETE_EVENT:
				self.dialog20.hide()
				self.Options(self)
			elif response20==gtk.RESPONSE_OK:
				self.dialog20.hide()
				self.Default_Settings(self)
				self.Options(self)
                elif response==gtk.RESPONSE_OK:
			self.dialog12.hide()
			thread.start_new_thread(self.Cache_Control,())
			self.delay=self.settings['delay']=self.spinbutton3.get_value()
			self.sample=self.settings['sample']=self.filechooserbutton3.get_filename()
			self.font=self.fontbutton1.get_font_name()
			self.font_desc=pango.FontDescription(self.font)
			self.settings['font']=self.font
			self.treeview1.modify_font(self.font_desc)
			self.gallery_color=self.colorbutton1.get_color()
			self.label_color=self.colorbutton2.get_color()
			self.toolbar_color=self.colorbutton4.get_color()
			self.selection_color=self.colorbutton5.get_color()
			self.treeview_color=self.colorbutton3.get_color()
			self.settings['treeview_red']=self.treeview_color.red
			self.settings['treeview_green']=self.treeview_color.green
			self.settings['treeview_blue']=self.treeview_color.blue
			self.settings['label_red']=self.label_color.red
			self.settings['label_green']=self.label_color.green
			self.settings['label_blue']=self.label_color.blue
			self.settings['gallery_red']=self.gallery_color.red
			self.settings['gallery_green']=self.gallery_color.green
			self.settings['gallery_blue']=self.gallery_color.blue
			self.settings['toolbar_red']=self.toolbar_color.red
			self.settings['toolbar_green']=self.toolbar_color.green
			self.settings['toolbar_blue']=self.toolbar_color.blue
			self.settings['selection_red']=self.selection_color.red
			self.settings['selection_green']=self.selection_color.green
			self.settings['selection_blue']=self.selection_color.blue
			self.window1.modify_bg(gtk.STATE_NORMAL,self.toolbar_color)
			self.window2.modify_bg(gtk.STATE_NORMAL,self.toolbar_color)
			self.toolbar1.modify_bg(gtk.STATE_NORMAL,self.toolbar_color)
			self.toolbar2.modify_bg(gtk.STATE_NORMAL,self.toolbar_color)
			self.treeview1.modify_base(gtk.STATE_NORMAL,self.treeview_color)
			self.treeview2.modify_base(gtk.STATE_NORMAL,self.treeview_color)
			self.treeview3.modify_base(gtk.STATE_NORMAL,self.treeview_color)
			if self.radiobutton6.get_active():
                                self.eventbox1.modify_bg(gtk.STATE_NORMAL,self.gallery_color)
                                self.eb.modify_bg(gtk.STATE_NORMAL,self.gallery_color)
                                if self.scrolledwindow2.get_child()!=None:
                                        for i in range(len(self.label)):
                                                self.event[i].modify_bg(gtk.STATE_NORMAL,self.gallery_color)
                                                self.e[i].modify_bg(gtk.STATE_NORMAL,self.gallery_color)
                                                if type(self.label[i])!=int:
                                                        self.label[i].modify_fg(gtk.STATE_NORMAL,self.label_color)
                                                        self.label[i].modify_font(self.font_desc)
                        else:
				try:
                                	self.swin2_label.modify_fg(gtk.STATE_NORMAL,self.label_color)
                                	self.swin2_label.modify_font(self.font_desc)
					self.eventbox9.modify_bg(gtk.STATE_NORMAL,self.gallery_color)
                                	for i in range(self.n):
                                        	self.b_event[i].modify_bg(gtk.STATE_NORMAL,self.gallery_color)
                                	self.b_event[self.indice].modify_bg(gtk.STATE_NORMAL,self.selection_color)
				except: pass
                        self.settings['adj_value']=self.oldadj=self.adj.value
                        self.pause=self.adj.value
                        if self.checkbutton1.get_active():
                                self.settings['checkbutton1']=True
                        else:   self.settings['checkbutton1']=False
			if self.checkbutton2.get_active():
                                self.settings['checkbutton2']=True
                        else:   self.settings['checkbutton2']=False
                        if self.checkbutton3.get_active():
                                self.settings['checkbutton3']=True
                        else:   self.settings['checkbutton3']=False
			if self.checkbutton4.get_active():
                                self.settings['checkbutton4']=True
				border_color=self.comboboxentry5.get_active_text()
				if border_color=='White': self.border_color=0xffffffff
				elif border_color=='Black': self.border_color=0x00000000
				else: self.border_color=0x858585ff
				self.settings['border_color']=self.border_color
                        else:   self.settings['checkbutton4']=False
			if self.checkbutton5.get_active():
                                self.settings['checkbutton5']=True
				self.frames=int(self.spinbutton2.get_value())
				self.settings['frames']=self.frames
                        else:   self.settings['checkbutton5']=False
			if self.checkbutton6.get_active():
                                self.settings['checkbutton6']=True
                        else:   self.settings['checkbutton6']=False
			if self.checkbutton7.get_active():
                                self.settings['checkbutton7']=True
				try:
					self.cache_size=int(self.entry9.get_text())
				except: self.cache_size=50
                        else:   self.settings['checkbutton7']=False
                        if self.radiobutton1.get_active():
                                self.width=150
                                self.height=100
                                self.settings['radiobutton1']=True
                        else:   self.settings['radiobutton1']=False
                        if self.radiobutton2.get_active():
                                self.width=201
                                self.height=134
                                self.settings['radiobutton2']=True
                        else:   self.settings['radiobutton2']=False
                        if self.radiobutton3.get_active():
                                self.width=260
                                self.height=174
                                self.settings['radiobutton3']=True
                        else:   self.settings['radiobutton3']=False
			if self.radiobutton6.get_active():
				self.settings['radiobutton6']=True
				self.settings['radiobutton7']=False
			else:
				self.settings['radiobutton6']=False
				self.settings['radiobutton7']=True
			if self.radiobutton8.get_active():
				self.settings['radiobutton8']=True
				self.settings['radiobutton9']=False
				self.preview_options='-h'
			else:
				self.settings['radiobutton9']=True
				self.settings['radiobutton8']=False
				self.preview_options='-w -h'
			archives=self.filechooserbutton1.get_current_folder()
			if archives!=self.ark[:-1]:
                                f=open(self.ark+'albums.db','w')
                                cPickle.dump(self.albums,f)
                                f.close()
                                self.ark=archives+'/'
                                self.settings['ark']=archives
				self.model.clear()
				self.Load_Album_Database(self)
			
        def Default_Colors(self,event):
                self.colorbutton1.set_color(gtk.gdk.color_parse('#525252'))
                self.colorbutton2.set_color(gtk.gdk.color_parse('#FFFFFF'))
                self.colorbutton3.set_color(gtk.gdk.color_parse('#E2E2E2'))
                self.colorbutton4.set_color(gtk.gdk.color_parse('#969696'))
                self.colorbutton5.set_color(gtk.gdk.color_parse('#CD7300'))

        def Dcraw_Options(self,event):
                self.dialog17.show()
                response=self.dialog17.run()
                if response==gtk.RESPONSE_CANCEL or response==gtk.RESPONSE_DELETE_EVENT:
                        self.dialog17.hide()
                        if self.settings['dcraw_options']=='-w -q 3':
                                self.radiobutton4.set_active(True)
                                self.entry6.set_sensitive(False)
                        else:
                                self.radiobutton5.set_active(True)
                                self.settings['dcraw_options']=self.dcraw_options
                                self.entry6.set_text(self.dcraw_options)
                                self.entry6.set_sensitive(True)
			if self.window6.get_property("visible"):
				self.Show_Convert(self)
			elif self.filechooser2.get_property("visible"):
				self.Save_As_Dialog(self)
                elif response==gtk.RESPONSE_OK:
                        options=self.entry6.get_text()
                        if self.radiobutton5.get_active() and (options.isspace() or options==''):
                                gtk.gdk.beep()
                                self.Dcraw_Options(self)
                        else:
                                self.dialog17.hide()
                                if self.radiobutton4.get_active():
                                        self.settings['dcraw_options']=self.dcraw_options='-w -q 3'
                                elif self.radiobutton5.get_active():
                                        if ' -T' in options:
                                                options=string.replace(options,' -T','')
                                        if ' -4' in options:
                                                options=string.replace(options,' -4','')
                                        self.settings['dcraw_options']=self.dcraw_options=options
                        if self.window6.get_property("visible"):
				self.Show_Convert(self)
			elif self.filechooser2.get_property("visible"):
				self.Save_As_Dialog(self)

        def Show_Convert(self,event):
		self.window6.move(0,0)
		self.progressbar4.hide()
                self.window6.set_title('Convert Selection  (%d files)' % len(self.selected)) 
                self.window6.show()

        def Conversion(self,event):
                dest=self.entry5.get_text()
                extension=self.comboboxentry3.get_active_text()
		if extension=='':
			gtk.gdk.beep()
			self.Show_Convert(self)
			return True
                if '.jpg' in extension:
                        self.dialog16.show()
                        response16=self.dialog16.run()
                        if response16==gtk.RESPONSE_CANCEL or response16==gtk.RESPONSE_DELETE_EVENT:
                                self.dialog16.hide()
                                self.Show_Convert(self)
				return True
                        elif response16==gtk.RESPONSE_OK:
                                self.dialog16.hide()
                                while gtk.events_pending(): gtk.main_iteration(False)
                                self.settings['jpg_quality']=self.jpg_quality.value
				self.progressbar4.show()
                                thread.start_new_thread(self.Convert_as_jpg,(self.selected,self.jpg_quality.value,dest))
                elif '.png' in extension:
			self.progressbar4.show()
                        thread.start_new_thread(self.Convert_as_png,(self.selected,dest))     
                elif '.tiff' in extension and '8 bit' in extension:
			self.progressbar4.show()
                        thread.start_new_thread(self.Convert_as_tiff,(self.selected,8,dest))
                elif '.tiff' in extension and '16 bit' in extension:
			self.progressbar4.show()
                        thread.start_new_thread(self.Convert_as_tiff,(self.selected,16,dest))        
                elif '.bmp' in extension:
			self.progressbar4.show()
                        thread.start_new_thread(self.Convert_as_bmp,(self.selected,dest))      

        def Save_As_Dialog(self,event):
                if self.radiobutton6.get_active() and not self.window2.get_property('visible'):
                        if self.obj in self.event:
                                self.indice=self.event.index(self.obj)
                        elif  self.obj in self.e:
                                self.indice=self.e.index(self.obj)
                format=os.path.splitext(self.list[self.indice])[1]
		if string.lower(format) in self.raw_formats: self.button25.set_sensitive(True)
		else: self.button25.set_sensitive(False)
                if self.version+'Albums/' not in self.window1.get_title() :
                        if string.lower(format) in self.raw_formats: filename=self.rawpath[self.list[self.indice]]
                        else:   filename=self.list[self.indice]
                elif self.version+'Albums/' in self.window1.get_title() :
                        if string.lower(format) in self.raw_formats:
				 filename=string.replace(string.replace(self.list[self.indice],'/thumb',''),'.thumb.jpg','')
                        else:   filename=self.list[self.indice]
		self.entry7.set_text(os.path.basename(filename)[:-len(format)])
		self.filechooser2.move(0,0)
                self.filechooser2.show()
		if self.window2.get_property('visible'): self.filechooser2.set_transient_for(self.window2)
		else: self.filechooser2.set_transient_for(self.window1)
                response=self.filechooser2.run()
                if response==gtk.RESPONSE_CANCEL or response==gtk.RESPONSE_DELETE_EVENT:
                        self.filechooser2.hide()
		elif response==gtk.RESPONSE_APPLY:
                        self.Dcraw_Options(self)
		elif response==-7:
			label=gtk.Label("Loading...")
			self.eventbox2.add(label)
			self.dialog19.show_all()
			self.dialog19.window.set_cursor(self.watch)
			while gtk.events_pending(): gtk.main_iteration(False)
			time.sleep(0.1)
			fname=os.path.basename(filename)[:-len(format)]
			outfile=self.temp+fname+'.tiff'
			os.system('dcraw -c "%s" -T "%s" > "%s" ' %(self.dcraw_options,filename,outfile))
			pixbuf=gtk.gdk.pixbuf_new_from_file_at_size(outfile,400,400)
			label.destroy()
			image=gtk.Image()
			self.eventbox2.add(image)
			image.set_from_pixbuf(pixbuf)
			self.dialog19.show_all()
			while gtk.events_pending(): gtk.main_iteration(False)
			self.dialog19.window.set_cursor(None)
			del pixbuf
			gc.collect()
			response19=self.dialog19.run()
			if response19==-6 or response19==gtk.RESPONSE_DELETE_EVENT:
				self.dialog19.hide()
				image.destroy()
				self.Save_As_Dialog(self)
                elif response==gtk.RESPONSE_OK:
                        fname=self.entry7.get_text()
                        dest=self.filechooser2.get_current_folder()
                        extension=self.comboboxentry4.get_active_text()
			if extension.isspace() or extension=='':
				gtk.gdk.beep()
				self.Save_As_Dialog(self)
                        if '.jpg' in extension:
                                self.dialog16.show()
                                response16=self.dialog16.run()
                                if response16==gtk.RESPONSE_CANCEL or response16==gtk.RESPONSE_DELETE_EVENT:
                                        self.dialog16.hide()
                                        self.Save_As_Dialog(self)
                                elif response16==gtk.RESPONSE_OK:
                                        self.dialog16.hide()
                                        while gtk.events_pending(): gtk.main_iteration(False)
                                        self.settings['jpg_quality']=self.jpg_quality.value
                                        self.Save_as_jpg(fname,filename,self.jpg_quality.value,dest)
                        elif '.png' in extension:
                                self.Save_as_png(fname,filename,dest)        
                        elif '.tiff' in extension and '8 bit' in extension:
                                self.Save_as_tiff(fname,filename,8,dest)
                        elif '.tiff' in extension and '16 bit' in extension:
                                self.Save_as_tiff(fname,filename,16,dest)        
                        elif '.bmp' in extension:
                                self.Save_as_bmp(fname,filename,dest)     
                        self.filechooser2.hide()               
                self.Unselect(self)

        def Conversion_Error(self,item):
                self.label31.set_text('Cannot convert %s'%os.path.split(item)[1])
                self.dialog15.show()
                gtk.gdk.beep()
                response=self.dialog15.run()
                if response==gtk.RESPONSE_CANCEL or response==gtk.RESPONSE_DELETE_EVENT:
                        self.dialog15.hide()

        def Overwrite_Dialog(self,dest,filename):
                filelist=os.listdir(dest)
                if filename in filelist:
                        self.label29.set_text('A file named:\n"%s" already exists.\nDo you want to overwrite it?' % filename)
                        self.dialog18.show()
			gtk.gdk.beep()
                        response=self.dialog18.run()
                        if response==gtk.RESPONSE_CANCEL or response==gtk.RESPONSE_DELETE_EVENT:
                                self.dialog18.hide()
                                return False
                        elif response==gtk.RESPONSE_OK:
                                self.dialog18.hide()
                                return True
		else: return True 
                        

        def Save_as_jpg(self,fname,filename,quality,dest):
                if not self.Overwrite_Dialog(dest,fname+'.jpg'): return True
                self.filechooser2.window.set_cursor(self.watch)
                self.window1.window.set_cursor(self.watch)
                self.window5.set_title('Saving...')
                self.window5.show()
                while gtk.events_pending(): gtk.main_iteration(False)
                format=os.path.splitext(filename)[1]
                if string.lower(format) in self.raw_formats:
                        try:
				self.progressbar2.set_fraction(0.25)
                                while gtk.events_pending(): gtk.main_iteration(False)
                                infile=self.temp+fname+'.tiff'
                                outfile=dest+'/'+fname+'.jpg'
                                status=os.system('dcraw -c "%s" -T "%s" > "%s"'% (self.dcraw_options,filename,infile))
				self.progressbar2.set_fraction(0.5)
                                while gtk.events_pending(): gtk.main_iteration(False)
				pixbuf=gtk.gdk.pixbuf_new_from_file(infile)
				pixbuf.save(outfile, "jpeg", {"quality":str(quality)})
                                self.progressbar2.set_fraction(0.75)
                                while gtk.events_pending(): gtk.main_iteration(False)
                                os.system('exiftool -overwrite_original -TagsFromFile "%s" "%s" '% (filename,outfile))
                                os.remove(infile)
                                self.progressbar2.set_fraction(1)
                                while gtk.events_pending(): gtk.main_iteration(False)
				time.sleep(0.1)
				del pixbuf
				gc.collect()
                        except IOError:
                                self.Conversion_Error(filename)
                else:
                        try:
                                outfile=dest+'/'+fname+'.jpg'
			        pixbuf=gtk.gdk.pixbuf_new_from_file(filename)
                                self.progressbar2.set_fraction(0.25)
                                while gtk.events_pending(): gtk.main_iteration(False)
			        pixbuf.save(outfile, "jpeg", {"quality":str(quality)})
                                self.progressbar2.set_fraction(0.5)
                               	while gtk.events_pending(): gtk.main_iteration(False)
                               	os.system('exiftool -overwrite_original -TagsFromFile "%s" "%s" '% (filename,outfile))
                                self.progressbar2.set_fraction(1)
                                while gtk.events_pending(): gtk.main_iteration(False)
				time.sleep(0.1)
				del pixbuf
				gc.collect()
                        except IOError:
                                self.Conversion_Error(filename)
                                if os.path.isfile(outfile): os.remove(outfile)
                self.window1.window.set_cursor(None)
                self.filechooser2.window.set_cursor(None)
                self.window5.hide()
                self.progressbar2.set_fraction(0)

        def Save_as_png(self,fname,filename,dest):
                if not self.Overwrite_Dialog(dest,fname+'.png'): return True
                self.filechooser2.window.set_cursor(self.watch)
                self.window1.window.set_cursor(self.watch)
                self.window5.set_title('Saving...')
                self.window5.show()
		while gtk.events_pending(): gtk.main_iteration(False)
                format=os.path.splitext(filename)[1]
                if string.lower(format) in self.raw_formats:
                        try:
				self.progressbar2.set_fraction(0.25)
                                while gtk.events_pending(): gtk.main_iteration(False)
                                infile=self.temp+fname+'.tiff'
                                outfile=dest+'/'+fname+'.png'
                                os.system('dcraw -c "%s" -T "%s" > "%s"'% (self.dcraw_options,filename,infile))
				self.progressbar2.set_fraction(0.5)
                                while gtk.events_pending(): gtk.main_iteration(False)
				time.sleep(0.1)
                                pixbuf=gtk.gdk.pixbuf_new_from_file(infile)
				self.progressbar2.set_fraction(0.75)
                                while gtk.events_pending(): gtk.main_iteration(False)
				time.sleep(0.1)
                                pixbuf.save(outfile, "png")
                                os.remove(infile)
                                self.progressbar2.set_fraction(1)
                                while gtk.events_pending(): gtk.main_iteration(False)
				time.sleep(0.1)
				del pixbuf
				gc.collect()
                        except IOError:
                                self.Conversion_Error(filename)
                else:
                        try:
				pixbuf=gtk.gdk.pixbuf_new_from_file(filename)
				self.progressbar2.set_fraction(0.25)
                                while gtk.events_pending(): gtk.main_iteration(False)
                                outfile=dest+'/'+fname+'.png'
                                pixbuf.save(outfile, "png")
                                self.progressbar2.set_fraction(0.5)
                                while gtk.events_pending(): gtk.main_iteration(False)
				time.sleep(0.1)
                                self.progressbar2.set_fraction(0.75)
                                while gtk.events_pending(): gtk.main_iteration(False)
				time.sleep(0.1)
				self.progressbar2.set_fraction(1)
                                while gtk.events_pending(): gtk.main_iteration(False)
				time.sleep(0.1)
                        except IOError:
                                self.Conversion_Error(filename)
                                if os.path.isfile(outfile): os.remove(outfile)
                self.window1.window.set_cursor(None)
		self.filechooser2.window.set_cursor(None)
		self.window5.hide()
                self.progressbar2.set_fraction(0)
		
	def Load_Raw_Preview(self,event):
		self.window2.window.set_cursor(self.watch)
		while gtk.events_pending(): gtk.main_iteration(False)
		format=os.path.splitext(self.list[self.indice])[1]
		if string.lower(format) in self.raw_formats:
                	if self.version+'Albums/' not in self.window1.get_title() :
                        	filename=self.rawpath[self.list[self.indice]]
                	elif self.version+'Albums/' in self.window1.get_title() :
				filename=string.replace(string.replace(self.list[self.indice],'/thumb',''),'.thumb.jpg','')
			fname=os.path.basename(filename)[:-len(format)]
			outfile=self.temp+fname+'.tiff'
			os.system('dcraw -c "%s" -T "%s" > "%s" ' %(self.preview_options,filename,outfile))
			pixbuf=gtk.gdk.pixbuf_new_from_file_at_size(outfile,self.rect.width,self.rect.height)
			self.image1.set_from_pixbuf(pixbuf)
			while gtk.events_pending(): gtk.main_iteration(False)
			del pixbuf
			gc.collect()
		self.window2.window.set_cursor(None)
		self.raw_preview=True
		
        def Save_as_tiff(self,fname,filename,depth,dest):
                if not self.Overwrite_Dialog(dest,fname+'.tiff'): return True
                self.filechooser2.window.set_cursor(self.watch)
                self.window1.window.set_cursor(self.watch)
                self.window5.set_title('Saving...')
                self.window5.show()
		while gtk.events_pending(): gtk.main_iteration(False)
                format=os.path.splitext(filename)[1]
                if string.lower(format) in self.raw_formats:
                        try:
				self.progressbar2.set_fraction(0.25)
				time.sleep(0.1)
                                while gtk.events_pending(): gtk.main_iteration(False)
                                outfile=dest+'/'+fname+'.tiff'
                                if depth==8: os.system('dcraw -c "%s" -T "%s" > "%s" '%(self.dcraw_options, filename,outfile))
                                else:        os.system('dcraw -c "%s" -4 -T "%s" > "%s"'%(self.dcraw_options, filename,outfile))
				self.progressbar2.set_fraction(0.5)
                                while gtk.events_pending(): gtk.main_iteration(False)
                                self.progressbar2.set_fraction(0.75)
                                while gtk.events_pending(): gtk.main_iteration(False)
				time.sleep(0.1)
				os.system('exiftool -overwrite_original --Orientation -TagsFromFile "%s" "%s" '% (filename,outfile))
				self.progressbar2.set_fraction(1)
                                while gtk.events_pending(): gtk.main_iteration(False)
				time.sleep(0.1)
                        except IOError:
                                self.Conversion_Error(filename)
                else:
                        try:
				self.progressbar2.set_fraction(0.25)
                                while gtk.events_pending(): gtk.main_iteration(False)
				time.sleep(0.1)
                        	outfile=dest+'/'+fname+'.tiff'
                                pixbuf=gtk.gdk.pixbuf_new_from_file(filename)
                                self.progressbar2.set_fraction(0.5)
                                while gtk.events_pending(): gtk.main_iteration(False)
                                pixbuf.save(outfile,'tiff')
                                self.progressbar2.set_fraction(0.75)
                                while gtk.events_pending(): gtk.main_iteration(False)
                                os.system('exiftool -overwrite_original --Orientation -TagsFromFile "%s" "%s" '% (filename,outfile))
                                self.progressbar2.set_fraction(1)
                                while gtk.events_pending(): gtk.main_iteration(False)
				time.sleep(0.1)
				del pixbuf
				gc.collect()
                        except IOError:
                                self.Conversion_Error(filename)
                                if os.path.isfile(outfile): os.remove(outfile)
                self.window1.window.set_cursor(None)
                self.filechooser2.window.set_cursor(None)
                self.window5.hide()
                self.progressbar2.set_fraction(0)
                
        def Save_as_bmp(self,fname,filename,dest):
                if not self.Overwrite_Dialog(dest,fname+'.bmp'): return True
                self.filechooser2.window.set_cursor(self.watch)
                self.window1.window.set_cursor(self.watch)
                self.window5.set_title('Saving...')
                self.window5.show()
                while gtk.events_pending(): gtk.main_iteration(False)
                format=os.path.splitext(filename)[1]
                if string.lower(format) in self.raw_formats:
                        try:
				self.progressbar2.set_fraction(0.25)
                                while gtk.events_pending(): gtk.main_iteration(False)
                                infile=self.temp+fname+'.tiff'
                                outfile=dest+'/'+fname+'.bmp'
                                status=os.system('dcraw -c "%s" -T "%s" > "%s"'% (self.dcraw_options,filename,infile))
				self.progressbar2.set_fraction(0.5)
                                while gtk.events_pending(): gtk.main_iteration(False)
				pixbuf=gtk.gdk.pixbuf_new_from_file(infile)
				pixbuf.save(outfile, "bmp")
                                self.progressbar2.set_fraction(0.75)
                                while gtk.events_pending(): gtk.main_iteration(False)
                                os.remove(infile)
                                self.progressbar2.set_fraction(1)
                                while gtk.events_pending(): gtk.main_iteration(False)
				time.sleep(0.1)
				del pixbuf
				gc.collect()
                        except IOError:
                                self.Conversion_Error(filename)
                else:
                        try:
				self.progressbar2.set_fraction(0.25)
                                while gtk.events_pending(): gtk.main_iteration(False)
				time.sleep(0.1)
                                outfile=dest+'/'+fname+'.bmp'
				pixbuf=gtk.gdk.pixbuf_new_from_file(filename)
                                self.progressbar2.set_fraction(0.5)
                                while gtk.events_pending(): gtk.main_iteration(False)
				pixbuf.save(outfile, "bmp")
                                self.progressbar2.set_fraction(0.75)
                                while gtk.events_pending(): gtk.main_iteration(False)
                                time.sleep(0.1)
                                self.progressbar2.set_fraction(1)
                                while gtk.events_pending(): gtk.main_iteration(False)
				time.sleep(0.1)
				del pixbuf
				gc.collect()
                        except IOError:
                                self.Conversion_Error(filename)
                                if os.path.isfile(outfile): os.remove(outfile)
                self.window1.window.set_cursor(None)
                self.filechooser2.window.set_cursor(None)
                self.window5.hide()
                self.progressbar2.set_fraction(0)
                
        def Convert_as_jpg(self,selected,quality,dest):
                gobject.idle_add(self.win6_okbutton.set_sensitive,False)
                gobject.idle_add(self.dcraw_options_button.set_sensitive,False)
                gobject.idle_add(self.win6_cancelbutton.set_label,'Stop')
                gobject.idle_add(self.win6_cancelbutton.set_property,'image',self.stock_stop_img)
                n=0
                fraction=0.99/len(selected)
                for item in selected:
                        if self.Stop_thread.isSet(): break
                        n+=1
                        gobject.idle_add(self.window6.set_title,('Converting %s of %s files...'%(n,len(selected))))
                        format=os.path.splitext(item)[1]
                        if string.lower(format) in self.raw_formats:
                                if self.version+'Albums/' not in self.window1.get_title() :
                                	filename=self.rawpath[item]
                                else:   filename=string.replace(string.replace(item,'/thumb',''),'.thumb.jpg','')
                                try:
                                        infile=self.temp+os.path.split(filename)[1]+'.tiff'
                                        outfile=dest+'/'+os.path.split(filename)[1][:-len(format)]+'.jpg'
                                        os.system('dcraw -c "%s" -T "%s" > "%s"'% (self.dcraw_options,filename,infile))
                                        pixbuf=gtk.gdk.pixbuf_new_from_file(infile)
                                        pixbuf.save(outfile,"jpeg",{"quality":str(int(quality))})
                                        os.system('exiftool -overwrite_original -TagsFromFile "%s" "%s" '% (filename,outfile))
                                        os.remove(infile)
					del pixbuf
					gc.collect()
                                except IOError:
                                        self.Conversion_Error(item)
                        else:
                                try:
                                        outfile=dest+'/'+os.path.split(item)[1][:-len(format)]+'.jpg'
					pixbuf=gtk.gdk.pixbuf_new_from_file(item)
				   	pixbuf.save(outfile,"jpeg",{"quality":str(int(quality))})
                                        os.system('exiftool -overwrite_original -TagsFromFile "%s" "%s" '% (item,outfile))
					del pixbuf
					gc.collect()
                                except IOError:
                                        self.Conversion_Error(item)
                                        if os.path.isfile(outfile): os.remove(outfile)
                        gobject.idle_add(self.progressbar4.set_fraction,(self.progressbar4.get_fraction()+fraction))
			time.sleep(0.1)
		self.window6.hide()
		self.Unselect(self)
                gobject.idle_add(self.progressbar4.set_fraction,0)
                gobject.idle_add(self.win6_okbutton.set_sensitive,True)
                gobject.idle_add(self.dcraw_options_button.set_sensitive,True)
                gobject.idle_add(self.win6_cancelbutton.set_label,'Cancel')
                gobject.idle_add(self.win6_cancelbutton.set_property,'image',self.stock_cancel_img)
		self.Stop_thread.clear()
		
        def Convert_as_png(self,selected,dest):
                gobject.idle_add(self.win6_okbutton.set_sensitive,False)
                gobject.idle_add(self.dcraw_options_button.set_sensitive,False)
                gobject.idle_add(self.win6_cancelbutton.set_label,'Stop')
                gobject.idle_add(self.win6_cancelbutton.set_property,'image',self.stock_stop_img)
                n=0
                fraction=0.99/len(selected)
                for item in selected:
                        if self.Stop_thread.isSet(): break
                        n+=1
                        gobject.idle_add(self.window6.set_title,('Converting %s of %s files...'%(n,len(selected))))
                        format=os.path.splitext(item)[1]
                        if string.lower(format) in self.raw_formats:
                                if self.version+'Albums/' not in self.window1.get_title() :
                                        filename=self.rawpath[item]
                                else:   filename=string.replace(string.replace(item,'/thumb',''),'.thumb.jpg','')
                                try:
                                        infile=self.temp+os.path.split(filename)[1]+'.png'
                                        outfile=dest+'/'+os.path.split(filename)[1][:-len(format)]+'.png'
                                        os.system('dcraw -c "%s" -T "%s" > "%s"'% (self.dcraw_options,filename,infile))
					pixbuf=gtk.gdk.pixbuf_new_from_file(infile)
                                        pixbuf.save(outfile, "png")
                                        os.remove(infile)
					del pixbuf
					gc.collect()
                                except IOError:
                                        self.Conversion_Error(item)
                        else:
                                try:
                                        outfile=dest+'/'+os.path.split(item)[1][:-len(format)]+'.png'
                                        pixbuf=gtk.gdk.pixbuf_new_from_file(item)
                                        pixbuf.save(outfile, "png")
					del pixbuf
					gc.collect()
                                except IOError:
                                        self.Conversion_Error(item)
                                        if os.path.isfile(outfile): os.remove(outfile)
                        gobject.idle_add(self.progressbar4.set_fraction,(self.progressbar4.get_fraction()+fraction))
			time.sleep(0.1)
                self.window6.hide()
		self.Unselect(self)
                gobject.idle_add(self.progressbar4.set_fraction,0)
                gobject.idle_add(self.win6_okbutton.set_sensitive,True)
                gobject.idle_add(self.dcraw_options_button.set_sensitive,True)
                gobject.idle_add(self.win6_cancelbutton.set_label,'Cancel')
                gobject.idle_add(self.win6_cancelbutton.set_property,'image',self.stock_cancel_img)
		self.Stop_thread.clear()
		
        def Convert_as_tiff(self,selected,depth,dest):
                gobject.idle_add(self.win6_okbutton.set_sensitive,False)
                gobject.idle_add(self.dcraw_options_button.set_sensitive,False)
                gobject.idle_add(self.win6_cancelbutton.set_label,'Stop')
                gobject.idle_add(self.win6_cancelbutton.set_property,'image',self.stock_stop_img)
                n=0
                fraction=0.99/len(selected)
                for item in selected:
                        if self.Stop_thread.isSet(): break
                        n+=1
                        gobject.idle_add(self.window6.set_title,('Converting %s of %s files...'%(n,len(selected))))
                        format=os.path.splitext(item)[1]
                        if string.lower(format) in self.raw_formats:
                                if self.version+'Albums/' not in self.window1.get_title() :
                                        filename=self.rawpath[item]
                                else:   filename=string.replace(string.replace(item,'/thumb',''),'.thumb.jpg','')
                                try:
                                        outfile=dest+'/'+os.path.split(filename)[1][:-len(format)]+'.tiff'
                                        if depth==8: os.system('dcraw -c "%s" -T "%s" > "%s"'%(self.dcraw_options,filename,outfile))
                                        else:        os.system('dcraw -c "%s" -4 -T "%s" > "%s"'%(self.dcraw_options,filename,outfile))
					os.system('exiftool -overwrite_original --Orientation -TagsFromFile "%s" "%s" '% (filename,outfile))
                                except IOError:
                                        self.Conversion_Error(item)
                        else:
                                try:
                                        outfile=dest+'/'+os.path.split(item)[1][:-len(format)]+'.tiff'
					pixbuf=gtk.gdk.pixbuf_new_from_file(item)
                                        pixbuf.save(outfile, "tiff")
                                        os.system('exiftool -overwrite_original --Orientation -TagsFromFile "%s" "%s" '% (item,outfile))
					del pixbuf
					gc.collect()
                                except IOError:
                                        self.Conversion_Error(item)
                                        if os.path.isfile(outfile): os.remove(outfile)
                        gobject.idle_add(self.progressbar4.set_fraction,(self.progressbar4.get_fraction()+fraction))
			time.sleep(0.1)
                self.window6.hide()
		self.Unselect(self)
                gobject.idle_add(self.progressbar4.set_fraction,0)
                gobject.idle_add(self.win6_okbutton.set_sensitive,True)
                gobject.idle_add(self.dcraw_options_button.set_sensitive,True)
                gobject.idle_add(self.win6_cancelbutton.set_label,'Cancel')
                gobject.idle_add(self.win6_cancelbutton.set_property,'image',self.stock_cancel_img)
		self.Stop_thread.clear()
		
        def Convert_as_bmp(self,selected,dest):
                gobject.idle_add(self.win6_okbutton.set_sensitive,False)
                gobject.idle_add(self.dcraw_options_button.set_sensitive,False)
                gobject.idle_add(self.win6_cancelbutton.set_label,'Stop')
                gobject.idle_add(self.win6_cancelbutton.set_property,'image',self.stock_stop_img)
                n=0
                fraction=0.99/len(selected)
                for item in selected:
                        if self.Stop_thread.isSet(): break
                        n+=1
                        gobject.idle_add(self.window6.set_title,('Converting %s of %s files...'%(n,len(selected))))
                        format=os.path.splitext(item)[1]
                        if string.lower(format) in self.raw_formats:
                                if self.version+'Albums/' not in self.window1.get_title() :
                                        filename=self.rawpath[item]
                                else:   filename=string.replace(string.replace(item,'/thumb',''),'.thumb.jpg','')
                                try:
					infile=self.temp+os.path.split(filename)[1]+'.tiff'
                                        outfile=dest+'/'+os.path.split(filename)[1][:-len(format)]+'.bmp'
                                        os.system('dcraw -c "%s" -T "%s" > "%s"'% (self.dcraw_options,filename,infile))
                                        pixbuf=gtk.gdk.pixbuf_new_from_file(infile)
                                        pixbuf.save(outfile,"bmp")
                                        os.remove(infile)
					del pixbuf
					gc.collect()
                                except IOError:
                                        self.Conversion_Error(item)
                        else:
                                try:
                                        outfile=dest+'/'+os.path.split(item)[1][:-len(format)]+'.bmp'
					pixbuf=gtk.gdk.pixbuf_new_from_file(item)
                                        pixbuf.save(outfile,"bmp")
					del pixbuf
					gc.collect()
                                except IOError:
                                        self.Conversion_Error(item)
                                        if os.path.isfile(outfile): os.remove(outfile)
                        gobject.idle_add(self.progressbar4.set_fraction,(self.progressbar4.get_fraction()+fraction))
			time.sleep(0.1)
                self.window6.hide()
		self.Unselect(self)
                gobject.idle_add(self.progressbar4.set_fraction,0)
                gobject.idle_add(self.win6_okbutton.set_sensitive,True)
                gobject.idle_add(self.dcraw_options_button.set_sensitive,True)
                gobject.idle_add(self.win6_cancelbutton.set_label,'Cancel')
                gobject.idle_add(self.win6_cancelbutton.set_property,'image',self.stock_cancel_img)
		self.Stop_thread.clear()
		   
        def Statusbar_Push(self,statusbar,context_id,text):
                statusbar.push(context_id,text)

        def Statusbar_Pop(self,statusbar,context_id):
                statusbar.pop(context_id)

        def Set_Statusbar2(self,image_size, filename):
                self.Statusbar_Pop(self.statusbar2,self.context_id2)
		text=' %s                          %.3f kb'% (image_size,os.path.getsize(filename)/1000.0)
		self.Statusbar_Push(self.statusbar2,self.context_id2,text)
		
        def Get_Folder(self,treeview,path,view_column):   #Make a gallery double clicking a  
		self.vpaned2.handler_block(self.id27)     #folder in the directory tree      
                iter0=self.treestore.get_iter(path)      
                n=1
                percorso=self.treestore[path][1]
                while n<len(path):
                        iterparent=self.treestore.iter_parent(iter0)
                        pathparent=self.treestore.get_path(iterparent)
                        percorso=self.treestore[pathparent][1]+'/'+percorso
                        n+=1
			del iter0
			iter0=iterparent.copy()
			del iterparent
                percorso=percorso[1:]
                viewport=self.scrolledwindow2.get_child()
		if viewport!=None:
			viewport.destroy()
			self.cartella=percorso
			self.window1.set_title(self.version+self.cartella)
			self.n=self.Conta_Foto(self)
			if self.n!=0:
				self.Make_Table(self)
				self.Attach_Images(self)
				self.Statusbar_Pop(self.statusbar3,self.context_id3)
				self.Statusbar_Push(self.statusbar3,self.context_id3,\
                                'There are %s images     Total size %f MB'%(self.n,self.total_size/1000000.0))
				if self.radiobutton7.get_active(): self.Make_Bottom_Panel(self)
				else: self.Make_Thumbnails(self.width,self.height)
			else:
				self.Statusbar_Pop(self.statusbar3,self.context_id3)
                                self.Statusbar_Push(self.statusbar3,self.context_id3,'There are %s images'%self.n)
				if self.radiobutton7.get_active(): self.hbox1.destroy()
		else:
			self.cartella=percorso
			self.window1.set_title(self.version+self.cartella)
			self.n=self.Conta_Foto(self)
			if self.n!=0:
				self.Make_Table(self)
				self.Attach_Images(self)
				self.Statusbar_Pop(self.statusbar3,self.context_id3)
				self.Statusbar_Push(self.statusbar3,self.context_id3,\
                                'There are %s images     Total size %f MB'%(self.n,self.total_size/1000000.0))
				if self.radiobutton7.get_active(): self.Make_Bottom_Panel(self)
				else: self.Make_Thumbnails(self.width,self.height)
			else:
				self.Statusbar_Pop(self.statusbar3,self.context_id3)
                                self.Statusbar_Push(self.statusbar3,self.context_id3,'There are %s images'%self.n)
				if self.radiobutton7.get_active(): self.hbox1.destroy()
                self.delete1.set_sensitive(False)
                self.delete_selection1.set_sensitive(False)
                self.add_selection1.set_sensitive(True)
		self.selected=[]
		self.settings['last_folder_path']=self.cartella[:]
		self.settings['switch']='cartella'
       		self.vpaned2.handler_unblock(self.id27)
       		
	def Expand_Rows(self,treeview,iter,path):       #Expands row appending children dynamically
                iter0=iter.copy()
                n=1
                percorso=self.treestore[path][1]
                while n<len(path):
                        iterparent=self.treestore.iter_parent(iter0)
                        pathparent=self.treestore.get_path(iterparent)
                        percorso=self.treestore[pathparent][1]+'/'+percorso
                        n+=1
			del iter0
			iter0=iterparent.copy()
			del iterparent
                percorso=percorso[1:]
                n_children=self.treestore.iter_n_children(iter)
                x=0
                while x<n_children:
                        iterchildren=self.treestore.iter_nth_child(iter,x)
                        pathchildren=self.treestore.get_path(iterchildren)
                        childname=percorso+'/'+self.treestore[pathchildren][1]
                        filelist=glob.glob(childname+'/*')
                        for item in sorted(filelist):
                                if os.path.isdir(item):
                                        self.treestore.append(iterchildren, [self.folderpb,os.path.basename(item)] )
                        x+=1
                self.treeview2.set_model(self.treestore)
		
	def Collapse_Rows(self,treeview,iter,path):
		n_children=self.treestore.iter_n_children(iter)
                x=0
                while x<n_children:
                        iterchildren=self.treestore.iter_nth_child(iter,x)
                        pathchildren=self.treestore.get_path(iterchildren)
                        n_nipoti=self.treestore.iter_n_children(iterchildren)
                        lista=list(pathchildren)
                        n=0
                        lista.append(n)
                        while n<n_nipoti:
                                lista[len(lista)-1]=n_nipoti-1
                                del self.treestore[tuple(lista)]
				n_nipoti-=1
                        x+=1
                self.treeview2.set_model(self.treestore)
		
	def Show_Filechooserdialog1(self,event):
		self.vpaned2.handler_block(self.id27)
		self.filechooser.show()
		response=self.filechooser.run()
		if response==gtk.RESPONSE_CANCEL or response==gtk.RESPONSE_DELETE_EVENT:
			self.filechooser.hide()
		elif response==gtk.RESPONSE_OK:
			viewport=self.scrolledwindow2.get_child()
			if viewport:
				viewport.destroy()
				self.cartella=self.filechooser.get_current_folder()
				self.window1.set_title(self.version+self.cartella)
				self.filechooser.hide()
				while gtk.events_pending(): gtk.main_iteration(False)
				self.n=self.Conta_Foto(self)
				if self.n!=0:
					self.Make_Table(self)
					self.Attach_Images(self)
					self.Statusbar_Pop(self.statusbar3,self.context_id3)
                                        self.Statusbar_Push(self.statusbar3,self.context_id3,\
                                        'There are %s images     Total size %f MB'%(self.n,self.total_size/1000000.0))
                                        if self.radiobutton7.get_active(): self.Make_Bottom_Panel(self)
					else: self.Make_Thumbnails(self.width,self.height)
				else:
                                        self.Statusbar_Pop(self.statusbar3,self.context_id3)
                                        self.Statusbar_Push(self.statusbar3,self.context_id3,'There are %s images'%self.n)
					if self.radiobutton7.get_active(): self.hbox1.destroy()
			else:
				self.cartella=self.filechooser.get_current_folder()
				self.window1.set_title(self.version+self.cartella)
				self.filechooser.hide()
				while gtk.events_pending(): gtk.main_iteration(False)
				self.n=self.Conta_Foto(self)
				if self.n!=0:
					self.Make_Table(self)
					self.Attach_Images(self)
					self.Statusbar_Pop(self.statusbar3,self.context_id3)
                                        self.Statusbar_Push(self.statusbar3,self.context_id3,\
                                        'There are %s images     Total size %f MB'%(self.n,self.total_size/1000000.0))
                                        if self.radiobutton7.get_active(): self.Make_Bottom_Panel(self)
					else: self.Make_Thumbnails(self.width,self.height)
				else:
                                        self.Statusbar_Pop(self.statusbar3,self.context_id3)
                                        self.Statusbar_Push(self.statusbar3,self.context_id3,'There are %s images'%self.n)
					if self.radiobutton7.get_active(): self.hbox1.destroy()
		self.delete1.set_sensitive(False)
		self.delete_selection1.set_sensitive(False)
		self.add_selection1.set_sensitive(True)
		self.selected=[]
		self.settings['last_folder_path']=self.cartella[:]
		self.settings['switch']='cartella'
		self.vpaned2.handler_unblock(self.id27)
		
	def Open_Last_Folder(self,cartella):
		self.Expand_To_Path(cartella)
		self.vpaned2.handler_block(self.id27)            #Opens last visited folder at start
                self.cartella=cartella
                self.window1.set_title(self.version+self.cartella)
		self.n=self.Conta_Foto(self)
		if self.n!=0:
			self.Make_Table(self)
			self.Attach_Images(self)
			self.Statusbar_Pop(self.statusbar3,self.context_id3)
                        self.Statusbar_Push(self.statusbar3,self.context_id3,\
                        'There are %s images     Total size %f MB'%(self.n,self.total_size/1000000.0))
			if self.radiobutton7.get_active(): self.Make_Bottom_Panel(self)
			else: self.Make_Thumbnails(self.width,self.height)
		else:
                        self.Statusbar_Pop(self.statusbar3,self.context_id3)
                        self.Statusbar_Push(self.statusbar3,self.context_id3,'There are %s images'%self.n)
		self.delete1.set_sensitive(False)
		self.delete_selection1.set_sensitive(False)
		self.add_selection1.set_sensitive(True)
		self.selected=[]
		self.settings['last_folder_path']=self.cartella[:]
		self.settings['switch']='cartella'
		self.vpaned2.handler_unblock(self.id27)
		
	def Expand_To_Path(self,folder):
		lista=string.split(folder,'/')
		iter0=self.treestore.get_iter_root()
		iter0=self.treestore.iter_nth_child(iter0,0)
		for item in lista[1:]:
			value=''
                	while value!=item:
                		value=self.treestore.get_value(iter0,1)
                        	if value==item:break
                        	iter0=self.treestore.iter_next(iter0)
			path0=self.treestore.get_path(iter0)
			self.treeview2.expand_to_path(path0)
			iter0=self.treestore.iter_nth_child(iter0,0)
		column=self.treeview2.get_column(len(lista))
		self.treeview2.scroll_to_cell(path0,column,True,0.5,0.0)
		
	def Album_Control(self,event):                 #Controls for new files on album directory
                files=os.listdir(self.ark+self.album)
                filelist=[]
                for item in files:
			if item=='_preview_.png': continue
                        format=os.path.splitext(item)[1]
                        if string.lower(format) in self.raw_formats:
                                filelist.append(self.ark+self.album+'/thumb/'+item[:-len(format)]+'.thumb.jpg'+format)
                        elif string.lower(format) in self.formats:
                                filelist.append(self.ark+self.album+'/'+item)
                        else:   continue
                if len(filelist)==len(self.albums[self.album]):
                        pass
                else:
                        self.label8.set_text('Attention! The %s archives has been modified!\nDo you want to update the album?'%self.album)
                        self.dialog14.show()
                        gtk.gdk.beep()
                        response=self.dialog14.run()
                        if response==gtk.RESPONSE_CANCEL or response==gtk.RESPONSE_DELETE_EVENT:
                                self.dialog14.hide()
                        elif response==gtk.RESPONSE_OK:
                                self.dialog14.hide()
                                self.albums[self.album]=[]
                                self.albums[self.album]=filelist

        def Open_Last_Album(self,album):                #Opens last visited album at start
                try:
                        self.Expand_To_Path(self.settings['last_folder_path'])
		except: pass
                self.album=album
                self.Album_Control(self)
		self.Make_Album_Gallery(self)
                self.delete1.set_sensitive(True)
		self.delete_selection1.set_sensitive(True)
                self.add_selection1.set_sensitive(True)
		self.selected=[]
		self.settings['last_album_path']=self.album[:]
		self.settings['switch']='album'                        
                                
	def Show_Album(self,treeview,path,column):      #Make gallery double clicking the album name.
                iter=self.model.get_iter(path)
		self.album=self.model.get_value(iter,1)
		self.Album_Control(self)
		self.Make_Album_Gallery(self)
                self.delete1.set_sensitive(True)
		self.delete_selection1.set_sensitive(True)
                self.add_selection1.set_sensitive(True)
		self.selected=[]
		self.settings['last_album_path']=self.album[:]
		self.settings['switch']='album'
		
	def Make_Album_Gallery(self,event):
		self.vpaned2.handler_block(self.id27)
		self.window1.set_title(self.version+'Albums/'+self.album)
                self.n=len(self.albums[self.album])
		files=self.albums[self.album]
		self.list=[]
		self.total_size=0
		for infile in files:
                        format=os.path.splitext(infile)[1]
			if string.lower(format) in self.formats:
				self.list.append(infile)
				self.total_size+=os.path.getsize(infile)
			elif string.lower(format) in self.raw_formats:
				self.list.append(infile)
				f=string.replace(string.replace(infile,'thumb/',''),'.thumb.jpg','')
				self.total_size+=os.path.getsize(f)
		self.n=len(self.list)
                if self.n>0:
                        viewport=self.scrolledwindow2.get_child()
                        if viewport:
                                viewport.destroy()
                                self.Make_Table(self)
                                self.Attach_Images(self)
                                self.Statusbar_Pop(self.statusbar3,self.context_id3)
				self.Statusbar_Push(self.statusbar3,self.context_id3,\
                                'There are %s images     Total size %f MB'%(self.n,self.total_size/1000000.0))
				if self.radiobutton7.get_active(): self.Make_Bottom_Panel(self)
				else: self.Make_Thumbnails(self.width,self.height)
                        else:
                                self.Make_Table(self)
                                self.Attach_Images(self)
                                self.Statusbar_Pop(self.statusbar3,self.context_id3)
				self.Statusbar_Push(self.statusbar3,self.context_id3,\
                                'There are %s images     Total size %f MB'%(self.n,self.total_size/1000000.0))
				if self.radiobutton7.get_active(): self.Make_Bottom_Panel(self)
				else: self.Make_Thumbnails(self.width,self.height)
                else:
			if self.radiobutton7.get_active(): self.hbox1.destroy()
			viewport=self.scrolledwindow2.get_child()
			if viewport:
				viewport.destroy()	  
				self.Statusbar_Pop(self.statusbar3,self.context_id3)
                        	self.Statusbar_Push(self.statusbar3,self.context_id3,'There are 0 images')
			else:
				self.Statusbar_Pop(self.statusbar3,self.context_id3)
                        	self.Statusbar_Push(self.statusbar3,self.context_id3,'There are 0 images')
                self.vpaned2.handler_unblock(self.id27)
		
	def Open(self,event):
		self.treeiter=self.model.get_iter(self.path)
                self.album=self.model.get_value(self.treeiter,1)
                self.Album_Control(self)
                self.Make_Album_Gallery(self)
		self.delete1.set_sensitive(True)
                self.delete_selection1.set_sensitive(True)
                self.add_selection1.set_sensitive(True)
                self.settings['last_album_path']=self.album[:]
		self.settings['switch']='album'

        def Open_Album(self,event):
                self.dialog3.set_title('Open Album')
                self.label4.set_text('Choose the album to open')
                self.dialog3.show()
		response=self.dialog3.run()
		if response==gtk.RESPONSE_CANCEL or response==gtk.RESPONSE_DELETE_EVENT: self.dialog3.hide()
		elif response==gtk.RESPONSE_OK:
                        self.album=self.comboboxentry1.get_active_text()
                        if self.album=='': self.dialog3.hide()
                        else:
                                self.dialog3.hide()
                                self.Album_Control(self)
                                self.Make_Album_Gallery(self)
                self.delete1.set_sensitive(True)
                self.delete_selection1.set_sensitive(True)
                self.add_selection1.set_sensitive(True)
		self.selected=[]
		self.settings['last_album_path']=self.album[:]
		self.settings['switch']='album'
                
	def Add_Album(self,event,data):			#Makes a new album 
		self.entry1.grab_focus()                            
                self.dialog1.show()
		response=self.dialog1.run()
		if response==gtk.RESPONSE_CANCEL or response==gtk.RESPONSE_DELETE_EVENT:
			self.dialog1.hide()
			self.entry1.set_text('')
                        if data=='button':
				self.Add_Selection(self)
				return False
		elif response==gtk.RESPONSE_OK:
                        self.added_album=self.entry1.get_text()
			if self.added_album.isspace() or self.added_album=='':
			 	self.dialog1.hide()
                        	if data=='button':
					self.Add_Selection(self)
					return False
                        elif self.albums.has_key(self.added_album):
                                gtk.gdk.beep()
                                self.dialog2.show()
                                response=self.dialog2.run()
                                if response==gtk.RESPONSE_CLOSE or response==gtk.RESPONSE_DELETE_EVENT:
                                        self.dialog2.hide()
                                        self.Add_Album(self,event)
                        else:
                                os.mkdir(self.ark+self.added_album)
                                os.mkdir(self.ark+self.added_album+'/thumb')
                                self.albums[self.added_album]=[]
                                self.model.append([gtk.gdk.pixbuf_new_from_file('icons/no_preview.png'),self.added_album])
                                self.treeview1.set_model(self.model)
                                self.boxmodel.append([self.added_album])
                                self.comboboxentry1.set_model(self.boxmodel)
                                self.boxmodel2.append([self.added_album])
                                self.comboboxentry2.set_model(self.boxmodel2)
                                if self.comboboxentry1.get_text_column()!=0: self.comboboxentry1.set_text_column(0)
                                if self.comboboxentry2.get_text_column()!=0: self.comboboxentry2.set_text_column(0)
                                self.dialog1.hide()
				self.entry1.set_text('')
			return True
		
	def Delete(self,event):                                 #Deletes the album       
		self.treeiter=self.model.get_iter(self.path)
                album=self.model.get_value(self.treeiter,1)
                self.dialog10.set_title('Delete Album')
                self.label9.set_text('Are you shure to delete\n %s ?' % album)
                self.dialog10.show()
                response=self.dialog10.run()
		if response==gtk.RESPONSE_CANCEL or response==gtk.RESPONSE_DELETE_EVENT: self.dialog10.hide()
		elif response==gtk.RESPONSE_OK:
                        if album in self.window1.get_title():
                                        viewport=self.scrolledwindow2.get_child()
					if viewport:
						viewport.destroy()
						self.Statusbar_Pop(self.statusbar3,self.context_id3)
                                                self.Statusbar_Push(self.statusbar3,self.context_id3,'There are 0 images')
					else:pass 
					if self.radiobutton7.get_active():
						self.hbox1.destroy()
						del self.b_event
						gc.collect()       
                        iter0=self.model.get_iter_first()
                        value=''
                        while value!=album:
                                value=self.model.get_value(iter0,1)
                                if value==album:break
                                iter0=self.model.iter_next(iter0)
                        self.model.remove(iter0)
                        self.treeview1.set_model(self.model)
                        iter1=self.boxmodel.get_iter_root()
                        value=''
                        while value!=album:
                                value=self.boxmodel.get_value(iter1,0)
                                if value==album:break
                                iter1=self.boxmodel.iter_next(iter1)
                        self.boxmodel.remove(iter1)
                        self.comboboxentry1.set_model(self.boxmodel)
                        self.boxentry.set_text('')
                        iter1=self.boxmodel2.get_iter_root()
                        value=''
                        while value!=album:
                                value=self.boxmodel2.get_value(iter1,0)
                                if value==album:break
                                iter1=self.boxmodel2.iter_next(iter1)
                        self.boxmodel2.remove(iter1)
                        self.comboboxentry2.set_model(self.boxmodel2)
                        self.dialog10.hide()
                        del self.albums[album]
                        shutil.rmtree(self.ark+album,ignore_errors=True)
                        while gtk.events_pending(): gtk.main_iteration(False)
			self.n=0
			self.list=[]
                                        	
        def Delete_Album(self,event):                                   
                self.dialog3.set_title('Delete Album')
                self.label4.set_text('Choose the album to delete!')
                self.dialog3.show()
		response=self.dialog3.run()
		if response==gtk.RESPONSE_CANCEL or response==gtk.RESPONSE_DELETE_EVENT: self.dialog3.hide()
		elif response==gtk.RESPONSE_OK:
                        album=self.comboboxentry1.get_active_text()
                        if album=='':   self.dialog3.hide()
                        else:
                                if album in self.window1.get_title():
                                        viewport=self.scrolledwindow2.get_child()
					if viewport:
						viewport.destroy()
						self.Statusbar_Pop(self.statusbar3,self.context_id3)
                                                self.Statusbar_Push(self.statusbar3,self.context_id3,'There are 0 images')
					else:pass
					if self.radiobutton7.get_active:
						self.hbox1.destroy()
						del self.b_event
						gc.collect()                 
                                iter0=self.model.get_iter_first()
                                value=''
                                while value!=album:
                                        value=self.model.get_value(iter0,1)
                                        if value==album:break
                                        iter0=self.model.iter_next(iter0)
                                self.model.remove(iter0)
                                self.treeview1.set_model(self.model)
                                iter1=self.boxmodel.get_iter_root()
                                value=''
                                while value!=album:
                                        value=self.boxmodel.get_value(iter1,0)
                                        if value==album:break
                                        iter1=self.boxmodel.iter_next(iter1)
                                self.boxmodel.remove(iter1)
                                self.comboboxentry1.set_model(self.boxmodel)
                                self.boxentry.set_text('')
                                iter1=self.boxmodel2.get_iter_root()
                                value=''
                                while value!=album:
                                        value=self.boxmodel2.get_value(iter1,0)
                                        if value==album:break
                                        iter1=self.boxmodel2.iter_next(iter1)
                                self.boxmodel2.remove(iter1)
                                self.comboboxentry2.set_model(self.boxmodel2)
                                self.dialog3.hide()
                                del self.albums[album]
                                shutil.rmtree(self.ark+album,ignore_errors=True)
                                while gtk.events_pending(): gtk.main_iteration(False)
				self.n=0
				self.list=[]
        
        def Rename(self,event):                                        
		self.treeiter=self.model.get_iter(self.path)
                album=self.model.get_value(self.treeiter,1)
                self.label10.set_text('Insert a new name for\n %s' % album)
		self.entry2.grab_focus()
                self.dialog11.show()
                response=self.dialog11.run()
		if response==gtk.RESPONSE_CANCEL or response==gtk.RESPONSE_DELETE_EVENT: self.dialog11.hide()
		elif response==gtk.RESPONSE_OK:
                        new_name=self.entry2.get_text()
			if new_name.isspace() or new_name=='':  self.dialog11.hide()
                        elif self.albums.has_key(new_name):
                                gtk.gdk.beep()
                                self.dialog2.show()
                                response=self.dialog2.run()
                                if response==gtk.RESPONSE_CLOSE or response==gtk.RESPONSE_DELETE_EVENT:
                                        self.dialog2.hide()
                                        self.Rename(self)
                        else:
                        	self.dialog11.hide()
                        	self.entry2.set_text('')
                        	temp=self.albums[album]
				os.rename(self.ark+album,self.ark+new_name)
				del self.albums[album]
				n=0
				while n<len(temp):
					item=temp[0]
					del temp[0]
					temp.append(string.replace(item,self.ark+album,self.ark+new_name))
					n+=1
				self.albums[new_name]=temp
                        	self.model.remove(self.treeiter)
                        	iter1=self.boxmodel.get_iter_root()
                        	value=''
                        	while value!=album:
                                	value=self.boxmodel.get_value(iter1,0)
                                	if value==album:break
                                	iter1=self.boxmodel.iter_next(iter1)
                        	self.boxmodel.remove(iter1)
                        	self.boxentry.set_text('')
                        	iter1=self.boxmodel2.get_iter_root()
                        	value=''
                       		while value!=album:
                                	value=self.boxmodel2.get_value(iter1,0)
                                	if value==album:break
                                	iter1=self.boxmodel2.iter_next(iter1)
                        	self.boxmodel2.remove(iter1)
                        	try:
                                        self.model.append([gtk.gdk.pixbuf_new_from_file(self.ark+new_name+'/_preview_.png'),new_name])
                                except:
                                        self.model.append([gtk.gdk.pixbuf_new_from_file('icons/no_preview.png'),new_name])
				self.boxmodel.append([new_name])
				self.boxmodel2.append([new_name])
                        	self.comboboxentry1.set_model(self.boxmodel)
                        	self.comboboxentry2.set_model(self.boxmodel2)
				self.treeview1.set_model(self.model)

	def Set_Panel(self,event,data):         # Hides and shows the left panel
		self.vpaned2.handler_block(self.id27)
		if self.scrolledwindow6: self.scrolledwindow6.destroy()
		if data=='hide':
                	self.hpaned1.set_position(0)
			self.close_panel=False
		elif data=='show':
			self.hpaned1.set_position(int(gtk.gdk.screen_width()*0.15))
		if self.radiobutton7.get_active():
                	viewport=self.scrolledwindow2.get_child()
			if viewport:
				viewport.destroy()
				if self.n!=0:
					self.Make_Table(self)
					self.Attach_Images(self)
					self.Make_Thumbnails(self.width,self.height)
				else: pass
			else:pass
		self.vpaned2.handler_unblock(self.id27)
		self.radiobutton6.set_active(True)
		self.settings['radiobutton6']=True
		self.settings['radiobutton7']=False
		
	def Hide_Pane(self,event):
		if self.radiobutton6.get_active():
			self.close_panel=True
			self.vpaned2.handler_block(self.id27)	
			self.hpaned1.set_position(0)
			self.vpaned2.handler_unblock(self.id27)
			self.Make_Bottom_Panel(self)
		else:	
			self.vpaned2.handler_block(self.id27)	
			self.hpaned1.set_position(0)
			self.vpaned2.handler_unblock(self.id27)
		
				                                   
	def Enlarge_Gallery(self,event):
                if self.radiobutton7.get_active():
			self.Zoom_out_Foto(self,1)
			return True
		if self.width==260: return True
		viewport=self.scrolledwindow2.get_child()
		if viewport:
			viewport.destroy()
			if self.n!=0:
				if self.width==150:
					self.width=201
					self.height=134
				elif self.width==201:
					self.width=260
					self.height=174 
				self.Make_Table(self)
				self.Attach_Images(self)
				self.Make_Thumbnails(self.width,self.height)
			else: pass
		else:pass
		gc.collect()
              	
	def Reduce_Gallery(self,event):
                if self.radiobutton7.get_active():
			self.Zoom_in_Foto(self,1)
			return True
		if self.width==150: return True
		viewport=self.scrolledwindow2.get_child()
		if viewport:
			viewport.destroy()
			if self.n!=0:
				if self.width==260:
					self.width=201
					self.height=134
				elif self.width==201:
					self.width=150
					self.height=100 
				self.Make_Table(self)
				self.Attach_Images(self)
				self.Make_Thumbnails(self.width,self.height)
			else: pass
		else:pass
		gc.collect()
              		
	def Select_All(self,event):
                viewport=self.scrolledwindow2.get_child()
		if viewport:
			for indice in range(self.n):
                                label=self.e[indice].get_child()
                                filename=label.get_text()
                                format=os.path.splitext(filename)[1]
                        	if self.version+'Albums/' not in self.window1.get_title():
                                        if string.lower(format) not in self.raw_formats:
                                                filename=self.cartella+'/'+filename
                                                if filename not in self.selected:
                                                        self.e[indice].modify_bg(gtk.STATE_NORMAL,self.selection_color)
                                                        self.selected.append(filename)
                                        else:
                                                filename=self.temp+filename[:-len(format)]+'.thumb.jpg'+format
                                                if filename not in self.selected:
                                                        self.e[indice].modify_bg(gtk.STATE_NORMAL,self.selection_color)
                                                        self.selected.append(filename)

                        	else:
                               		for item in self.albums[self.album]:    
                                        	if string.lower(format) in self.raw_formats:
                                                        if filename[:-len(format)] in item:
                                                                filename=item[:]
                                                                break
                                                elif filename in item:
                                                        filename=item[:]
                                                        break
                                                else:continue
                                	if filename not in self.selected:
                                        	self.e[indice].modify_bg(gtk.STATE_NORMAL,self.selection_color)
                                        	self.selected.append(filename)
                                	else:pass
                else:pass

        def Unselect(self,event):
                if len(self.selected)>0:
                        for indice in range(self.n): self.e[indice].modify_bg(gtk.STATE_NORMAL,self.colorbutton1.get_color())
                        self.selected=[]
                else: pass

        def Inverted_Selection(self,event):    
                if len(self.selected)==0: self.Select_All(self)
                else:
                        selected=self.selected[:]
                        self.Select_All(self)
                        for item in selected:
                                format=os.path.splitext(item)[1]
                                if string.lower(format) in self.raw_formats:
                                        filename=string.replace(os.path.split(item)[1],'.thumb.jpg','')
                                else:  filename=os.path.split(item)[1]
                                for indice in range(self.n):
                                        label=self.e[indice].get_child()
                                        fname=label.get_text()
                                        if fname==filename:
                                                self.e[indice].modify_bg(gtk.STATE_NORMAL,self.colorbutton1.get_color())
                                                del self.selected[self.selected.index(item)]
                                                break
                                        else: continue
                                                                	
	def Fullscreen(self,*obj):
		if not self.n: return True
		if not self.window2.get_property('visible'):
			if self.radiobutton6.get_active(): self.indice=0
			indice=self.indice
			self.old_indice=indice
		self.fullpbindex=1
		self.window3.set_size_request(gtk.gdk.screen_width(),gtk.gdk.screen_height())
		self.window3.fullscreen()
		width,height=self.window3.get_size()
		format=os.path.splitext(self.list[self.indice])[1]
		if string.lower(format) in self.raw_formats:
			self.fullpblist[1] = gtk.gdk.pixbuf_new_from_file_at_size(self.list[self.indice][:-len(format)],\
			width,height)
		else:
			self.fullpblist[1] = gtk.gdk.pixbuf_new_from_file_at_size(self.list[self.indice],\
			width,height)
		self.image2.set_from_pixbuf(self.fullpblist[1])
		self.window3.show_all()
		while gtk.events_pending():  gtk.main_iteration(False)
		gc.collect()
		thread.start_new_thread(self.Load_Cache,(width,height,'fullscreen'))

	def Play(self,*data):           # starts the player
		options=['-q']
		for i in range(30):options.append(self.sample)
		options+=["-t","ossdsp","-w","-s","/dev/dsp"]
                self.pid=os.fork()
                if self.pid==0:
			try:
                		os.execvp("sox",options)
			except:  print 'Error trying to execute sox'
                elif self.pid>0: pass
                else: print ' fork error'

	def Slideshow(self,*data):
		if self.list:
			if len(data)==3:
				if self.radiobutton6.get_active(): self.indice=0
				self.loop=data[1]
				indice=self.indice
				self.old_indice=indice
				if self.checkbutton6.get_active() and self.sample:
					self.Play(self,*data)
			if len(data)==2:
				self.loop=data[1]
				indice=self.indice
				self.win2_indice=indice
				if self.checkbutton6.get_active() and self.sample:
					self.Play(self,*data)
			if self.loop!=0:
				self.window4.set_size_request(gtk.gdk.screen_width(),gtk.gdk.screen_height())
				self.window4.fullscreen()
				width,height=self.window4.get_size()
				if not self.pixbuf1 or not self.checkbutton5.get_active():
					format=os.path.splitext(self.list[self.indice])[1]
					if string.lower(format) in self.raw_formats:
                                		self.pixbuf1=gtk.gdk.pixbuf_new_from_file_at_size(self.list[self.indice]\
						[:-len(format)],width,height)
                        		else:   self.pixbuf1=gtk.gdk.pixbuf_new_from_file_at_size(self.list[self.indice],\
					width,height)
					width1=self.pixbuf1.get_width()
                			height1=self.pixbuf1.get_height()
                			nero=self.background.copy()
					if self.pixbuf1.get_has_alpha():
						nero=nero.add_alpha(False,chr(255),chr(255),chr(255))
                			self.pixbuf1.copy_area(0,0,width1,height1,nero,(width-width1)/2,(height-height1)/2)
                			self.pixbuf1=nero.copy()
                			del nero
					gc.collect()
				self.image4.set_from_pixbuf(self.pixbuf1)
				self.window4.show_all()
				while gtk.events_pending():  gtk.main_iteration(False)
				t1=time.time()
				if self.indice==len(self.list)-1: self.indice=-1
				format=os.path.splitext(self.list[self.indice+1])[1]
				if string.lower(format) in self.raw_formats:
                                	pixbuf2 =gtk.gdk.pixbuf_new_from_file_at_size(self.list[self.indice+1][:-len(format)],\
                                	width,height)
                        	else:   pixbuf2 = gtk.gdk.pixbuf_new_from_file_at_size(self.list[self.indice+1],width,height)
				while gtk.events_pending():  gtk.main_iteration(False)
                                t2=time.time()
                                delay=t2-t1
                                pause=self.pause
                                if delay>pause: delay=pause
				for i in range(100):
					time.sleep((pause-delay)/100.0)
					while gtk.events_pending():  gtk.main_iteration(False)
					if self.loop==0:
						self.pixbuf1=0
						del pixbuf2
						gc.collect()
						return True 
				if self.checkbutton5.get_active():
                                        self.pixbuf1=self.Transition(self.pixbuf1,pixbuf2,width,height,\
					self.pixbuf1.get_width(),self.pixbuf1.get_height())
                                        if not self.pixbuf1: return True
				self.image4.set_from_pixbuf(pixbuf2)
				self.window4.show_all()
				while gtk.events_pending():  gtk.main_iteration(False)
				del pixbuf2
				gc.collect()
				self.indice+=1
				if self.indice>=len(self.list)-1: self.indice=-1
				gobject.timeout_add(1, self.Slideshow)
			else:
				self.pixbuf1=0
				gc.collect()

	def Transition(self,pixbuf1,pixbuf2,width,height,width1,height1):
                width2=pixbuf2.get_width()
		height2=pixbuf2.get_height()
                nero=self.background.copy()
		if pixbuf2.get_has_alpha():
			nero=nero.add_alpha(False,chr(255),chr(255),chr(255))
		pixbuf2.copy_area(0,0,width2,height2,nero,(width-width2)/2,(height-height2)/2)
		pixbuf2=nero.copy()
		del nero
		gc.collect()
		n=255/self.frames
		alpha=255-n
		for i in range(self.frames):
			if self.loop==0:
				pixbuf1=0
				gc.collect()
				return pixbuf1
			transition=pixbuf2.copy()
			pixbuf1.composite(transition,0,0,width1,height1,0,0,1.0,1.0,\
			gtk.gdk.INTERP_BILINEAR,alpha)
			self.image4.set_from_pixbuf(transition)
			self.window4.show_all()
			while gtk.events_pending():  gtk.main_iteration(False)
			alpha-=n
			pixbuf1=transition.copy()
			time.sleep(self.delay)
		del transition
		gc.collect()
		return pixbuf2
				
	def First_Foto(self,event):
		if not self.lock.locked():
			self.lock.acquire()
                	self.pbindex=1
                	self.indice=0
			format=os.path.splitext(self.list[self.indice])[1]
                	self.Set_Image1(format)
                	while gtk.events_pending():  gtk.main_iteration(False)
       			self.Add_Dimensions(format,self._label)
       			self.count=0
       			while gtk.events_pending(): gtk.main_iteration(False)
       			thread.start_new_thread(self.Cache_Pixbuf,(self.pbindex+1,self.indice+1))
		gc.collect()
		
	def First_b_Foto(self,event):
		if not self.lock2.locked() and self.n>0:
			self.lock2.acquire()
                	self.pixindex=1
                	self.indice=0
			for i in range(self.n):
                        	self.b_event[i].modify_bg(gtk.STATE_NORMAL,self.gallery_color)
			self.b_event[self.indice].modify_bg(gtk.STATE_NORMAL,self.selection_color)
			while gtk.events_pending(): gtk.main_iteration(False)
			format=os.path.splitext(self.list[self.indice])[1]
                	self.Set_Image2(format)
                	while gtk.events_pending():  gtk.main_iteration(False)
       			self.count=0
       			while gtk.events_pending(): gtk.main_iteration(False)
       			thread.start_new_thread(self.Cache_b_Pixbuf,(self.pixindex+1,self.indice+1))
		gc.collect()

        def Set_Image1(self,format):
		if string.lower(format) in self.raw_formats:
                        self._label=string.replace(os.path.split(self.list[self.indice])[1],'.thumb.jpg','')
                        self.window2.set_title(self.window1.get_title()+'/'+ self._label)
                        self.pblist[1] = gtk.gdk.pixbuf_new_from_file_at_size(self.list[self.indice][:-len(format)],\
                        self.rect.width,self.rect.height)
		else:
                        self._label=os.path.split(self.list[self.indice])[1]
                        self.window2.set_title(self.window1.get_title()+'/'+ self._label)
                        self.pblist[1] = gtk.gdk.pixbuf_new_from_file_at_size(self.list[self.indice],\
                        self.rect.width,self.rect.height)
		self.pblist[1]=self.Check_Icons(format,self.pblist[1])
                self.image1.set_from_pixbuf(self.pblist[1])
		while gtk.events_pending(): gtk.main_iteration(False)
		gc.collect()
		self.raw_preview=False
		
	def Set_Image2(self,format):
		if string.lower(format) in self.raw_formats:
                        self._label=string.replace(os.path.split(self.list[self.indice])[1],'.thumb.jpg','')
                        self.b_pixlist[1] = gtk.gdk.pixbuf_new_from_file_at_size(self.list[self.indice][:-len(format)],\
                        self.rect2.width,self.rect2.height-self.swin2_label.allocation.height)
		else:
                        self._label=os.path.split(self.list[self.indice])[1]
                        self.b_pixlist[1] = gtk.gdk.pixbuf_new_from_file_at_size(self.list[self.indice],\
                        self.rect2.width,self.rect2.height-self.swin2_label.allocation.height)
		self.b_pixlist[1]=self.Check_Icons(format,self.b_pixlist[1])
                self.swin2_image.set_from_pixbuf(self.b_pixlist[1])
		while gtk.events_pending(): gtk.main_iteration(False)
		gc.collect()
               
	def Set_Pixbuf(self,format,pbindex):
                if string.lower(format) in self.raw_formats:
                        self._label=string.replace(os.path.split(self.list[self.indice])[1],'.thumb.jpg','')
                        self.window2.set_title(self.window1.get_title()+'/'+ self._label)
		else:
                        self._label=os.path.split(self.list[self.indice])[1]
                        self.window2.set_title(self.window1.get_title()+'/'+ self._label)
		self.pblist[pbindex]=self.Check_Icons(format,self.pblist[pbindex])
		self.image1.set_from_pixbuf(self.pblist[pbindex])
		while gtk.events_pending(): gtk.main_iteration(False)
		if self.pblist[pbindex].get_width()!=self.rect.width: self.Zoom_fit_Foto(self,0)
		self.raw_preview=False
		
	def Set_b_Pixbuf(self,format,pixindex):
		self.b_pixlist[pixindex]=self.Check_Icons(format,self.b_pixlist[pixindex])
		self.swin2_image.set_from_pixbuf(self.b_pixlist[pixindex])
		self.swin2_label.set_text(self.label[self.indice].get_text())
		while gtk.events_pending(): gtk.main_iteration(False)
		if self.b_pixlist[pixindex].get_width()!=self.rect2.width: self.Zoom_fit_Foto(self,1)
                        
	def Cache_Pixbuf(self,pbindex,indice):                  # Preloads pixbuf on detailed window
		if indice in range(self.n):
			if pbindex>2:   pbindex=0
			if pbindex<0: pbindex=2
			format=os.path.splitext(self.list[indice])[1]
			if string.lower(format) in self.raw_formats:	
                		self.pblist[pbindex]=gtk.gdk.pixbuf_new_from_file_at_size(self.list[indice][:-len(format)],\
				self.rect.width,self.rect.height)
			else:
				self.pblist[pbindex]=gtk.gdk.pixbuf_new_from_file_at_size(self.list[indice],\
				self.rect.width,self.rect.height)
		self.lock.release()
		gc.collect()

	def Cache_b_Pixbuf(self,pixindex,indice):                  # Preloads pixbuf on detailed window
		if indice in range(self.n):
			if pixindex>2:   pixindex=0
			if pixindex<0: pixindex=2
			format=os.path.splitext(self.list[indice])[1]
			if string.lower(format) in self.raw_formats:	
                		self.b_pixlist[pixindex]=gtk.gdk.pixbuf_new_from_file_at_size(self.list[indice]\
                                [:-len(format)],self.rect2.width,self.rect2.height-self.swin2_label.allocation.height)
			else:
				self.b_pixlist[pixindex]=gtk.gdk.pixbuf_new_from_file_at_size(self.list[indice],\
				self.rect2.width,self.rect2.height-self.swin2_label.allocation.height)
		self.lock2.release()
		gc.collect()
		
	def Cache_Fullpixbuf(self,fullpbindex,indice):          # Preloads pixbuf on fullscreen mode
		if indice in range(self.n):
			if fullpbindex>2:   fullpbindex=0
			elif fullpbindex<0: fullpbindex=2
			format=os.path.splitext(self.list[indice])[1]
			if string.lower(format) in self.raw_formats:	
                		self.fullpblist[fullpbindex]=gtk.gdk.pixbuf_new_from_file_at_size(self.list[indice]\
				[:-len(format)],gtk.gdk.screen_width(),gtk.gdk.screen_height())
			else:
				self.fullpblist[fullpbindex]=gtk.gdk.pixbuf_new_from_file_at_size(self.list[indice],\
				gtk.gdk.screen_width(),gtk.gdk.screen_height())
		self.lock.release()
		gc.collect()
		
       	def Add_Dimensions(self,format,label):                  #Adds image dimensions on the statusbar
		if string.lower(format) in self.raw_formats and self.ark not in self.list[self.indice]:
			self.Display_Exif(self.rawpath[self.list[self.indice]],label)
			if self.Image_Size!='':
                                self.Set_Statusbar2(self.Image_Size,self.rawpath[self.list[self.indice]])
                        else:   self.Set_Statusbar2('',self.list[self.indice][:-len(format)])
		elif string.lower(format) in self.raw_formats and self.ark in self.list[self.indice]:
                        filename=string.replace(string.replace(self.list[self.indice],'/thumb',''),'.thumb.jpg','')
                        self.Display_Exif(filename,label)
                        if self.Image_Size!='':
                                self.Set_Statusbar2(self.Image_Size,filename)
                        else:   self.Set_Statusbar2('',filename)
		else:
                        try:
                                self.Display_Exif(self.list[self.indice],label)
                                if self.Image_Size!='':
                                        self.Set_Statusbar2(self.Image_Size,self.list[self.indice])
                                else:   self.Set_Statusbar2('',self.list[self.indice])
                        except: self.exifmodel.clear()
		
	def Last_Foto(self,event):
		if not self.lock.locked():
			self.lock.acquire()
                	self.pbindex=1
                	self.indice=len(self.list)-1
			format=os.path.splitext(self.list[self.indice])[1]
                	self.Set_Image1(format)
                	while gtk.events_pending(): gtk.main_iteration(False)
       			self.Add_Dimensions(format,self._label)
       			self.count=0
       			while gtk.events_pending(): gtk.main_iteration(False)
       			thread.start_new_thread(self.Cache_Pixbuf,(self.pbindex-1,self.indice-1))
		gc.collect()
		
	def Last_b_Foto(self,event):
		if not self.lock2.locked() and self.n>0:
			self.lock2.acquire()
                	self.pixindex=1
                	self.indice=len(self.list)-1
			for i in range(self.n):
                        	self.b_event[i].modify_bg(gtk.STATE_NORMAL,self.gallery_color)
			self.b_event[self.indice].modify_bg(gtk.STATE_NORMAL,self.selection_color)
			while gtk.events_pending(): gtk.main_iteration(False)
			format=os.path.splitext(self.list[self.indice])[1]
                	self.Set_Image2(format)
                	while gtk.events_pending(): gtk.main_iteration(False)
       			self.count=0
       			while gtk.events_pending(): gtk.main_iteration(False)
       			thread.start_new_thread(self.Cache_b_Pixbuf,(self.pixindex-1,self.indice-1))
		gc.collect()
	
	def Previous_Foto(self,event):
		if not self.lock.locked():
			self.count=0
			if self.indice>0:
				self.lock.acquire()
				self.indice-=1
				if self.pbindex>0: self.pbindex-=1
                        	else:              self.pbindex=2
				format=os.path.splitext(self.list[self.indice])[1]
				self.Set_Pixbuf(format,self.pbindex)
				while gtk.events_pending(): gtk.main_iteration(False)
       				self.Add_Dimensions(format,self._label)
       				while gtk.events_pending(): gtk.main_iteration(False)
       				thread.start_new_thread(self.Cache_Pixbuf,(self.pbindex-1,self.indice-1))
			else: pass
		gc.collect()

	def Previous_b_Foto(self,event):
		if not self.lock2.locked():
			self.count=0
			if self.indice>0:
				self.lock2.acquire()
				self.indice-=1
				for i in range(self.n):
                                	self.b_event[i].modify_bg(gtk.STATE_NORMAL,self.gallery_color)
				self.b_event[self.indice].modify_bg(gtk.STATE_NORMAL,self.selection_color)
				while gtk.events_pending(): gtk.main_iteration(False)
				if self.pixindex>0: self.pixindex-=1
                        	else:              self.pixindex=2
				format=os.path.splitext(self.list[self.indice])[1]
				self.Set_b_Pixbuf(format,self.pixindex)
				while gtk.events_pending(): gtk.main_iteration(False)
       				thread.start_new_thread(self.Cache_b_Pixbuf,(self.pixindex-1,self.indice-1))
			else: pass
		gc.collect()

	def Next_Foto(self,event):
		if not self.lock.locked():
			self.count=0
			if self.indice<len(self.list)-1:
				self.lock.acquire()
				self.indice+=1
				if self.pbindex<2: self.pbindex+=1
                        	else:              self.pbindex=0
				format=os.path.splitext(self.list[self.indice])[1]
				self.Set_Pixbuf(format,self.pbindex)
				while gtk.events_pending(): gtk.main_iteration(False)
       				self.Add_Dimensions(format,self._label)
       				while gtk.events_pending(): gtk.main_iteration(False)
       				thread.start_new_thread(self.Cache_Pixbuf,(self.pbindex+1,self.indice+1))
			else: pass
		gc.collect()

	def Next_b_Foto(self,event):
		if not self.lock2.locked():
			self.count=0
			if self.indice<len(self.list)-1:
				self.lock2.acquire()
				self.indice+=1
				for i in range(self.n):
                                        self.b_event[i].modify_bg(gtk.STATE_NORMAL,self.gallery_color)
				self.b_event[self.indice].modify_bg(gtk.STATE_NORMAL,self.selection_color)
				while gtk.events_pending(): gtk.main_iteration(False)
				if self.pixindex<2: self.pixindex+=1
                        	else:              self.pixindex=0
				format=os.path.splitext(self.list[self.indice])[1]
				self.Set_b_Pixbuf(format,self.pixindex)
       				while gtk.events_pending(): gtk.main_iteration(False)
       				thread.start_new_thread(self.Cache_b_Pixbuf,(self.pixindex+1,self.indice+1))
			else: pass
		gc.collect()

	def Previous_Fullfoto(self,event):
		if not self.lock.locked():
                	if self.indice>0:
				self.lock.acquire()
				self.indice-=1
				if self.fullpbindex>0: self.fullpbindex-=1
                        	else:                  self.fullpbindex=2
				self.image2.set_from_pixbuf(self.fullpblist[self.fullpbindex])
				while gtk.events_pending(): gtk.main_iteration(False)
       				thread.start_new_thread(self.Cache_Fullpixbuf,(self.fullpbindex-1,self.indice-1))	
			else: pass
		gc.collect()

	def Next_Fullfoto(self,event):
		if not self.lock.locked():
			if self.indice<len(self.list)-1:
				self.lock.acquire()
				self.indice+=1
				if self.fullpbindex<2: self.fullpbindex+=1
                        	else:                  self.fullpbindex=0
				self.image2.set_from_pixbuf(self.fullpblist[self.fullpbindex])
				while gtk.events_pending(): gtk.main_iteration(False)
       				thread.start_new_thread(self.Cache_Fullpixbuf,(self.fullpbindex+1,self.indice+1))	
			else:pass
		gc.collect()
		
	def Zoom_in_Foto(self,event,data):
		while gtk.events_pending():  gtk.main_iteration(False)
		if not self.n: return True
		self.toolbutton6.handler_block(self.id35)
                self.toolbutton7.handler_block(self.id36)
		self.toolbutton8.handler_block(self.id37)
		self.toolbutton9.handler_block(self.id38)
                self.toolbutton16.handler_block(self.id1)
                self.toolbutton17.handler_block(self.id2)
		self.count=0
		format=os.path.splitext(self.list[self.indice])[1]
		if not data:
                        self.rect.width-=(self.rect.width/100)*25
			self.rect.height-=(self.rect.height/100)*25
			if self.rect.height<100:
				self.rect.width=150
				self.rect.height=100
                        rect_width=self.rect.width
                        rect_height=self.rect.height
                else:
                        self.rect2.width-=(self.rect2.width/100)*25
			self.rect2.height-=(self.rect2.height/100)*25
			if self.rect2.height<100:
				self.rect2.width=150
				self.rect2.height=100
                        rect_width=self.rect2.width
                        rect_height=self.rect2.height
		if string.lower(format) in self.raw_formats:
			preview=self._label[:-len(format)]+'.tiff'
			if preview in os.listdir(self.temp) and self.raw_preview:
				pixbuf=gtk.gdk.pixbuf_new_from_file_at_size(self.temp+preview,rect_width,rect_height)
			else:
				pixbuf = gtk.gdk.pixbuf_new_from_file_at_size(self.list[self.indice][:-len(format)],\
				rect_width,rect_height)
		else:
			pixbuf = gtk.gdk.pixbuf_new_from_file_at_size(self.list[self.indice],\
			rect_width,rect_height)
		pixbuf=self.Check_Icons(format,pixbuf) 
		if not data:
                        self.image1.set_from_pixbuf(pixbuf)
                else:   self.swin2_image.set_from_pixbuf(pixbuf)
		while gtk.events_pending(): gtk.main_iteration(False)
		del pixbuf
		gc.collect()
		self.toolbutton6.handler_unblock(self.id35)
                self.toolbutton7.handler_unblock(self.id36)
		self.toolbutton8.handler_unblock(self.id37)
		self.toolbutton9.handler_unblock(self.id38)
		self.toolbutton16.handler_unblock(self.id1)
                self.toolbutton17.handler_unblock(self.id2)
		
	def Zoom_out_Foto(self,event,data):
		while gtk.events_pending():  gtk.main_iteration(False)
		if not self.n: return True
		self.toolbutton6.handler_block(self.id35)
                self.toolbutton7.handler_block(self.id36)
		self.toolbutton8.handler_block(self.id37)
		self.toolbutton9.handler_block(self.id38)
                self.toolbutton16.handler_block(self.id1)
                self.toolbutton17.handler_block(self.id2)
		self.count=0
		format=os.path.splitext(self.list[self.indice])[1]
		if not data:
                        self.rect.width+=(self.rect.width/100)*25
			self.rect.height+=(self.rect.height/100)*25
			if self.rect.height<100:
				self.rect.width=150
				self.rect.height=100
                        rect_width=self.rect.width
                        rect_height=self.rect.height
                else:
                        self.rect2.width+=(self.rect2.width/100)*25
			self.rect2.height+=(self.rect2.height/100)*25
                        if self.rect2.height<100:
				self.rect2.width=150
				self.rect2.height=100
                        rect_width=self.rect2.width
                        rect_height=self.rect2.height
		if string.lower(format) in self.raw_formats:
			preview=self._label[:-len(format)]+'.tiff'
			if preview in os.listdir(self.temp) and self.raw_preview:
				pixbuf=gtk.gdk.pixbuf_new_from_file_at_size(self.temp+preview,rect_width,rect_height)
			else:
				pixbuf = gtk.gdk.pixbuf_new_from_file_at_size(self.list[self.indice][:-len(format)],\
				rect_width,rect_height)
		else:
			pixbuf = gtk.gdk.pixbuf_new_from_file_at_size(self.list[self.indice],\
			rect_width,rect_height)
		pixbuf=self.Check_Icons(format,pixbuf) 
		if not data:
                        self.image1.set_from_pixbuf(pixbuf)
                else:   self.swin2_image.set_from_pixbuf(pixbuf)
		while gtk.events_pending(): gtk.main_iteration(False)
		del pixbuf
		gc.collect()
		self.toolbutton6.handler_unblock(self.id35)
                self.toolbutton7.handler_unblock(self.id36)
		self.toolbutton8.handler_unblock(self.id37)
		self.toolbutton9.handler_unblock(self.id38)
		self.toolbutton16.handler_unblock(self.id1)
                self.toolbutton17.handler_unblock(self.id2)

	def Zoom_fit_Foto(self,obj,data):
		while gtk.events_pending():  gtk.main_iteration(False)
		self.toolbutton6.handler_block(self.id35)
                self.toolbutton7.handler_block(self.id36)
		self.toolbutton8.handler_block(self.id37)
		self.toolbutton9.handler_block(self.id38)
                self.toolbutton16.handler_block(self.id1)
                self.toolbutton17.handler_block(self.id2)
		self.count=0
		format=os.path.splitext(self.list[self.indice])[1]
		if not data:
                        self.rect=self.scrolledwindow3.allocation
                        rect=self.rect
                else:
                        self.rect2=self.scrolledwindow2.allocation
                        rect=self.rect2
		if string.lower(format) in self.raw_formats:
			if not data:
				preview=self._label[:-len(format)]+'.tiff'
				if preview in os.listdir(self.temp) and self.raw_preview:
					pixbuf=gtk.gdk.pixbuf_new_from_file_at_size(self.temp+preview,rect.width,rect.height)
				else:
					pixbuf = gtk.gdk.pixbuf_new_from_file_at_size(self.list[self.indice][:-len(format)],\
					rect.width,rect.height)
			else:
				pixbuf = gtk.gdk.pixbuf_new_from_file_at_size(self.list[self.indice][:-len(format)],\
				rect.width,rect.height-self.swin2_label.allocation.height)
		else:
			if not data:
				pixbuf = gtk.gdk.pixbuf_new_from_file_at_size(self.list[self.indice],\
				rect.width,rect.height)
			else:
				pixbuf = gtk.gdk.pixbuf_new_from_file_at_size(self.list[self.indice],\
				rect.width,rect.height-self.swin2_label.allocation.height)
		pixbuf=self.Check_Icons(format,pixbuf)   
		if not data:
                        self.image1.set_from_pixbuf(pixbuf)
                else:   self.swin2_image.set_from_pixbuf(pixbuf)
		del pixbuf
		gc.collect()
		self.toolbutton6.handler_unblock(self.id35)
                self.toolbutton7.handler_unblock(self.id36)
		self.toolbutton8.handler_unblock(self.id37)
		self.toolbutton9.handler_unblock(self.id38)
		self.toolbutton16.handler_unblock(self.id1)
                self.toolbutton17.handler_unblock(self.id2)
		
	def Zoom_1_Foto(self,event,data):
		while gtk.events_pending():  gtk.main_iteration(False)
		self.toolbutton6.handler_block(self.id35)
                self.toolbutton7.handler_block(self.id36)
		self.toolbutton8.handler_block(self.id37)
		self.toolbutton9.handler_block(self.id38)
                self.toolbutton16.handler_block(self.id1)
                self.toolbutton17.handler_block(self.id2)
		self.count=0
                format=os.path.splitext(self.list[self.indice])[1]
		if string.lower(format) in self.raw_formats:
			preview=self._label[:-len(format)]+'.tiff'
			if preview in os.listdir(self.temp) and self.raw_preview:
				pixbuf=gtk.gdk.pixbuf_new_from_file(self.temp+preview)
			else:
				pixbuf = gtk.gdk.pixbuf_new_from_file(self.list[self.indice][:-len(format)])
		else:   pixbuf = gtk.gdk.pixbuf_new_from_file(self.list[self.indice])
		pixbuf=self.Check_Icons(format,pixbuf) 	
		if not data:
                        self.image1.set_from_pixbuf(pixbuf)
                        self.rect.width=pixbuf.get_width()
                        self.rect.height=pixbuf.get_height()
                else:
                        self.swin2_image.set_from_pixbuf(pixbuf)
                        self.rect2.width=pixbuf.get_width()
                        self.rect2.height=pixbuf.get_height()
		del pixbuf
		gc.collect()
		self.toolbutton6.handler_unblock(self.id35)
                self.toolbutton7.handler_unblock(self.id36)
		self.toolbutton8.handler_unblock(self.id37)
		self.toolbutton9.handler_unblock(self.id38)
		self.toolbutton16.handler_unblock(self.id1)
                self.toolbutton17.handler_unblock(self.id2)
		
	def Sx_Rotation(self,event,data):
		while gtk.events_pending():  gtk.main_iteration(False)
                if self.count<3: self.count+=1
                else:            self.count=0
                if not data:
                        rect_width=self.rect.width
                        rect_height=self.rect.height
                else:
                        rect_width=self.rect2.width
                        rect_height=self.rect2.height
                format=os.path.splitext(self.list[self.indice])[1]
		if string.lower(format) in self.raw_formats:
			preview=self._label[:-len(format)]+'.tiff'
			if preview in os.listdir(self.temp) and self.raw_preview:
				pixbuf=gtk.gdk.pixbuf_new_from_file_at_size(self.temp+preview,rect_width,rect_height)
			else:
        			pixbuf=gtk.gdk.pixbuf_new_from_file_at_size(self.list[self.indice][:-len(format)],\
                        	rect_width,rect_height)
			pixbuf=pixbuf.rotate_simple(self.gradi[self.count])
			pixbuf.save('.thumbnails/'+os.path.split(self.list[self.indice][:-len(format)])[1],"jpeg")
			pixbuf=gtk.gdk.pixbuf_new_from_file_at_size('.thumbnails/'+\
                        os.path.split(self.list[self.indice][:-len(format)])[1],rect_width,rect_height)               
                else:
			pixbuf=gtk.gdk.pixbuf_new_from_file_at_size(self.list[self.indice],rect_width,rect_height)
			pixbuf=pixbuf.rotate_simple(self.gradi[self.count])
			if string.lower(format) in ['.png','.ico','.svg'] and pixbuf.get_has_alpha():
                                pixbuf.save('.thumbnails/'+os.path.split(self.list[self.indice])[1][:-len(format)]+'.png',"png")
                                pixbuf=gtk.gdk.pixbuf_new_from_file_at_size('.thumbnails/'+\
                                os.path.split(self.list[self.indice])[1][:-len(format)]+'.png',rect_width,rect_height)
                        else:
                                pixbuf.save('.thumbnails/'+os.path.split(self.list[self.indice])[1][:-len(format)]+'.jpg',"jpeg")
                                pixbuf=gtk.gdk.pixbuf_new_from_file_at_size('.thumbnails/'+\
                                os.path.split(self.list[self.indice])[1][:-len(format)]+'.jpg',rect_width,rect_height)
		pixbuf=self.Check_Icons(format,pixbuf) 
                if not data:    self.image1.set_from_pixbuf(pixbuf)
                else:           self.swin2_image.set_from_pixbuf(pixbuf)
		del pixbuf
		gc.collect()
                
        def Scroll_Fullfoto(self,obj,event):
                if event.direction == gtk.gdk.SCROLL_UP:
                	self.Previous_Fullfoto(self)
                elif event.direction == gtk.gdk.SCROLL_DOWN:
                        self.Next_Fullfoto(self)
		
	def Dx_Rotation(self,event,data):
		while gtk.events_pending():  gtk.main_iteration(False)
                if self.count>0: self.count-=1
                else:            self.count=3
                if not data:
                        rect_width=self.rect.width
                        rect_height=self.rect.height
                else:
                        rect_width=self.rect2.width
                        rect_height=self.rect2.height
		format=os.path.splitext(self.list[self.indice])[1]
		if string.lower(format) in self.raw_formats:
			preview=self._label[:-len(format)]+'.tiff'
			if preview in os.listdir(self.temp) and self.raw_preview:
				pixbuf=gtk.gdk.pixbuf_new_from_file_at_size(self.temp+preview,rect_width,rect_height)
			else:
        			pixbuf=gtk.gdk.pixbuf_new_from_file_at_size(self.list[self.indice][:-len(format)],\
                        	rect_width,rect_height)
			pixbuf=pixbuf.rotate_simple(self.gradi[self.count])
			pixbuf.save('.thumbnails/'+os.path.split(self.list[self.indice][:-len(format)])[1],"jpeg")
			pixbuf=gtk.gdk.pixbuf_new_from_file_at_size('.thumbnails/'+\
                        os.path.split(self.list[self.indice][:-len(format)])[1],rect_width,rect_height)           
                else:
			pixbuf=gtk.gdk.pixbuf_new_from_file_at_size(self.list[self.indice],rect_width,rect_height)
			pixbuf=pixbuf.rotate_simple(self.gradi[self.count])
			if string.lower(format) in ['.png','.ico','.svg'] and pixbuf.get_has_alpha():
                                pixbuf.save('.thumbnails/'+os.path.split(self.list[self.indice])[1][:-len(format)]+'.png',"png")
                                pixbuf=gtk.gdk.pixbuf_new_from_file_at_size('.thumbnails/'+\
                                os.path.split(self.list[self.indice])[1][:-len(format)]+'.png',rect_width,rect_height)
                        else:
                                pixbuf.save('.thumbnails/'+os.path.split(self.list[self.indice])[1][:-len(format)]+'.jpg',"jpeg")
                                pixbuf=gtk.gdk.pixbuf_new_from_file_at_size('.thumbnails/'+\
                                os.path.split(self.list[self.indice])[1][:-len(format)]+'.jpg',rect_width,rect_height)
		pixbuf=self.Check_Icons(format,pixbuf) 
                if not data:    self.image1.set_from_pixbuf(pixbuf)
                else:           self.swin2_image.set_from_pixbuf(pixbuf)
		del pixbuf
		gc.collect()

	def Open_With_Gimp(self,obj):               #Opens image with Gimp
                if self.radiobutton6.get_active():
                        if self.obj in self.event:
                                self.indice=self.event.index(self.obj)
                        elif  self.obj in self.e:
                                self.indice=self.e.index(self.obj)
                format=os.path.splitext(self.list[self.indice])[1]
                if self.version+'Albums/' not in self.window1.get_title() :
                        if string.lower(format) in self.raw_formats: filename=self.rawpath[self.list[self.indice]]
                        else:   filename=self.list[self.indice]
                elif self.version+'Albums/' in self.window1.get_title() :
                        if string.lower(format) in self.raw_formats:
				 	filename=string.replace(string.replace(self.list[self.indice],'/thumb',''),\
					'.thumb.jpg','')
                        else:   filename=self.list[self.indice]
		thread.start_new_thread(self.Start_Gimp,(filename,))
		
	def Start_Gimp(self,filename):
                status=os.system('gimp "%s" '% filename)
                print status
       
        def Open_With_Other(self,obj):
		self.entry3.grab_focus()              #Opens image with other software
                self.dialog13.show()
                response=self.dialog13.run()
                if response==gtk.RESPONSE_CANCEL or response==gtk.RESPONSE_DELETE_EVENT: self.dialog13.hide()
                elif response==gtk.RESPONSE_OK:
			self.dialog13.hide()
			while gtk.events_pending(): gtk.main_iteration(False)
			if self.radiobutton6.get_active():
                                if self.obj in self.event:
                                        self.indice=self.event.index(self.obj)
                                elif  self.obj in self.e:
                                        self.indice=self.e.index(self.obj)
                        format=os.path.splitext(self.list[self.indice])[1]
                        if self.version+'Albums/' not in self.window1.get_title() :
                                if format in self.raw_formats:
                                        filename=self.rawpath[self.list[self.indice]]
                                else:   filename=self.list[self.indice]
                        elif self.version+'Albums/' in self.window1.get_title() :
                                if string.lower(format) in self.raw_formats:
                                        filename=string.replace(string.replace(self.list[self.indice],'/thumb',''),\
					'.thumb.jpg','')
                                else:   filename=self.list[self.indice]
                        command=self.entry3.get_text()
			thread.start_new_thread(self.Start_Other,(command,filename))
			
	def Start_Other(self,command,filename):
                        status=os.system(' "%s" "%s" '%(command,filename))
                        print status

        def Load_Cache(self,width,height,data):         # Preloads previous and next images
		self.lock.acquire()
                if self.indice>0:
			format=os.path.splitext(self.list[self.indice-1])[1]
			if string.lower(format) in self.raw_formats:
				if data=='fullscreen':
					self.fullpblist[0]=gtk.gdk.pixbuf_new_from_file_at_size(self.list[self.indice-1]\
					[:-len(format)],width,height)	
				else:
                			self.pblist[0]=gtk.gdk.pixbuf_new_from_file_at_size(self.list[self.indice-1]\
					[:-len(format)],width,height)
			else:
				if data=='fullscreen':
					self.fullpblist[0]=gtk.gdk.pixbuf_new_from_file_at_size(self.list[self.indice-1]\
					,width,height)
				else:
					self.pblist[0]=gtk.gdk.pixbuf_new_from_file_at_size(self.list[self.indice-1],\
					width,height)
                else: pass
                if self.indice<self.n-1:
			format=os.path.splitext(self.list[self.indice+1])[1]
			if string.lower(format) in self.raw_formats:
				if data=='fullscreen':
					self.fullpblist[2]=gtk.gdk.pixbuf_new_from_file_at_size(self.list[self.indice+1]\
					[:-len(format)],width,height)
				else:		
                			self.pblist[2]=gtk.gdk.pixbuf_new_from_file_at_size(self.list[self.indice+1]\
					[:-len(format)],width,height)
			else:
				if data=='fullscreen':
					self.fullpblist[2]=gtk.gdk.pixbuf_new_from_file_at_size(self.list[self.indice+1],\
					width,height)
				else:	
					self.pblist[2]=gtk.gdk.pixbuf_new_from_file_at_size(self.list[self.indice+1],\
					width,height)
                else: pass
		self.lock.release()

	def Load_b_Cache(self,width,height):
                self.lock2.acquire()
                if self.indice>0:
			format=os.path.splitext(self.list[self.indice-1])[1]
			if string.lower(format) in self.raw_formats:
				self.b_pixlist[0]=gtk.gdk.pixbuf_new_from_file_at_size(self.list[self.indice-1]\
				[:-len(format)],width,height-self.swin2_label.allocation.height)	
			else:
				self.b_pixlist[0]=gtk.gdk.pixbuf_new_from_file_at_size(self.list[self.indice-1],\
                                width,height-self.swin2_label.allocation.height)
                else: pass
                if self.indice<self.n-1:
			format=os.path.splitext(self.list[self.indice+1])[1]
			if string.lower(format) in self.raw_formats:
				self.b_pixlist[2]=gtk.gdk.pixbuf_new_from_file_at_size(self.list[self.indice+1]\
				[:-len(format)],width,height-self.swin2_label.allocation.height)	
			else:
				self.b_pixlist[2]=gtk.gdk.pixbuf_new_from_file_at_size(self.list[self.indice+1],\
				width,height-self.swin2_label.allocation.height)
                else: pass
		self.lock2.release()
   
	def Display_Foto(self,obj):             # Opens image on details window
		self.hpaned2.handler_block(self.id22)
                self.pbindex=1
		if self.obj in self.event:
			self.indice=self.event.index(self.obj)
		elif  self.obj in self.e:
                        self.indice=self.e.index(self.obj)
		self.window2.maximize()
		self.window2.show()
		self.rect=self.scrolledwindow3.allocation
		format=os.path.splitext(self.list[self.indice])[1]	
		self.Set_Image1(format)
		self.window2.show()
		while gtk.events_pending(): gtk.main_iteration(False)
       		self.Add_Dimensions(format,self._label)
		self.hpaned2.handler_unblock(self.id22)
		while gtk.events_pending(): gtk.main_iteration(False)
		thread.start_new_thread(self.Load_Cache,(self.rect.width,self.rect.height,''))

	def Eventbox1_Handler(self,obj,event):
                if self.radiobutton7.get_active():
                        if event.button==3 and self.n!=0:
				if self.version+'Albums/' not in self.window1.get_title():
					self.imagemenuitem9.set_sensitive(False)
					self.imagemenuitem20.set_sensitive(False)
				else:
                                        self.imagemenuitem9.set_sensitive(True)
                                        self.imagemenuitem20.set_sensitive(True)
                                self.menu8.popup(None,None,None,event.button, event.time)
                        if event.type==5:
				self.Open_On_Window2(self)
					
	def Scroll_Eventbox1(self,obj,event):
		if self.radiobutton7.get_active():
                	if event.direction==gtk.gdk.SCROLL_DOWN: self.Next_b_Foto(self)
                	elif event.direction==gtk.gdk.SCROLL_UP: self.Previous_b_Foto(self)
		
	def Scroll_Scrolledwindow3(self,obj,event):
		if event.direction==gtk.gdk.SCROLL_DOWN: self.Next_Foto(self)
                elif event.direction==gtk.gdk.SCROLL_UP: self.Previous_Foto(self)

        def Open_On_Window2(self,obj):
		self.hpaned2.handler_block(self.id22)
		indice=self.indice
                self.old_indice=indice
                self.pbindex=1
                self.window2.maximize()
		self.window2.show()
		self.rect=self.scrolledwindow3.allocation
		format=os.path.splitext(self.list[self.indice])[1]	
		self.Set_Image1(format)
		self.window2.show()
		while gtk.events_pending(): gtk.main_iteration(False)
       		self.Add_Dimensions(format,self._label)
		while gtk.events_pending(): gtk.main_iteration(False)
		thread.start_new_thread(self.Load_Cache,(self.rect.width,self.rect.height,''))
		self.hpaned2.handler_unblock(self.id22)	
		
	def Exiftool(self,lista,tag):           # Populates exif panel
                for item in lista:
                        if tag in item and item[0]==tag[0]:
                                self.exifmodel.append([tag,string.split(item,' : ')[1]])
				break
                	else: pass
			
	def Full_Exif(self,event):              # Populates exif panel with full exif list
		if self.checkbutton1.get_active():
			return True
		self.exifmodel.clear()
		format=os.path.splitext(self.list[self.indice])[1]
		if string.lower(format) in self.raw_formats and self.ark not in self.list[self.indice]:
			image=self.rawpath[self.list[self.indice]]
		elif string.lower(format) in self.raw_formats and self.ark in self.list[self.indice]:
                        image=string.replace(string.replace(self.list[self.indice],'/thumb',''),'.thumb.jpg','')
		elif string.lower(format) in self.formats:
			image=self.list[self.indice]
		status,output=commands.getstatusoutput('exiftool "%s" '%image)
		if output!='':
			exif_list=string.split(output,'\n')
			for item in exif_list:
				tag=string.split(item,' : ')
				self.exifmodel.append([tag[0],tag[1]])

        def Display_Exif(self,image,label):
		if self.toolbutton24.get_active():
			self.Full_Exif(self)
			return True
		if self.checkbutton1.get_active():
			return True
		else:
                	self.Image_Size=''
                	self.exifmodel.clear()
                	self.exifmodel.append(['Filename  ',label])
                	status,output=commands.getstatusoutput('exiftool "%s" '%image)
                	if output!='':
                        	self.exif_list=lista=string.split(output,'\n')
                        	self.Exiftool(lista,'Create Date  ')
                        	self.Exiftool(lista,'ISO  ')
                        	self.Exiftool(lista,'Exposure Time  ')
                        	self.Exiftool(lista,'F Number  ')
                        	self.Exiftool(lista,'Focal Length  ')
                        	self.Exiftool(lista,'Exposure Program  ')
                        	self.Exiftool(lista,'Exposure Compensation  ')
                        	self.Exiftool(lista,'Image Description  ')
                        	self.Exiftool(lista,'Camera Model Name  ')
                        	self.Exiftool(lista,'Software  ')
                        	self.Exiftool(lista,'Image Width  ')
                        	self.Exiftool(lista,'Image Height  ')
                        	self.Exiftool(lista,'Bits Per Sample  ')
                        	self.Exiftool(lista,'Compression  ')
                        	self.Exiftool(lista,'Flash  ')
                        	self.Exiftool(lista,'Flash Mode  ')
                        	self.Exiftool(lista,'Flash Exposure Compensation  ')
                        	self.Exiftool(lista,'Lens  ')
                        	self.Exiftool(lista,'White Balance  ')
                        	self.Exiftool(lista,'White Balance Temperature  ')
                        	self.Exiftool(lista,'Focus Mode  ')
                        	self.Exiftool(lista,'Focus Distance  ')
                        	self.Exiftool(lista,'Focus Process  ')
                        	for item in lista:
                                	if 'Image Size  ' in item: self.Image_Size=string.split(item,':')[1][1:]
                        	self.treeview3.set_model(self.exifmodel)

        def Select_b_foto(self,obj,event):      # Displays the selected image on the single image layout
                self.pixindex=1
                self.vpaned2.handler_block(self.id27)
                self.indice=self.b_event.index(obj)
                for i in range(self.n): self.b_event[i].modify_bg(gtk.STATE_NORMAL,self.gallery_color)
                self.b_event[self.indice].modify_bg(gtk.STATE_NORMAL,self.selection_color)
		while gtk.events_pending(): gtk.main_iteration(False)
                if event.button==1 or event.button==3 :
                        self.rect2=self.scrolledwindow2.allocation
                        format=os.path.splitext(self.list[self.indice])[1]
                        if string.lower(format) in self.raw_formats:
                                self.b_pixlist[self.pixindex]= gtk.gdk.pixbuf_new_from_file_at_size(self.list[self.indice]\
                                [:-len(format)],self.rect2.width,self.rect2.height-self.swin2_label.allocation.height)
                        else:
                                self.b_pixlist[self.pixindex]= gtk.gdk.pixbuf_new_from_file_at_size(self.list[self.indice],\
                                self.rect2.width,self.rect2.height-self.swin2_label.allocation.height)
			self.b_pixlist[self.pixindex]=self.Check_Icons(format,self.b_pixlist[self.pixindex])
                        self.swin2_image.set_from_pixbuf(self.b_pixlist[self.pixindex])
                        self.swin2_label.set_text(self.label[self.indice].get_text())
                        self.scrolledwindow2.show_all()
                        while gtk.events_pending(): gtk.main_iteration(False)
                        gc.collect()
                self.vpaned2.handler_unblock(self.id27)
                thread.start_new_thread(self.Load_b_Cache,(self.rect2.width,self.rect2.height))
		
	def Check_Icons(self,format,pixbuf):
		if string.lower(format) in ['.png','.svg','.ico'] and pixbuf.get_has_alpha():
				w=pixbuf.get_width()
				h=pixbuf.get_height()
				grey=self.grey.copy()
				grey=grey.scale_simple(w,h,gtk.gdk.INTERP_BILINEAR)
				pixbuf.composite(grey,0,0,w,h,0,0,1.0,1.0,\
				gtk.gdk.INTERP_BILINEAR,255)
				return grey
		else:  return pixbuf
		

	def Select_Foto(self,obj,event):        # Selects clicked thumbnails on gallery layout
		if obj in self.event:
			indice=self.event.index(obj)
		elif obj in self.e:
			indice=self.e.index(obj)
                if event.button==3:
			self.obj=obj
                        label=self.e[indice].get_child()
			filename=label.get_text()
			format=os.path.splitext(filename)[1]
			if self.version+'Albums/' not in self.window1.get_title():
                                if string.lower(format) in self.raw_formats:
					 filename=self.temp+filename[:-len(format)]+'.thumb.jpg'+format
                                else: filename=self.cartella+'/'+filename
                                if filename not in self.selected:
                                        self.e[indice].modify_bg(gtk.STATE_NORMAL,self.selection_color)
                                        self.selected.append(filename)
                                else:pass
                        else:
                                for item in self.albums[self.album]:      
                                        if string.lower(format) in self.raw_formats:
                                                if filename[:-len(format)] in item:
                                                        filename=item[:]
                                                        break
                                        elif filename in item:
                                                filename=item[:]
                                                break
                                        else:continue
                                if filename not in self.selected:   
                                        self.e[indice].modify_bg(gtk.STATE_NORMAL,self.selection_color)
                                        self.selected.append(filename)
                                else:pass
                        if len(self.selected)>0:
				if self.version+'Albums/' not in self.window1.get_title():
					self.imagemenuitem19.set_sensitive(False)
				else:
                                        self.imagemenuitem19.set_sensitive(True)
                        	self.menu5.popup(None,None,None,event.button, event.time)            
		elif event.type==5 :
			self.obj=obj
			self.Display_Foto(self)
		elif event.button==1:
			label=self.e[indice].get_child()
			filename=label.get_text()
			format=os.path.splitext(filename)[1]
			if self.version+'Albums/' not in self.window1.get_title():
                                if string.lower(format) in self.raw_formats:
					 filename=self.temp+filename[:-len(format)]+'.thumb.jpg'+format
                                else: filename=self.cartella+'/'+filename
                                if filename not in self.selected:
                                        self.e[indice].modify_bg(gtk.STATE_NORMAL,self.selection_color)
                                        self.selected.append(filename)
                                else:
                                        del self.selected[self.selected.index(filename)]
                                        self.e[indice].modify_bg(gtk.STATE_NORMAL,self.colorbutton1.get_color())
                        else:
                                for item in self.albums[self.album]:     
                                        if string.lower(format) in self.raw_formats:
                                                if filename[:-len(format)] in item:
                                                        filename=item[:]
                                                        break
                                        elif filename in item:
                                                filename=item[:]
                                                break
                                        else:continue
                                if filename not in self.selected:
                                        self.e[indice].modify_bg(gtk.STATE_NORMAL,self.selection_color)
                                        self.selected.append(filename)
                                else:
                                        del self.selected[self.selected.index(filename)]
                                        self.e[indice].modify_bg(gtk.STATE_NORMAL,self.colorbutton1.get_color())
		
        def Selection_Control(self,event):              #Controls selected images for unknown files
                if self.radiobutton7.get_active():
                        self.selected=[]
                        self.selected.append(self.list[self.indice])
                if self.version+'Albums/' not in self.window1.get_title() :
                        files=os.listdir(self.cartella)
                        for item in self.selected:
                                format=os.path.splitext(item)[1]
                                if string.lower(format) in self.raw_formats:
					 fname=string.replace(os.path.split(item)[1],'.thumb.jpg','')
                                else:   fname=os.path.split(item)[1]
                                if fname in files: continue
                                else:
                                        self.label7.set_text('Attention! Unknown file: %s\n The gallery will be updated!'% fname)
                                        self.dialog6.show()
					gtk.gdk.beep()
                                        response=self.dialog6.run()
                                        if response==gtk.RESPONSE_OK:
                                                self.dialog6.hide()
                                                self.scrolledwindow2.get_child().destroy()
                                                if self.radiobutton7.get_active(): self.hbox1.destroy()
                                                self.n=self.Conta_Foto(self)
                                                if self.n!=0:
                                                        self.Make_Table(self)
                                                        self.Attach_Images(self)
                                                        self.Statusbar_Pop(self.statusbar3,self.context_id3)
                                                        self.Statusbar_Push(self.statusbar3,self.context_id3,\
							'There are %s images     Total size %f MB'%(self.n,self.total_size/1000000.0))
                                                        if self.radiobutton7.get_active(): self.Make_Bottom_Panel(self)
                                                        else: self.Make_Thumbnails(self.width,self.height)

                                                else:
                                                        self.Statusbar_Pop(self.statusbar3,self.context_id3)
                                                        self.Statusbar_Push(self.statusbar3,self.context_id3,\
							'There are %s images'%self.n)
                                                self.selected=[]
                                                return False
                elif self.version+'Albums/' in self.window1.get_title() :
                        files=os.listdir(self.ark+self.album)
                        for item in self.selected:
                                format=os.path.splitext(item)[1]
                                if string.lower(format) in self.raw_formats:
					 fname=string.replace(os.path.split(item)[1],'.thumb.jpg','')
                                else:   fname=os.path.split(item)[1]
                                if fname in files: continue
                                else:
                                        self.label7.set_text('Attention! Unknown file: %s\n The gallery will be updated!'%fname)
                                        self.dialog6.show()
					gtk.gdk.beep()
                                        response=self.dialog6.run()
                                        if response==gtk.RESPONSE_OK:
                                                self.dialog6.hide()
                                                del self.albums[self.album]
                                                lista=[]
                                                for item in files:
                                                        format=os.path.splitext(item)[1]
                                                        if string.lower(format) in self.raw_formats:
                                                                fname=self.ark+self.album+'/thumb/'+item[:-len(format)]+\
								'.thumb.jpg'+format
                                                                lista.append(fname)
                                                        elif string.lower(format) in self.formats:
                                                                fname=self.ark+self.album+'/'+item
                                                                lista.append(fname)
                                                        else: pass
                                                self.albums[self.album]=lista
                                                self.Make_Album_Gallery(self)
                                                self.selected=[]
                                                return False
                return True

        def Pre_Add_Selection(self,event):
                if len(self.selected)>0:
                        self.Add_Selection(self)
                else:
                        self.dialog9.show()
                        gtk.gdk.beep()
                        response=self.dialog9.run()
                        if response==gtk.RESPONSE_CLOSE or response==gtk.RESPONSE_DELETE_EVENT: self.dialog9.hide()
                                        	
        def Add_Selection(self,event):                          #Adds selected images to album
                self.window5.set_title('Saving to album...')
                if self.Selection_Control(self):
                        images=0
                        selected=self.selected
                        self.dialog4.show()
                        response=self.dialog4.run()
                        if response==gtk.RESPONSE_CANCEL or response==gtk.RESPONSE_DELETE_EVENT:
                                self.dialog4.hide()
				self.boxentry2.set_text('')
				return True
                        elif response==gtk.RESPONSE_APPLY:      
                                if not self.Add_Album(self,'button'): return True
                                self.window1.window.set_cursor(self.watch)
                                if self.version+'Albums/' not in self.window1.get_title() :
                                        if self.radiobutton6.get_active():
                                                for indice in range(self.n): self.e[indice].modify_bg(gtk.STATE_NORMAL,self.gallery_color)
                                        fraction=0.99/len(selected)
                                        self.window5.show()
                                        for item in self.selected:
                                                self.progressbar2.set_fraction(self.progressbar2.get_fraction()+fraction)
                                                format=os.path.splitext(item)[1]
                                                if string.lower(format) in self.raw_formats:
                                                        source=self.rawpath[item]
                                                        dest=self.ark+self.added_album
                                                        fname=string.replace(item,self.temp,dest+'/thumb/')
                                                        raw=True
                                                else:
                                                        source=item
                                                        dest=self.ark+self.added_album
                                                        fname=dest+'/'+os.path.split(item)[1]
                                                        raw=False
                                                if fname in self.albums[self.added_album]: continue
                                                else:
                                                        os.system('cp "%s" "%s" '% (source,dest))
                                                        if raw: os.system('mv "%s" "%s" '% (item[:-len(format)],dest+'/thumb'))
                                                self.albums[self.added_album].append(fname)
                                                while gtk.events_pending(): gtk.main_iteration(False)
                                        self.window5.hide()
                                        self.selected=[]
                                        self.progressbar2.set_fraction(0)
                                        album=self.added_album[:]
                                elif self.version+'Albums/' in self.window1.get_title() : 
                                        self.dialog4.hide()
                                        if self.radiobutton6.get_active():
                                                for indice in range(self.n): self.e[indice].modify_bg(gtk.STATE_NORMAL,self.gallery_color)
                                        fraction=0.99/len(selected)
                                        self.window5.show()
                                        for item in self.selected:
                                                self.progressbar2.set_fraction(self.progressbar2.get_fraction()+fraction)
                                                format=os.path.splitext(item)[1]
                                                if string.lower(format) in self.raw_formats:
                                                        source=string.replace(string.replace(item,'/thumb',''),'.thumb.jpg','')
                                                        dest=self.ark+self.added_album
                                                        fname=dest+'/thumb/'+os.path.split(item)[1]
                                                        raw=True
                                                else:
                                                        source=item
                                                        dest=self.ark+self.added_album
                                                        fname=dest+'/'+os.path.split(item)[1]
                                                        raw=False
                                                if fname in self.albums[self.added_album]: continue
                                                else:
                                                        os.system('cp "%s" "%s" '% (source,dest))
                                                        if raw: os.system('cp "%s" "%s" '% (item[:-len(format)],dest+'/thumb'))
                                                self.albums[self.added_album].append(fname)
                                                while gtk.events_pending(): gtk.main_iteration(False)
                                        self.window5.hide()
                                        self.selected=[]
                                        self.progressbar2.set_fraction(0)
                                        album=self.added_album[:]
                                else:   self.dialog4.hide()
                                self.boxentry2.set_text('')
				self.dialog4.hide()
                        elif response==gtk.RESPONSE_OK:
                                album=self.comboboxentry2.get_active_text()
				if album not in self.albums:
					self.dialog4.hide()
					return True
				else:   self.album=album[:]	
                                if self.version+'Albums/'+self.album in self.window1.get_title():
                                        self.dialog4.hide()
					return True
				self.window1.window.set_cursor(self.watch)
                                if self.album!='' and self.version+'Albums/' not in self.window1.get_title() :
                                        self.dialog4.hide()
					images=len(self.albums[self.album])
                                        if self.radiobutton6.get_active():
                                                for indice in range(self.n): self.e[indice].modify_bg(gtk.STATE_NORMAL,self.gallery_color)
                                        fraction=0.99/len(selected)
                                        self.window5.show()
                                        for item in self.selected:
                                                self.progressbar2.set_fraction(self.progressbar2.get_fraction()+fraction)
                                                format=os.path.splitext(item)[1]
                                                if string.lower(format) in self.raw_formats:
                                                        source=self.rawpath[item]
                                                        dest=self.ark+self.album
                                                        fname=string.replace(item,self.temp,dest+'/thumb/')
                                                        raw=True
                                                else:
                                                        source=item
                                                        dest=self.ark+self.album
                                                        fname=dest+'/'+os.path.split(item)[1]
                                                        raw=False
                                                if fname in self.albums[self.album]: continue
                                                else:
                                                        os.system('cp "%s" "%s" '% (source,dest))
                                                        if raw: os.system('mv "%s" "%s" '% (item[:-len(format)],dest+'/thumb'))
                                                self.albums[self.album].append(fname)
                                                while gtk.events_pending(): gtk.main_iteration(False)
                                        self.window5.hide()
                                        self.selected=[]
                                        self.progressbar2.set_fraction(0)
                                elif self.album!='' and self.version+'Albums/' in self.window1.get_title() :
                                        self.dialog4.hide()
					images=len(self.albums[self.album])
                                        if self.radiobutton6.get_active():
                                                for indice in range(self.n): self.e[indice].modify_bg(gtk.STATE_NORMAL,self.gallery_color)
                                        fraction=0.99/len(selected)
                                        self.window5.show()
                                        for item in self.selected:
                                                bul=False
                                                self.progressbar2.set_fraction(self.progressbar2.get_fraction()+fraction)
                                                format=os.path.splitext(item)[1]
                                                if string.lower(format) in self.raw_formats:
                                                        source=string.replace(string.replace(item,'/thumb',''),'.thumb.jpg','')
                                                        dest=self.ark+self.album
                                                        fname=dest+'/thumb/'+os.path.split(item)[1]
                                                        raw=True
                                                else:
                                                        source=item
                                                        dest=self.ark+self.album
                                                        fname=dest+'/'+os.path.split(item)[1]
                                                        raw=False
                                                if fname in self.albums[self.album]: continue
                                                else:
                                                        os.system('cp "%s" "%s" '% (source,dest))
                                                        if raw: os.system('cp "%s" "%s" '% (item[:-len(format)],dest+'/thumb'))
                                                self.albums[self.album].append(fname)
                                                while gtk.events_pending(): gtk.main_iteration(False)
                                        self.window5.hide()
                                        self.selected=[]
                                        self.progressbar2.set_fraction(0)   
                                else:
					self.dialog4.hide()
                        if not images :
                                self.Make_Preview(album,self.albums[album][0])
                        self.boxentry2.set_text('')
                self.window1.window.set_cursor(None)
		
	def Set_Album_Preview(self,obj):
		while gtk.events_pending(): gtk.main_iteration(False)
		if self.radiobutton6.get_active():
			if self.obj in self.event:
				self.indice=self.event.index(self.obj)
			elif  self.obj in self.e:
                        	self.indice=self.e.index(self.obj)
		self.Make_Preview(self.album,self.list[self.indice])

        def Make_Preview(self,album,infile):
                format=os.path.splitext(infile)[1]
                if string.lower(format) in self.raw_formats:
                        outfile=infile[:-len(format)]
                else:   outfile=infile
                pixbuf=gtk.gdk.pixbuf_new_from_file_at_size(outfile,100,53)
                pixbuf=self.Add_Border(pixbuf,0x00000000,True)
                pixbuf.save(self.ark+album+'/_preview_.png',"png")
                iter0=self.model.get_iter_first()
                value=''
                while value!=album:
                        value=self.model.get_value(iter0,1)
                        if value==album:break
                        iter0=self.model.iter_next(iter0)
                self.model.set_value(iter0,0,pixbuf)
                self.treeview1.set_model(self.model)
		
        def Delete_Selection(self,event):               #Deletes selection from album
                if self.Selection_Control(self):
                        if len(self.selected)==0:
                                self.dialog9.show()
                                gtk.gdk.beep()
                                response=self.dialog9.run()
                                if response==gtk.RESPONSE_CLOSE or response==gtk.RESPONSE_DELETE_EVENT:
                                        self.dialog9.hide()
                        else:        
                                self.dialog5.show()
                                response=self.dialog5.run()
                                if response==gtk.RESPONSE_CANCEL or response==gtk.RESPONSE_DELETE_EVENT:
                                        self.dialog5.hide()
                                elif response==gtk.RESPONSE_OK:
                                        for item in self.selected:  self.albums[self.album].remove(item)
                                        if self.radiobutton6.get_active():
                                                for item in range(self.n):  self.e[item].modify_bg(gtk.STATE_NORMAL,self.gallery_color)
                                        self.dialog5.hide()
                                        self.Make_Album_Gallery(self)
                                for item in self.selected:
                                        bul=False
                                        format=os.path.splitext(item)[1]	
                                        for key in self.albums:
                                                if item in self.albums[key]:
                                                        bul=True
                                                        break
                                                else: continue	
                                        if not bul:
                                                if string.lower(format) in self.raw_formats:
                                                        os.remove(item[:-len(format)])
                                                        os.remove(string.replace(string.replace(item,'/thumb',''),\
							'.thumb.jpg',''))
                                                        while gtk.events_pending(): gtk.main_iteration(False)
                                                else:
                                                        os.remove(item)
                                                        while gtk.events_pending(): gtk.main_iteration(False)
				if not self.n:
					iter0=self.model.get_iter_first()
                			value=''
                			while value!=self.album:
                        			value=self.model.get_value(iter0,1)
                        			if value==self.album:break
                        			iter0=self.model.iter_next(iter0)
					self.model.set_value(iter0,0,gtk.gdk.pixbuf_new_from_file('icons/no_preview.png'))
					self.treeview1.set_model(self.model)
                self.selected=[]

        def Make_Raw(self,infile,format,i):
                preview=self.temp+os.path.splitext(os.path.split(infile)[1])[0]+'.thumb.jpg'  
                os.system('dcraw -c -e "%s" > "%s"'% (infile,preview))
                thumb=preview+format  
                self.list[i]=thumb
                self.rawpath[thumb]=infile
                self.Autorotate(infile,preview,format)
                return thumb
                
	def Autorotate(self,infile,preview,format):               #Autorotates thumbnails
                if self.checkbutton2.get_active():
			try:
				f=open(infile,'rb')
				tags=exif.process_file(f , details=False)
				f.close()
				if 'Rotated 90 CCW' in str(tags['Image Orientation']):
					pixbuf=gtk.gdk.pixbuf_new_from_file(preview)
					pixbuf=pixbuf.rotate_simple(gtk.gdk.PIXBUF_ROTATE_COUNTERCLOCKWISE)
					pixbuf.save(preview,'jpeg')	
				elif 'Rotated 90 CW' in str(tags['Image Orientation']):
					pixbuf=gtk.gdk.pixbuf_new_from_file(preview)
					pixbuf=pixbuf.rotate_simple(gtk.gdk.PIXBUF_ROTATE_CLOCKWISE)
					pixbuf.save(preview,'jpeg')
			except:pass
		else: pass

        def Stop_Thumbnails(self,event):
                self.stop_thumb=1
		
	def Sort(self,filelist):
		if self.sort_by_name.get_active():
			return sorted(filelist,cmp=lambda x,y:cmp(os.path.basename(x).lower(),os.path.basename(y).lower()))
		elif self.sort_by_type.get_active():
			filelist.sort(cmp=lambda x,y:cmp(os.path.basename(x).lower(),os.path.basename(y).lower()))
			return sorted(filelist,cmp=lambda x,y :cmp(os.path.splitext(x)[1].lower(),os.path.splitext(y)[1].lower()))
		elif self.sort_by_reverse.get_active():
			return sorted(filelist,cmp=lambda x,y:cmp(os.path.basename(x).lower(),os.path.basename(y).lower()),reverse=True)
		elif self.sort_by_random.get_active():
			return filelist
			
	def Conta_Foto(self,event):
		self.list=[]
		self.total_size=0
		files=glob.glob(self.cartella+'/*')
		for item in files:
                        format=os.path.splitext(item)[1]
			if string.lower(format) in self.formats:  self.list.append(item)
			elif string.lower(format) in self.raw_formats:  self.list.append(item)
			self.total_size+=os.path.getsize(item)
		return len(self.list)

	def Make_Table(self,event):
                if self.scrolledwindow6: self.scrolledwindow6.destroy()
		while gtk.events_pending(): gtk.main_iteration(False)
                self.rect2=self.scrolledwindow2.get_allocation()
                self.n_columns=(self.rect2.width-20)/(self.width+20)
		self.rows=int(math.ceil(self.n/float(self.n_columns)))
		self.table=gtk.Table(self.rows,self.n_columns,False)
		self.table.set_row_spacings(20)
		self.table.set_col_spacings(20)
		self.table.set_border_width(20)
		self.eb.add(self.table)
		self.eb.modify_bg(gtk.STATE_NORMAL,self.colorbutton1.get_color())
		self.scrolledwindow2.add_with_viewport(self.eb)
		self.table.show()
		
	def Attach_Images(self,event):
		n=0
		self.image=range(self.n)
		self.e=range(self.n)
		self.event=range(self.n)
		for i in range(self.n):
			self.image[i]=gtk.Image()
			self.event[n] = gtk.EventBox()
			self.event[n].add(self.image[i])
			self.event[n].add_events(gtk.gdk.BUTTON_PRESS_MASK)
 			self.event[n].connect("button_press_event", self.Select_Foto)
			self.event[n].modify_bg(gtk.STATE_NORMAL,self.gallery_color)
			n+=1
		if self.rows>1:
			n=0
			for y in range(self.n/self.n_columns):
				for x in range(self.n_columns):
					self.vbox=gtk.VBox()
					self.e[n] = gtk.EventBox()
 					self.e[n].add_events(gtk.gdk.BUTTON_PRESS_MASK)
 					self.e[n].connect("button_press_event", self.Select_Foto)
					self.e[n].modify_bg(gtk.STATE_NORMAL,self.gallery_color)
					self.table.attach(self.vbox,x,x+1,y,y+1,xoptions=0,yoptions=0)
					self.vbox.pack_start(self.event[n],expand=True,fill=True)
					self.vbox.pack_start(self.e[n],expand=False,fill=False)
					n+=1
			resto=self.n%self.n_columns
			if resto>0:
				for x in range(resto):
					self.vbox=gtk.VBox()
					self.e[n] = gtk.EventBox()
 					self.e[n].add_events(gtk.gdk.BUTTON_PRESS_MASK)
 					self.e[n].connect("button_press_event", self.Select_Foto)
					self.e[n].modify_bg(gtk.STATE_NORMAL,self.gallery_color)
					self.table.attach(self.vbox,x,x+1,y+1,y+2,xoptions=0,yoptions=0)
					self.vbox.pack_start(self.event[n],expand=True,fill=True)
					self.vbox.pack_start(self.e[n],expand=False,fill=False)
					n+=1
		else:
			for x in range(self.n):
				self.vbox=gtk.VBox()
				self.e[x] = gtk.EventBox()
 				self.e[x].add_events(gtk.gdk.BUTTON_PRESS_MASK)
 				self.e[x].connect("button_press_event", self.Select_Foto)
				self.e[x].modify_bg(gtk.STATE_NORMAL,self.gallery_color)
				self.table.attach(self.vbox,x,x+1,0,1,xoptions=0,yoptions=0)
				self.vbox.pack_start(self.event[x])
				self.vbox.pack_start(self.e[x],expand=False,fill=False)

        def Make_Thumbnails(self,width,height):
		self.radiobutton6.set_active(True)
		self.settings['radiobutton6']=True
		self.settings['radiobutton7']=False
		self.Toolbuttons(self,False,True)    
		self.b_pixlist=range(3)
		gc.collect()
		while gtk.events_pending(): gtk.main_iteration(False)
		self.progressbar3.show()        
		self.button5.show()             
                self.treeview1.handler_block(self.id3)
                self.Open1.handler_block(self.id4)
		self.toolbutton16.handler_block(self.id1)
		self.toolbutton17.handler_block(self.id2)
		self.open_folder1.handler_block(self.id5)
		self.open_album1.handler_block(self.id6)
		self.treeview2.handler_block(self.id7)
		self.toolbutton1.handler_block(self.id8)
		self.toolbutton14.handler_block(self.id9)
		self.toolbutton15.handler_block(self.id10)
		self.toolbutton18.handler_block(self.id11)
		self.toolbutton19.handler_block(self.id12)
		self.toolbutton20.handler_block(self.id13)
		self.toolbutton21.handler_block(self.id19)
		self.toolbutton26.handler_block(self.id23)
		self.toolbutton27.handler_block(self.id24)
		self.toolbutton28.handler_block(self.id39)
		self.toolbutton29.handler_block(self.id26)
		self.toolbutton30.handler_block(self.id30)
		self.hpaned1.handler_block(self.id28)
		self.new1.handler_block(self.id14)
		self.delete2.handler_block(self.id15)
		self.add_selection1.handler_block(self.id16)
		self.delete_selection1.handler_block(self.id17)
		i=0
		fraction=0.99/self.n
		self.label=range(self.n)
		self.list=self.Sort(self.list)
		for infile in self.list:   	
			try:
				infile=self.Get_Filename(infile,i)
				preview=os.path.splitext(os.path.basename(infile))[0]+'.png'
				if self.checkbutton7.get_active():
                                        if preview not in self.cache_list:
                                                pixbuf = gtk.gdk.pixbuf_new_from_file_at_size(infile,260,174)
                                                pixbuf.save(self.cache+preview,"png")
                                        pixbuf = gtk.gdk.pixbuf_new_from_file_at_size(self.cache+preview,width,height)
                                else:
                                        if preview in self.cache_list:
                                                pixbuf = gtk.gdk.pixbuf_new_from_file_at_size(self.cache+preview,width,height)
                                        else:   pixbuf = gtk.gdk.pixbuf_new_from_file_at_size(infile,width,height)
                                new_pixbuf=self.Add_Border(pixbuf,self.border_color,False)
				self.image[i].set_from_pixbuf(new_pixbuf)       
				self.label[i].modify_fg(gtk.STATE_NORMAL,self.label_color)
				self.label[i].modify_font(self.font_desc)
				self.e[i].add(self.label[i])
				self.window1.show_all()
				i+=1
				del pixbuf, new_pixbuf
				gc.collect()
				self.progressbar3.set_fraction(self.progressbar3.get_fraction()+fraction)
				while gtk.events_pending(): gtk.main_iteration(False)
				if self.stop_thumb==1: break
			except gobject.GError :
				print 'error loading image'
                                self.image[i].set_from_stock(gtk.STOCK_MISSING_IMAGE,5)
                                self.e[i].add(self.label[i])
                                i+=1
                                self.window1.show_all()
       		self.progressbar3.set_fraction(0)
       		self.treeview1.handler_unblock(self.id3)
                self.Open1.handler_unblock(self.id4)
		self.toolbutton16.handler_unblock(self.id1)
		self.toolbutton17.handler_unblock(self.id2)
		self.open_folder1.handler_unblock(self.id5)
		self.open_album1.handler_unblock(self.id6)
		self.treeview2.handler_unblock(self.id7)
		self.toolbutton1.handler_unblock(self.id8)
		self.toolbutton14.handler_unblock(self.id9)
		self.toolbutton15.handler_unblock(self.id10)
		self.toolbutton18.handler_unblock(self.id11)
		self.toolbutton19.handler_unblock(self.id12)
		self.toolbutton20.handler_unblock(self.id13)
		self.toolbutton21.handler_unblock(self.id19)
		self.toolbutton26.handler_unblock(self.id23)
		self.toolbutton27.handler_unblock(self.id24)
		self.toolbutton28.handler_unblock(self.id39)
		self.toolbutton29.handler_unblock(self.id26)
		self.hpaned1.handler_unblock(self.id28)
		self.toolbutton30.handler_unblock(self.id30)
		self.new1.handler_unblock(self.id14)
		self.delete2.handler_unblock(self.id15)
		self.add_selection1.handler_unblock(self.id16)
		self.delete_selection1.handler_unblock(self.id17)
		self.stop_thumb=0
		self.progressbar3.hide()
		self.button5.hide()
		self.cache_list=os.listdir(self.cache)
		thread.start_new_thread(self.Cache_Control,())
		
	def Make_Bottom_Panel(self,event):
		if self.radiobutton7.get_active() and self.vpaned2.get_child2():
			self.vpaned2.handler_block(self.id27)	
			self.hpaned1.set_position(int(gtk.gdk.screen_width()*0.15))
			self.vpaned2.handler_unblock(self.id27)
			return True	
		if self.radiobutton6.get_active() and not self.close_panel:
			self.hpaned1.set_position(int(gtk.gdk.screen_width()*0.15))
			self.close_panel=False
			while gtk.events_pending(): gtk.main_iteration(False)
		elif self.radiobutton6.get_active() and self.close_panel:
			self.hpaned1.set_position(0)
			self.close_panel=False
			while gtk.events_pending(): gtk.main_iteration(False)		
		self.radiobutton7.set_active(True)
		self.settings['radiobutton7']=True
		self.settings['radiobutton6']=False
		self.Toolbuttons(self,True,False)
		self.toolbutton1.handler_block(self.id8)
		self.toolbutton14.handler_block(self.id9)
		self.toolbutton15.handler_block(self.id10)
		self.toolbutton16.handler_block(self.id1)
		self.toolbutton17.handler_block(self.id2)
		self.toolbutton21.handler_block(self.id19)
		self.toolbutton26.handler_block(self.id23)
		self.toolbutton27.handler_block(self.id24)
		self.toolbutton28.handler_block(self.id39)
		self.toolbutton29.handler_block(self.id26)
		self.toolbutton30.handler_block(self.id30)
		self.toolbutton31.handler_block(self.id31)
		self.toolbutton32.handler_block(self.id32)
		self.toolbutton33.handler_block(self.id33)
		self.toolbutton34.handler_block(self.id34)
                self.vpaned2.handler_block(self.id27)
		self.hpaned1.handler_block(self.id28)
                self.progressbar3.show()
		self.button5.show()
                viewport=self.scrolledwindow2.get_child()
                if viewport: viewport.destroy()
                self.vbox1=gtk.VBox(False,0)
                self.swin2_image=gtk.Image()
                self.swin2_label=gtk.Label()
		self.swin2_label.modify_fg(gtk.STATE_NORMAL,self.label_color)
		self.swin2_label.modify_font(self.font_desc)
                self.vbox1.pack_start(self.swin2_image,True,True,0)
                self.vbox1.pack_start(self.swin2_label,False,False,0)
                self.scrolledwindow2.add_with_viewport(self.vbox1)
                if self.n:
			self.scrolledwindow2.get_child().modify_bg(gtk.STATE_NORMAL,self.nero)
		else:   self.scrolledwindow2.get_child().modify_bg(gtk.STATE_NORMAL,self.gallery_color)
		self.rect=self.scrolledwindow2.allocation
		self.scrolledwindow2.set_size_request(-1,self.rect.height-self.height+30)
                self.eventbox9=gtk.EventBox()
		self.eventbox9.set_size_request(-1,self.height+30)
		self.eventbox9.modify_bg(gtk.STATE_NORMAL,self.gallery_color)
		self.eventbox9.add_events(gtk.gdk.SCROLL_MASK)
		self.eventbox9.connect("scroll_event",self.Scroll_Bottom_Panel)
                self.scrolledwindow6=gtk.ScrolledWindow()
                self.hbox1=gtk.HBox(False,0)
		self.eventbox9.add(self.hbox1)
                self.scrolledwindow6.set_policy(gtk.POLICY_ALWAYS,gtk.POLICY_NEVER)
                self.scrolledwindow6.add_with_viewport(self.eventbox9)
                self.vpaned2.pack2(self.scrolledwindow6,False,False)
		self.vpaned2.set_position(int(gtk.gdk.screen_height())-self.height+30)
                self.b_img=range(self.n)
                self.b_event=range(self.n)
                self.label=range(self.n)
                for i in range(self.n):
			self.b_img[i]=gtk.Image()
			self.b_event[i] = gtk.EventBox()
			self.b_event[i].modify_bg(gtk.STATE_NORMAL,self.gallery_color)
			self.b_event[i].add_events(gtk.gdk.BUTTON_PRESS_MASK)
 			self.b_event[i].connect("button_press_event", self.Select_b_foto)
			self.b_event[i].add(self.b_img[i])
			self.hbox1.pack_start(self.b_event[i],True,True,0)
		self.window1.show_all()
		while gtk.events_pending(): gtk.main_iteration(False)
		if self.n:
			self.b_event[0].modify_bg(gtk.STATE_NORMAL,self.selection_color)
			fraction=0.99/self.n
		self.window1.show_all()
		i=0
		self.indice=0
		self.pixindex=1
		self.b_pixlist=range(3)
		self.list=self.Sort(self.list)
		for infile in self.list:
                        try:
                                infile=self.Get_Filename(infile,i)
                                preview=os.path.splitext(os.path.basename(infile))[0]+'.png'
                                if self.checkbutton7.get_active():
                                        if preview not in self.cache_list:
						pixbuf = gtk.gdk.pixbuf_new_from_file_at_size(infile,260,174)
                                                pixbuf.save(self.cache+preview,"png")
					pixbuf = gtk.gdk.pixbuf_new_from_file_at_size(self.cache+preview,self.width,self.height)
				else:
                                        if preview in self.cache_list:
                                                pixbuf = gtk.gdk.pixbuf_new_from_file_at_size(self.cache+preview,self.width,self.height)
                                        else:   pixbuf = gtk.gdk.pixbuf_new_from_file_at_size(infile,self.width,self.height)
				new_pixbuf=self.Add_Border(pixbuf,self.border_color,False)
				self.b_event[i].set_size_request(new_pixbuf.get_width()+20,self.height+30)
                                self.b_img[i].set_from_pixbuf(new_pixbuf)
                                if i==0:
					self.swin2_label.set_text(self.label[0].get_text())
					while gtk.events_pending(): gtk.main_iteration(False)
					self.rect2=self.scrolledwindow2.get_allocation()
					self.b_pixlist[self.pixindex]=gtk.gdk.pixbuf_new_from_file_at_size(infile,\
                        		self.rect2.width,self.rect2.height-self.swin2_label.allocation.height)
					format=os.path.splitext(infile)[1]
					self.b_pixlist[self.pixindex]=self.Check_Icons(format,self.b_pixlist[self.pixindex])
					self.swin2_image.set_from_pixbuf(self.b_pixlist[self.pixindex])
					while gtk.events_pending(): gtk.main_iteration(False)
				if i==1:
					thread.start_new_thread(self.Load_b_Cache,(self.rect2.width,self.rect2.height))
                                self.window1.show_all()
                                i+=1
                                del pixbuf, new_pixbuf
                                gc.collect()
                                self.progressbar3.set_fraction(self.progressbar3.get_fraction()+fraction)
                                while gtk.events_pending(): gtk.main_iteration(False)
                                if self.stop_thumb==1: break     
			except gobject.GError :
				print 'error loading image'
                                self.b_img[i].set_from_stock(gtk.STOCK_MISSING_IMAGE,5)
                                i+=1
                                self.window1.show_all()
                self.stop_thumb=0
		self.progressbar3.hide()
                self.progressbar3.set_fraction(0)
		self.button5.hide()
		self.toolbutton1.handler_unblock(self.id8)
		self.toolbutton14.handler_unblock(self.id9)
		self.toolbutton15.handler_unblock(self.id10)
		self.toolbutton16.handler_unblock(self.id1)
		self.toolbutton17.handler_unblock(self.id2)
		self.toolbutton21.handler_unblock(self.id19)
		self.toolbutton26.handler_unblock(self.id23)
		self.toolbutton27.handler_unblock(self.id24)
		self.toolbutton28.handler_unblock(self.id39)
		self.toolbutton29.handler_unblock(self.id26)
		self.toolbutton30.handler_unblock(self.id30)
		self.toolbutton31.handler_unblock(self.id31)
		self.toolbutton32.handler_unblock(self.id32)
		self.toolbutton33.handler_unblock(self.id33)
		self.toolbutton34.handler_unblock(self.id34)
		self.vpaned2.handler_unblock(self.id27)
		self.hpaned1.handler_unblock(self.id28)
		self.oldlist=self.list[:]
		self.cache_list=os.listdir(self.cache)
		thread.start_new_thread(self.Cache_Control,())
		
	def Add_Border(self,pixbuf,border_color,data):
		if not self.checkbutton4.get_active() and not data: return pixbuf
                pwidth = pixbuf.get_width()
		pheight = pixbuf.get_height()
		if border_color==0x00000000:
			new_pixbuf=self.background.copy().scale_simple(pwidth+2, pheight+2,gtk.gdk.INTERP_BILINEAR)
			if pixbuf.get_has_alpha():
				new_pixbuf=new_pixbuf.add_alpha(False,chr(0),chr(0),chr(0))
			pixbuf.copy_area(0,0,pwidth,pheight,new_pixbuf,1,1)
		else:
			new_pixbuf = gtk.gdk.Pixbuf(gtk.gdk.COLORSPACE_RGB, True, 8, pwidth+2, pheight+2)
			new_pixbuf.fill(border_color)
			pixbuf.copy_area(0, 0, pwidth, pheight,new_pixbuf, 1, 1)
		return new_pixbuf

	def Get_Filename(self,infile,i):
                format=os.path.splitext(infile)[1]
                if self.ark in infile:
                        if string.lower(format) in self.raw_formats:
				f=string.replace(os.path.split(infile)[1],'.thumb.jpg','')
                                self.label[i]=gtk.Label(f)
                                infile=os.path.splitext(infile)[0]
                        else: self.label[i]=gtk.Label(os.path.split(infile)[1])
                elif self.ark not in infile and string.lower(format) in self.raw_formats and self.temp not in infile:
                        infile=self.Make_Raw(infile,format,i)
		else: self.label[i]=gtk.Label(os.path.split(infile)[1])
                if self.temp in infile:
                        f=string.replace(os.path.split(infile)[1],'.thumb.jpg','')		
                        self.label[i]=gtk.Label(f)
                        infile=os.path.splitext(infile)[0]
                return infile
		
	def Cache_Control(self):
		filelist=glob.glob(self.cache+'*')
		total_size=0
		for item in filelist: total_size+=os.path.getsize(item)
		if total_size/1000000.0>self.cache_size:
			dict={}
			for item in filelist: dict[os.stat(item)[7]]=item
			lista=sorted(dict)
			for item in dict:
				if item==lista[0]:
					os.remove(dict[item])
					break
		 	self.Cache_Control()
		else:
			self.progressbar1.set_fraction((total_size/1000000.0)/self.cache_size)
			return True
	
	def Clear_Cache(self,event):
		self.dialog8.show()
		response=self.dialog8.run()
		if response==gtk.RESPONSE_CANCEL or response==gtk.RESPONSE_DELETE_EVENT:
			self.dialog8.hide()
			self.Options(self)
		elif response==gtk.RESPONSE_OK:
			self.dialog8.hide()
			self.progressbar1.set_fraction(0)
			self.Options(self)
			thread.start_new_thread(self.Delete_Cached,())
			
	def Delete_Cached(self):
		for item in os.listdir(self.cache): os.remove(self.cache+item)
							
	def main(self):
		gtk.main()
		
	def Close_Window2(self,obj):
		self.on_delete_event(self.window2,obj)
		
	def on_delete_event(self,obj,event):
		self.loop=0
		obj.hide()
                if obj==self.window2 and self.radiobutton7.get_active():
			indice=self.old_indice
                        self.indice=indice
			del self.pblist
			del self.fullpblist
			gc.collect()
                        self.pblist=range(3)
                        self.fullpblist=range(3)
			gc.collect()
		if obj==self.window4 and self.window2.get_property("visible"):
                        indice=self.win2_indice
                        self.indice=indice
			if self.checkbutton6.get_active() and self.pid:
				os.kill(self.pid,9)
				os.wait()
                elif obj==self.window4 and not self.window2.get_property("visible"):
                        indice=self.old_indice
                        self.indice=indice
			if self.checkbutton6.get_active() and self.pid:
				os.kill(self.pid,9)
				os.wait()
		self.pid=self.count=0		
		return True

	def on_delete_window3(self,obj,event):
                if self.window2.get_property("visible"):
                        while gtk.events_pending(): gtk.main_iteration(False)
                        format=os.path.splitext(self.list[self.indice])[1]
                        self.Set_Image1(format)
                        self.window2.show_all()
                        if self.settings['checkbutton1']: self.frame1.hide_all()	
                        while gtk.events_pending(): gtk.main_iteration(False)
                        self.Add_Dimensions(format,self._label)
                        obj.hide()
                        del self.fullpblist
                        gc.collect()
                        self.fullpblist=range(3)
                        while gtk.events_pending(): gtk.main_iteration(False)
                        thread.start_new_thread(self.Load_Cache,(self.rect.width,self.rect.height,None))
                else:
                        obj.hide()
                        del self.fullpblist
                        gc.collect()
                        self.fullpblist=range(3)
                        indice=self.old_indice
                        self.indice=indice
                        while gtk.events_pending(): gtk.main_iteration(False)
		
	def Hide_win6(self,obj,event):
		self.window6.hide()
		self.Stop_thread.set()
		self.Unselect(self)
		return True
		
	def destroy(self, *widget):
                fl=open('settings','w')
                cPickle.dump(self.settings,fl)
                fl.close()
		f=open(self.ark+'albums.db','w')
                cPickle.dump(self.albums,f)
                f.close()
                for item in os.listdir('.thumbnails'): os.remove('.thumbnails/'+item)
                for item in os.listdir('.raw'):
			os.remove('.raw/'+item)		
			while gtk.events_pending(): gtk.main_iteration(False)
                gtk.main_quit()	

if __name__ == "__main__":
	gtkrawgallery=Gallery()
	gtkrawgallery.main()
